1998-08-19  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* Version 20.3 released.

	* language/romanian.el ("Romanian"): Specify the tutorial file.

1998-08-18  Per Starbäck  <starback@update.uu.se>

	* language/european.el (setup-latin2-environment): Fix typo.
	(iso-latin-1): Doc fix.

1998-08-18  Eric Ludlam  <zappo@mescaline.gnu.org>

	* speedbar.el (speedbar-timer-fn): Disable updating if the frame
	is an icon, or if the user is using the minibuffer.
	(speedbar-key-map): Added Q binding to destroy the frame.
	(speedbar-easymenu-definition-trailer): Added Quit item.
	(speedbar-frame-mode): Set the frame position at creation time.
	(speedbar-file-unshown-regexp): Added .# lock files.

1998-08-18  Kenichi Handa  <handa@etl.go.jp>

	* language/cyrillic.el (cyrillic-koi8): Fix the value of
	`valid-code' property.
	(cyrillic-alternativnyj): Likewise.
	(cyrillic-alternativnyj-encode-table): Fix the initial value.

	* language/vietnamese.el (vietnamese-viscii): Fix the value of
	`valid-code' property.
	(vietnamese-vscii): Likewise.

1998-08-18  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* subr.el (read-quoted-char): Don't bind input-method-function;
	instead, pass the new args to read-event.

	* isearch.el (search-whitespace-regexp): Doc fix.

	* ange-ftp.el (ange-ftp-file-name-sans-versions): Don't return
	the shortened version of the file name.

1998-08-18  Kenichi Handa  <handa@etl.go.jp>

	* language/european.el: Give proper value of `input-method' key to
	all lang. env.

	* international/mule-cmds.el (activate-input-method): Handle the
	case that the arg INPUT-METHOD is nil correctly.
	(read-multilingual-string): Activate the specified input method
	before calling read-string.  Afterward, activate the original
	input method.

1998-08-17  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* midnight.el (midnight-hook): Initialize to a list.

1998-08-17  Kenichi Handa  <handa@etl.go.jp>

	* international/mule-cmds.el (set-language-environment): Reset
	syntax and case table to the defaults if the value of
	unibyte-syntax key is nil.

1998-08-16  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* mail/rmailout.el (rmail-output): Always preserve MIME-Version field,
	even if it was pruned.

1998-08-15  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* info.el (Info-follow-reference): Nice error msg if there was no arg.

1998-08-14  Michael Ernst  <mernst@alum.mit.edu>

	* comint.el (comint-postoutput-scroll-to-bottom): Cope with unset
	comint-last-output-start marker.

1998-08-15  Kenichi HANDA  <handa@etl.go.jp>

	* international/kkc.el (kkc-help): New function.
	(kkc-keymap): Use sparse keymap.  Add key binding for kkc-help.

	* international/mule.el (set-selection-coding-system): Make it
	interactive.
	(last-next-selection-coding-system): New variable.
	(set-next-selection-coding-system): New function.

	* international/mule-cmds.el (language-info-alist): Doc-string
	modified.
	(set-language-info-alist): Fix typo in doc-string.  Update
	setup-language-environment-map unconditionally.
	(mule-keymap): Key bindings for set-selection-coding-system and
	set-next-selection-coding-system.
	(set-coding-system-map): Add items of set-selection-coding-system
	and set-next-selection-coding-system.

	* language/hebrew.el ("Hebrew"): Delete describe-function key.

1998-08-14  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* mail/sendmail.el (sendmail-send-it): Report invalid values
	of mail-from-style.

	* info.el (Info-try-follow-nearest-node): Get the node name
	directly out of the menu item pointed at.

	* which-func.el (which-func-modes): Add fortran-mode.

	* ediff-util.el (ediff-next-difference, ediff-previous-difference):
	Handle nil as arg.

1998-08-14  Andreas Schwab  <schwab@issan.informatik.uni-dortmund.de>

	* international/mule-cmds.el (select-safe-coding-system): If
	default-coding-system is no-conversion return that, it is always
	safe.

1998-08-13  Eric Ludlam  <zappo@mescaline.gnu.org>

	* speedbar.el (speedbar-frame-parameters): Removed scroll-bar-width.

1998-08-13  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* loadup.el: Add informative message about the lists of GC stats.

	* dired-aux.el (dired-do-rename-regexp): Doc fix.

	* midnight.el (midnight-float-time): Renamed from float-time.
	(midnight-time-float): Renamed from time-float.
	(midnight-buffer-display-time): Renamed from buffer-display-time.
	(midnight-mode): Specify :initialize.  Use nil as default value.

	* complete.el (PC-do-completion): Exclude ./ and ../ from completion.

1998-08-12  Lars Magne Ingebrigtsen  <larsi@gnus.org>

	* gnus/nntp.el (nntp-encode-text): Properly encode outgoing text by
	putting CR at the end of all lines.

1998-08-12  Michael Ernst  <mernst@alum.mit.edu>

	* emacs-lisp/cust-print.el (custom-prin1-to-string): Doc fix.

1998-08-12  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* ebuff-menu.el (electric-buffer-menu-mode-map):
	Don't wipe out all Meta keys.

	* calendar/appt.el (appt-mode-string): New variable.
	(global-mode-string): Add appt-mode-string to it.
	(appt-check): Avoid using display-time-string to fetch current time.
	To display in mode line, use appt-mode-string.

1998-08-12  Per Abrahamsen  <abraham@dina.kvl.dk>

	* double.el (double-setup): Only copy `key-translation-map' if it
	is a keymap.

1998-08-11  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* files.el (recover-session): Add leading space on added text lines.

	* calendar/appt.el: Use a separate timer, not display-time-hook.
	(appt-timer): New variable.
	(appt-interval): New user option.
	(appt-disp-window): Start by erasing the buffer.

	* faces.el (list-faces-display): Call print-help-return-message.
	(describe-face): Likewise.

	* emacs-lisp/disass.el (disassemble-1): Move the call to
	string-as-unibyte outside of the if statement.

1998-08-10  Bob Glickstein  <bobg@hiro.zanshin.com>

	* sendmail.el (mail-setup): After using `fill-region-as-paragraph'
	on a new address field, ensure that it ends with a newline.

1998-08-10  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* time-stamp.el (time-stamp-string-preprocess): Add %U code.

	* international/quail.el (quail-update-leim-list-file):
	Fix message syntax.

	* mail/sendmail.el (mail-citation-header): New variable.
	(mail-yank-original, mail-yank-region): Bind mail-citation-header.
	(mail-citation-hook): Doc fix.

1998-08-09  Kenichi HANDA  <handa@etl.go.jp>

	* international/mule-conf.el (iso-safe): Comment for this coding
	system fixed.
	(coding-category-iso-8-1): Change default coding priority.

	* international/mule-cmds.el (language-info-alist): Doc-string
	modified.
	(reset-language-environment): New function for the job that
	setup-english-environment used to do.
	(set-language-environment): Do more setups according to the info
	in language-info-alist.
	(read-language-name): Handle the case that the arg KEY is nil.
	(describe-language-environment): Handle input-method property.

	* international/quail.el (quail-start-translation): If
	enable-multibyte-characters is nil, convert multibyte character to
	unibyte.
	(quail-start-conversion): Likewise.

	* language/: All files under this directory modified as below.
	(setup-XXX-environment): Just call set-language-environment.  If
	they used to do some other jobs than what done by
	set-language-environment, those jobs are done in
	setup-XXX-environment-internal now.
	("LANGUAGE-ENVIRONMENT"): Delete property setup-function or change
	the value to setup-XXX-environment-internal.  Add properties
	nonascii-translation, input-method, features, unibyte-syntax, and
	unibyte-display.

	* language/english.el (setup-english-environment): Just call
	reset-language-environment.

	* language/european.el (setup-8-bit-environment): Function deleted.

1998-08-09  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* emacs-lisp/sregex.el (sregex-replace-match):
	Don't call sregex--value-groups.
	(sregex-match-end, sregex-match-beginning): Likewise.
	(sregex-match-string-no-properties, sregex-match-string): Likewise.

	* help.el (describe-function-1): Handle macros properly.
	Handle multiple levels of aliases.

	* emacs-lisp/cust-print.el (custom-prin1-to-string): Add NOESCAPE arg.

1998-08-09  Sam Steingold  <sds@goems.com>

	* midnight.el (clean-buffer-list-kill-buffer-names): Add `*diff*'.
	(clean-buffer-list): Check `buffer-modified-p' only when the
	buffer is associated with a file.
	(midnight-delay-set): Improve doc.

1998-08-09  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* progmodes/compile.el (next-error): Doc fix.
	(grep): Doc fix.

	* loadup.el: Load byte-run and format a little earlier.

1998-08-08  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* textmodes/flyspell.el: Don't require font-lock.

	* textmodes/flyspell.el (flyspell-command-hook): Option deleted.
	(flyspell-mode-on): Delete code to handle flyspell-command-hook.
	(flyspell-mode-off): Likewise.
	(flyspell-mark-duplications-flag): Doc fix.
	(flyspell-duplicate-distance): Doc fix.
	(flyspell-duplicate-face): Doc fix.

	* subr.el (assoc-default): Rewrite not to use dolist.
	(add-hook): Use byte-code-function-p, not compiled-function-p.

	* hilit-chg.el: New file.
	Delete the undo-in-progress compatibility code.

	* mail/rmailmsc.el (set-rmail-inbox-list):
	Error if not in Rmail mode.

	* textmodes/paragraphs.el (forward-paragraph):
	Fix the logic for handling beginning of buffer
	in the "no fill-prefix" case.

	* info.el: Bind case-fold-search to t in many functions.

	* mail/mail-utils.el (mail-fetch-field): Doc fix.

1998-08-08  Eric M. Ludlam  <zappo@ultranet.com>

	* speedbar.el (speedbar-edit-line, speedbar-buffer-kill-buffer)
	(speedbar-buffer-revert-buffer): Updated buffer finding regex to
	handle the [?] tag.
	(speedbar-find-selected-file): New function.
	(speedbar-clear-current-file): Uses `speedbar-find-selected-file'.
	(speedbar-update-current-file): Uses `speedbar-find-selected-file',
	and now `speedbar-last-selected-file' is defined as the path name
	to the file, not just the file itself.

1998-08-08  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* international/mule-cmds.el (input-method-exit-on-first-char)
	(input-method-use-echo-area): Doc fixes.

	* vc-hooks.el (vc-file-not-found-hook): Call vc-file-clearprops.

1998-08-07  Lars Magne Ingebrigtsen  <larsi@gnus.org>

	* gnus/gnus-start.el (gnus-startup-file-coding-system): New variable.
	(gnus-read-init-file, gnus-read-newsrc-el-file): Use that.

1998-08-07  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* wid-edit.el (widget-beginning-of-line): Properly handle
	multiline fields.  Don't use call-interactively.
	(widget-end-of-line): Likewise.

	* midnight.el (midnight-delay-set): Use run-hooks directly.
	(midnight-timer-function): Function deleted.
	(midnight-find): Don't use `find'.

	* startup.el (command-line): Require whitespace delimiter when
	searching locale-translation-file-name.

	* midnight.el (midnight-timer-function):
	No need to test midnight-mode.

	* repeat.el (repeat): Make an undo boundary between repetitions.

1998-08-06  Kenichi Handa  <handa@etl.go.jp>

	* international/isearch-x.el
	(isearch-process-search-multibyte-characters): Fix previous change.

	* international/quail.el (quail-update-translation): Delete the
	code for handling the case that enable-multibyte-characters is nil.

1998-08-06  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* window.el (split-window-horizontally): Doc fix.

1998-08-06  Kenichi Handa  <handa@etl.go.jp>

	* emacs-lisp/debug.el
	(debugger-outer-unread-post-input-method-events): New variable.
	(debug): Bind debugger-outer-unread-post-input-method-events.
	Bind unread-post-input-method-events to nil.
	(debugger-env-macro): Likewise.

	* international/isearch-x.el (isearch-minibuffer-local-map):
	Bind the key C-g to exit.
	(isearch-minibuffer-self-insert): Use key-binding.
	Always call exit-minibuffer.
	(isearch-process-search-multibyte-characters):
	Use unread-command-events instead of unread-input-method-events.
	Always call isearch-update.

	* international/kkc.el (kkc-region): Don't bind echo-keystrokes.

	* international/mule-cmds.el (input-method-exit-on-first-char):
	New variable.
	(input-method-use-echo-area): New variable.

	* international/quail.el (quail-translation-keymap): Declare it as
	variable instead of constant.  Bind all keys less than 32 to
	quail-other-command.  Don't bind the key meta-prefix-char and escape.
	(quail-simple-translation-keymap): Likewise.
	(quail-conversion-keymap): Bind C-h to quail-translation-keymap.
	(quail-define-package): Fix typo in doc-string.
	(quail-conversion-str): New variable.
	(quail-input-method): Bind buffer-undo-list to t.
	Show Quail guidance buffer if necessary.
	(quail-delete-region): Move the definition before the first
	calling place.
	(quail-start-translation): Handle the case the arg KEY is nil.
	Bind echo-keystrokes and help-char.  Initialize quail-current-str
	to "".  If input-method-use-echo-area is non-nil, call
	read-key-sequence with appropriate PROMPT arg.  Setup
	last-command-event by local variable `keyseq'.  Generate an event
	list form quail-current-str.  If input-method-exit-on-first-char
	is non-nil, return only the first event.
	(quail-start-conversion): Likewise.  Initialize
	quail-conversion-str to "".  Generate an event list form
	quail-conversion-str.
	(quail-update-translation): Expect that the function given by
	(quail-update-translation-function) returns a new control-flag.
	Handle the case the length of quail-current-key is 1.  Use
	string-as-unibyte if enable-multibyte-characters is nil.  Always
	assures that quail-current-str is Lisp string.
	(quail-self-insert-command): Use `or' instead of `unless'.
	(quail-update-current-translations): Always assures that
	quail-current-str is Lisp string.
	(quail-next-translation-block): Update unread-command-events correctly.
	(quail-abort-translation): Set quail-current-str to nil.
	(quail-conversion-delete-char): Update quail-conversion-str.
	(quail-conversion-delete-tail): Likewise.
	(quail-conversion-backward-delete-char): Likewise.
	(quail-show-guidance-buf): Show Quail guidance buffer not in echo
	area if input-method-use-echo-area is non-nil.
	(quail-show-translations): Bind current-translations locally to
	quail-current-translations to get this value across different
	buffers.  Handle the case that the length quail-current-key is 0.
	(quail-translation-help): If this command is invoked repeatedly,
	scroll the already shown help window.  Handle the case that this
	command is called while converting (not translating).
	(quail-conversion-help): This function deleted and the
	functionality is merged to quail-translation-help.

1998-08-05  Dave Love  <fx@gnu.org>

	* iso-cvt.el (iso-spanish, iso-german, iso-iso2tex, iso-tex2iso)
	(iso-gtex2iso, iso-iso2gtex, iso-iso2duden): Add optional, ignored
	arg `buffer' for format-{de,en}code.  Doc fix.  Add * to
	interactive spec.  Add autoload cookie.
	(iso-cvt-read-only, iso-cvt-write-only): Add doc, autoload cookie.
	(iso-cvt-define-menu): Add autoload cookie.

1998-08-05  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* gnus/message.el: Require sendmail.
	(message-fill-yanked-message): Use mail-citation-prefix-regexp
	as an arg to fill-individual-paragraphs.

	* emacs-lisp/bytecomp.el (byte-compile-from-buffer):
	Make the output buffer multibyte.

	* scroll-bar.el (scroll-bar-mode): Doc fix.

1998-08-05  Sam Steingold  <sds@goems.com>

	* emacs-lisp/cl-indent.el (top-level let): Add defsubst.

1998-08-04  Andrew Innes  <andrewi@harlequin.co.uk>

	* mail/rmail.el (rmail-encoded-pop-password): New variable.

1998-08-04  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* textmodes/flyspell.el (flyspell-persistent-highlight): Doc fix.

1998-08-04  Eric Ludlam  <zappo@mescaline.gnu.org>

	* speedbar.el (speedbar-refresh): Removed special code to remove
	the speedbar update message.  Not necessary here.
	(speedbar-timer-fn): Add code to remove the updating message and
	thus restore the minibuffer.
	(speedbar-center-buffer-smartly): Fixed center error to handle
	the whole buffer.
	(speedbar-delete-subblock): Rewrote to be more robust, less clever.
	(speedbar-timer-fn): Removed short display time for messages.

1998-08-04  Dave Love  <d.love@dl.ac.uk>

	* vc.el (vc-backend-merge-news): Account for `already contains the
	differences' state.

1998-08-04  Eli Zaretskii  <eliz@delysid.gnu.org>

	* international/mule.el (find-new-buffer-file-coding-system): When
	inhibit-eol-conversion is non-nil and the buffer didn't already
	set a fully-qualified coding system, force -unix eol-type.

1998-08-04  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* info.el (Info-find-node): Once again, use byte-to-position.

	* vcursor.el (vcursor group): Move this to `editing' group.

	* comint.el (comint-bol-or-process-mark): Refer to this command's
	name correctly.

	* international/mule-cmds.el (set-default-coding-systems):
	In --unibyte mode, don't set default-file-name-coding-system.

	* midnight.el (clean-buffer-list-kill-regexps): Init to nil, as before.
	(clean-buffer-list-kill-buffer-names): Add *vc* and *vc-diff*.
	(clean-buffer-list-delay): Rename arg.
	(clean-buffer-list): Doc fix.
	(midnight-period): Doc fix.

1998-08-03  Eric Ludlam  <zappo@mescaline.gnu.org>

	* info.el (Info-speedbar-hierarchy-buttons): Improved the speedbar
	frame management.

	* speedbar.el (speedbar-update-current-file): Added call to
	`speedbar-center-buffer-smartly' to improve the display.
	(speedbar-center-buffer-smartly) Fixed off-by-one error in window
	height calculation.
	(speedbar-hack-buffer-menu): New function.
	(speedbar-frame-parameters): Removed scroll bar width.
	(speedbar-frame-mode): Change pointer shape for X
	and W32 window-systems only.  When window-system is pc, bind the
	speedbar frame name to "Speedbar", and select that frame so it is
	displayed.
	(speedbar-mode): Don't bind default-minibuffer-frame when
	window-system is pc.
	(speedbar-this-file-in-vc): Look for RCS/name as well as RCS/name,v.
	(speedbar-directory-buttons-follow): Support both upper- and
	lower-case drive letters.  Use directory-sep-char instead of a
	literal backslash.
	(speedbar-reconfigure-keymaps): Call
	`easy-menu-remove' before reconfiguring for a new menu bar.
	(speedbar-previous-menu): New Variable.
	(speedbar-frame-plist): Remove pointers.
	(speedbar-refresh): Prevent the mark from being deactivated.
	(speedbar-buffer-kill-buffer): Refresh speedbar after killing a
	buffer in the buffer display.

1998-08-03  Simon Marshall  <simon@gnu.org>

	* font-lock.el (lisp-font-lock-keywords-1): Fix previous change.
	(font-lock-support-mode): Allow nil as a mode-specific value.  Fix tag.

1998-08-01  Kenichi HANDA  <handa@etl.go.jp>

	* international/kkc.el (kkc-lookup-cache): Initialize it to nil.
	(kkc-lookup-cache-tag): New constant.
	(kkc-lookup-key): If kkc-lookup-cache is nil, initialize it.  Use
	kkc-init-file-name.
	(kkc-region): Fix previous change.  Call kkc-error on error.
	(kkc-shorter-conversion, kkc-longer-phrase): New functions.
	(kkc-keymap): Bind them to "I" and "O" respectively.
	(kkc-error): New error symbol and new function.
	(kkc-longer, kkc-shorter): Call kkc-error on error.
	(kkc-show-conversion-list-or-next-group): Likewise.
	(kkc-show-conversion-list-or-prev-group): Likewise.

	* international/mule-cmds.el (language-info-alist): Doc-string
	modified.
	(set-language-environment): Setup nonascii-translation-table and
	charset-origin-alist according to the property of the specified
	language environment.
	(update-iso-coding-systems): Make it an alias for
	update-coding-systems-internal.
	(prefer-coding-system): Call update-coding-systems-internal
	instead of update-iso-coding-systems.
	(set-language-environment-coding-systems): Likewise.

	* international/mule-conf.el: Initialize coding-category-ccl to
	nil.  Include it in the arg for set-coding-priority.

	* international/mule-diag.el (describe-current-coding-system):
	Check if each coding category is bound to a valid coding system.

	* international/mule.el (make-coding-system): If the arg TYPE is
	4, set coding-category property of the coding system to
	coding-category-ccl.
	(find-new-buffer-file-coding-system): If the arg CODING carries
	some information (about text conversion or eol conversion), always
	return a new coding system.
	(charset-origin-alist): New variable.
	(make-translation-table-from-vector): New function.

	* international/quail.el (quail-start-translation): Bind help-char
	to nil locally.

	* language/cyril-util.el (cyrillic-encode-koi8-r-char): New function.
	(cyrillic-encode-alternativnyj-char): New function.

	* language/cyrillic.el (cyrillic-koi8-r-decode-table): New
	variable.
	(cyrillic-koi8-r-encode-table): Likewise.
	(ccl-decode-koi8): Use cyrillic-koi8-r-decode-table.
	(ccl-encode-koi8): Use cyrillic-koi8-r-encode-table.
	(ccl-encode-koi8-font): Likewise.
	(cyrillic-koi8-r-nonascii-translation-table): New variable.
	("Cyrillic-KOI8"): Add nonascii-translation-table and
	charset-origin-alist properties.
	(cyrillic-alternativnyj-decode-table): New variable.
	(cyrillic-alternativnyj-encode-table): Likewise.
	(ccl-decode-alternativnyj): Use
	cyrillic-alternativnyj-decode-table.
	(ccl-encode-alternativnyj): Use
	cyrillic-alternativnyj-encode-table.
	(ccl-encode-alternativnyj-font): Likewise.
	(cyrillic-alternativnyj-nonascii-translation-table): New variable.
	("Cyrillic-ALT"): Add nonascii-translation-table and
	charset-origin-alist properties.

	* language/viet-util.el (viet-encode-viscii-char): New function.

	* language/vietnamese.el (viet-viscii-decode-table): Docstring fixed.
	(viet-viscii-encode-table): Likewise.
	(viet-vscii-decode-table): Likewise.
	(viet-vscii-encode-table): Likewise.
	(viet-viscii-nonascii-translation-table): New variable.
	("Vietnamese"): Add nonascii-translation-table and
	charset-origin-alist properties.

	* loadup.el: Call update-coding-systems-internal instead of
	update-iso-coding-systems.

	* simple.el (what-cursor-position): Check charset-origin-alist.

1998-08-01  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* mail/mailheader.el (mail-header-format): Convert string to symbol.

	* double.el (default-key-translation-map): Variable deleted.
	(double-setup): Make key-translation-map buffer-local here.
	New arg ENABLE-FLAG.
	(double-mode): Pass ENABLE-FLAG arg to double-setup.

1998-07-31  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* subr.el (assoc-default): New function.

	* midnight.el: Require timer.
	(clean-buffer-list-kill-regexps): Match `*vc' buffers.
	(midnight-find): Use dolist, not loop.
	(clean-buffer-list-delay): Use assoc-default.

	* info.el (Info-find-node): Position at the beginning of the node
	after calling Info-select-node.

	* info.el (Info-insert-dir): Catch errors in insert-file-contents.

1998-07-30  Sam Steingold  <sds@goems.com>

	* font-lock.el (lisp-font-lock-keywords-1): Fontify `defconstant'
	and `defparameter'.
	(lisp-font-lock-keywords-2): Fontify `lambda', `in-package'
	and `locally'.

	* emacs-lisp/cl-indent.el (lisp-indent-defun-method): New variable.
	(common-lisp-indent-function): Use it.
	(lisp-indent-259): Uncomment the `&lambda' code.
	(top-level let): Remove duplicate `catch' and `block'.  Use
	`&lambda' when appropriate.  Now the lambda lists are indented
	appropriately.

1998-07-30  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* dired.el (dired-garbage-files-regexp): Finish fixing regexp syntax.

	* mail/sendmail.el (mail-yank-region):
	Bind mark-even-if-inactive to t.
	(mail-yank-original was similarly changed, a few versions ago.)

	* textmodes/flyspell.el (flyspell-duplicate-distance):
	Doc fix; change default to 10000.
	(flyspell-mode-on): Fix the welcome message to deal with
	how the binding for flyspell-auto-correct-word is now made.
	(flyspell-delay, flyspell-delayed-commands): Doc fixes.
	(flyspell-mode-off): Kill Ispell only if it is per-buffer.

1998-07-30  Ken'ichi Handa  <handa@delysid.gnu.org>

	* international/mule-cmds.el (activate-input-method): Update mode line.
	(inactivate-input-method): Likewise.

1998-07-29  Kenichi Handa  <handa@etl.go.jp>

	* mouse.el (mouse-skip-word): If point is at word constituent
	characters, pay attention to word-separating-categories by using
	forward-word instead of skip-syntax-forward/backward.

1998-07-29  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* help.el (describe-function-1): Fix the code that uses
	find-function-noselect.

	* emacs-lisp/find-func.el (find-function-noselect): Autoload cookie.
	(find-function-search-for-symbol): Ignore directories
	when looking for a library file.

1998-07-29  Dave Love  <d.love@dl.ac.uk>

	* files.el (auto-mode-alist): Escape dots in some regexps.

1998-07-29  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* files.el (auto-mode-alist): Fix previous change.

	* textmodes/tex-mode.el (tex-main-file): Doc fix.

	* dired.el (dired-garbage-files-regexp): Fix typo.

	* emulation/crisp.el (crisp-mark-line): Greatly simplified.

	* mouse.el (mouse-delete-window): If the frame has just one window,
	bury the current buffer instead.

1998-07-28  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* textmodes/flyspell.el (flyspell-mode-map): Explicitly bind M-TAB.
	(flyspell-auto-correct-binding): Variable deleted.
	(flyspell-incorrect-face, flyspell-duplicate-face): Fix typos.
	(flyspell-check-pre-word-p): Check for word syntax in previous char.
	(flyspell-word): Set process-kill-without-query for Ispell.
	(flyspell-region): Put region args in order; use right percentage.
	(flyspell-properties-at-p): Rename arg to POS; doc fix.
	(flyspell-highlight-incorrect-region):
	Check flyspell-highlight-properties first.
	(flyspell-highlight-duplicate-region): Likewise.
	(flyspell-auto-correct-word): Doc fix.

	* international/iso-transl.el (iso-transl-define-keys): Don't test
	enable-multibyte-characters; use the translated characters as
	specified in alist.

	* double.el (key-translation-map):
	Don't call make-variable-buffer-local on this variable.

	* mail/rmail.el (rmail-dont-reply-to-names): Doc fix.

1998-07-27  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* textmodes/flyspell.el (flyspell-emacs-popup):
	Renamed from flyspell-gnuemacs-popup.  Callers changed.
	(push): Macro deleted.  Callers changed to do it explicitly.
	(flyspell-incorrect-face, flyspell-duplicate-face): Use defface.
	(flyspell-incorrect-color): Variable deleted.
	(flyspell-duplicate-color): Variable deleted.
	(flyspell-underline-p): Variable deleted.
	(flyspell-font-lock-make-face): Function deleted.
	(flyspell-mark-duplications-flag):
	Renamed from flyspell-doublon-as-error-flag.
	(flyspell-mode-on): Delete the debugging message.
	(flyspell-mode-off): Delete the debugging message.
	(flyspell-mode-on): Set flyspell-generic-check-word-p
	from the flyspell-mode-predicate property.
	(texinfo-mode, mail-mode, message-mode):
	Set flyspell-mode-predicate property.

	* international/mule.el (set-clipboard-coding-system): Define as alias.

1998-07-26  Ken'ichi Handa  <handa@melange.gnu.org>

	* arc-mode.el (archive-set-buffer-as-visiting-file): Give FILENAME
	arg to set-auto-coding-function.
	(archive-extract): Pay attention to enable-multibyte-characters.
	(archive-*-write-file-member): Likewise.
	(archive-rename-entry): Likewise.

1998-07-26  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* international/mule.el (auto-coding-alist): Recognize .tar.

1998-07-26  Ken'ichi Handa  <handa@melange.gnu.org>

	* files.el (auto-mode-alist): Fix regular expression error for
	sh-mode.

1998-07-26  Ken'ichi HANDA  <handa@etl.go.jp>

	* arc-mode.el (archive-summarize): Set buffer unibyte before
	calling archive-XXX-summarize.
	(archive-file-name-handler): New function to make the caller
	behave as if the extracted file existed.
	(archive-set-buffer-as-visiting-file): New function to simulate
	file visiting.  Uses archive-file-name-handler to make dos-w32
	systems preserve the coding-system of the extracted files.
	(archive-extract): Bind coding-system-for-write to
	file-name-coding-system, coding-system-for-read to 'no-conversion.
	Call archive-set-buffer-as-visiting-file after a member file is
	inserted in the current buffer.
	(archive-extract-by-stdout): Don't bind coding-system-for-read and
	inherit-process-coding-system.
	(archive-*-write-file-member): Give an encoded file name to
	external archive program.
	(archive-rename-entry): Likewise.
	(archive-mode-revert): Set buffer unibyte before calling
	revert-buffer.
	(archive-arc-rename-entry, archive-zip-chmod-entry): Set buffer
	unibyte before handling binary archive data.
	(archive-lzh-rename-entry, archive-lzh-ogm, archive-zip-chmod-entry):
	Likewise.
	(archive-lzh-summarize): Set local variable efnname to the decoded
	file name.  If default-enable-multibyte-characters is non-nil, set
	buffer multibyte before inserting summary lines.

1998-07-25  Dan Nicolaescu  <done@ece.arizona.edu>

	* files.el (auto-mode-alist): Move nroff-modes down the list.

1998-07-25  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* international/mule.el (auto-coding-alist): Another doc fix.

1998-07-25  Ken'ichi Handa  <handa@melange.gnu.org>

	* international/mule.el (auto-coding-alist): Docstring fixed.

	* ange-ftp.el (ange-ftp-re-read-dir): Quote ange-ftp-reread-dir in
	autoload cookie.

1998-07-24  Edward M. Reingold  <reingold@emr.cs.uiuc.edu>

	* calendar/cal-tex.el (cal-tex-latexify-list):
	Ignore specifier in diary entry.

1998-07-24  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* mail/sendmail.el (mail-mode): Add the citation regexp
	to adaptive-fill-regexp after the usual contents.
	But modify the usual contents not to match whitespace alone;
	match that again last.
	Add that citation regexp to paragraph-start and paragraph-separate too.

1998-07-24  Ken'ichi Handa  <handa@melange.gnu.org>

	* tar-mode.el (tar-extract): Give set-auto-coding-function
	FILENAME argument.

1998-07-25  Kenichi Handa  <handa@etl.go.jp>

	* international/mule.el (auto-coding-alist): New variable.
	(set-auto-coding): Argument FILENAME is added.  Check
	auto-coding-alist at first.

	* international/kkc.el (kkc-region): Unwind-protect the conversion
	process.
	(kkc-show-conversion-list-update): Pay attention to the length of
	kkc-show-conversion-list-index-chars.

	* international/mule-cmds.el (find-multibyte-characters): New
	function.
	(select-safe-coding-system): Highlight characters which can't be
	encoded.  Show list of such characters also in *Warning* buffer.

	* international/mule-util.el
	(coding-system-change-eol-conversion): Make it accepts an integer
	value in EOL-TYPE argument.

1998-07-24  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* uniquify.el (uniquify-ignore-buffers-re): Fix custom type.

	* emulation/crisp.el: Don't require cl.
	(crisp-override-meta-x): Doc fix.
	(crisp-last-last-command): Doc fix.
	(mark-something): Function deleted.
	(crisp-mark-line): Avoid using mark-something.
	(crisp-region-active): Renamed from region-active.
	(crisp-set-clipboard): Renamed from copy-primary-selection.
	(crisp-kill-region): Renamed from kill-primary-selection.
	(crisp-yank-clipboard): Renamed from yank-clipboard-selection.

	* files.el (basic-save-buffer-2): New function.
	(basic-save-buffer-1): Use basic-save-buffer-2,
	after perhaps binding coding-system-for-write.
	(save-buffer-coding-system): Make it a permanent local.

1998-07-24  Dan Nicolaescu  <done@ece.arizona.edu>

	* files.el (auto-mode-alist): Add idl-mode.

1998-07-23  Jonathan I. Kamens  <jik@kamens.brookline.ma.us>

	* mail/rmail.el (rmail-insert-inbox-text): Use rmail-have-password,
	rmail-get-pop-password and rmail-set-pop-password.
	(rmail-have-password, rmail-get-pop-password)
	(rmail-set-pop-password): New functions.
	(rmail-encode-string): New function.

1998-07-23  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* files.el (auto-mode-alist): Recognize shell profiles without dirname.

1998-07-23  Ken'ichi Handa  <handa@melange.gnu.org>

	* international/quail.el (quail-start-translation): Call
	this-single-command-raw-keys instead of this-single-command-keys.
	(quail-start-conversion): Likewise.

1998-07-23  Kenichi Handa  <handa@etl.go.jp>

	* international/isearch-x.el (isearch-minibuffer-self-insert):
	Handle space char event correctly.
	(isearch-process-search-multibyte-characters): If this-command is
	not isearch-printing-char, don't read multibyte chars from
	minibuffer, but just call isearch-process-search-char.

	* international/quail.el (quail-start-translation): Use
	this-single-command-keys to get raw events instead of
	listify-key-sequence.
	(quail-start-conversion): Likewise.

1998-07-22  Karl Heuer  <kwzh@gnu.org>

	* mail/feedmail.el: Avoid using all-caps for non-arguments.
	(feedmail-queue-send-edit-prompt-help-first): Doc fix.

1998-07-21  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* imenu.el (imenu-create-index-function): Add autoload cookie.
	(imenu-extract-index-name-function, imenu-default-goto-function)
	(imenu-sort-function, imenu-prev-index-position-function): Likewise.

	* ange-ftp.el (ange-ftp-reread-dir): Renamed from `re-read'.
	Old name defined as alias.  Doc fix.

1998-07-21  Kenichi Handa  <handa@etl.go.jp>

	* international/kkc.el (kkc-region): Handled the case that
	conversion is canceled.
	(kkc-terminate): Update kkc-overlay-head correctly.
	(kkc-cancel): Don't call kkc-terminate, but set kkc-converting to nil.

	* international/quail.el (quail-simple-translation-keymap): Typo
	in doc-string fixed.
	(quail-start-translation): Check start position of quail-overlay
	before calling quail-overlay-region-events.
	(quail-start-conversion): Likewise.

1998-07-20  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* files.el (auto-mode-alist): Match .emacs with no directory.

1998-07-19  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* progmodes/compile.el (grep): Doc fix.
	(next-error): Doc fix.

	* progmodes/sh-script.el (sh-mode): parse-sexp-ignore-comments = t.

1998-07-19  Eli Zaretskii  <eliz@delysid.gnu.org>

	* arc-mode.el (archive-mode): Undo previous change.
	(archive-extract): Make the buffer unibyte if the extracted file
	was read with coding-system of no-conversion or raw-text.

1998-07-19  Kenichi Handa  <handa@etl.go.jp>

	* isearch.el (isearch-input-method-function): New variable.
	(isearch-input-method-local-p): New variable.
	(isearch-mode): Setup the above two variable.  Set
	input-method-function to nil locally.
	(isearch-done): Restore the previous value of
	input-method-function.

	* international/quail.el (quail-conversion-keymap): New binding
	for quail-conversion-delete-tail.
	(quail-input-method): Suppress input method if
	overriding-terminal-local-map or overriding-local-map is non-nil.
	Erase contents of quail-guidance-buf.  Run the hook
	input-method-after-insert-chunk-hook.
	(quail-start-translation): Get the original event list by
	listify-key-sequence.  Setup last-command and this-command.
	(quail-start-conversion): Likewise.
	(quail-conversion-beginning-of-region): Set quail-translating to nil.
	(quail-conversion-end-of-region, quail-conversion-delete-char):
	Likewise.
	(quail-conversion-delete-tail): New function.
	(quail-no-conversion): Don' run the hook
	input-method-after-insert-chunk-hook.

	* international/kkc.el (kkc-region): Fix the return value.

	* international/isearch-x.el
	(isearch-toggle-specified-input-method): Adjusted for the change
	in isearch.el.
	(isearch-toggle-input-method): Likewise.
	(isearch-minibuffer-local-map): New variable.
	(isearch-minibuffer-non-self-insert): New function.
	(isearch-minibuffer-self-insert): New function.
	(isearch-process-search-multibyte-characters): Read multibyte
	characters from minibuffer with the keymap
	isearch-minibuffer-local-map.

	* international/mule-cmds.el (read-multilingual-string): Don't
	activate an input method in the current buffer, but just bind
	current-input-method.

	* language/japan-util.el (japanese-replace-region): New function.
	(japanese-katakana-region, japanese-hiragana-region)
	(japanese-hankaku-region, japanese-zenkaku-region): Don't change
	point.  Use japanese-replace-region to change text.

1998-07-18  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* ange-ftp.el (ange-ftp-re-read-dir): Add doc string.

1998-07-17  Simon Marshall  <simon@gnu.org>

	* lazy-lock.el (lazy-lock-fontify-after-visage): Renamed from
	lazy-lock-fontify-after-outline.
	(lazy-lock-install-hooks): Add it to hs-hide-hook too.
	(lazy-lock-unstall): Remove it from hs-hide-hook too.
	(lazy-lock-fontify-rest-after-change)
	(lazy-lock-defer-rest-after-change): Ensure properties are always
	removed from the rest of the buffer by widening during removal.

1998-07-17  Stephen Eglen  <stephen@gnu.org>

	* forms.el (forms-mode): Doc fix.

1998-07-17  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* arc-mode.el (archive-mode): Make the buffer unibyte.

1998-07-16  Eli Zaretskii  <eliz@is.elta.co.il>

	* arc-mode.el (archive-extract): If the extractor signals an
	error, trap it, so that the buffer created for a member is killed.

1998-07-15  Kenichi Handa  <handa@etl.go.jp>

	* international/kkc.el (kkc-show-conversion-list-index-chars):
	Default value changed.
	(kkc-keymap): Renamed from kkc-mode-map.  Key binding for
	kkc-non-kkc-command are deleted.
	(kkc-mode): This function deleted.
	(kkc-canceled): This variable deleted.
	(kkc-converting): New variable.
	(kkc-region): 3rd optional arg is deleted.  Completely rewritten
	to adjust for the change in quail.el.
	(kkc-terminate, kkc-cancel): Adjusted for the change of
	kkc-region.
	(kkc-non-kkc-command): This function deleted.
	(kkc-select-from-list): Use last-input-event instead of
	last-input-char.  Put an unknown event back to
	unread-input-method-events.

	* international/quail.el (quail-mode): This variable deleted.
	(quail-current-key): Make it buffer local.
	(quail-current-str, quail-current-translations): Likewise.
	(quail-reset-conversion-region): This variable deleted.
	(quail-use-package): Call quail-activate at the tail.
	(quail-translation-keymap, quail-simple-translation-keymap): Key
	bindings for quail-execute-non-quail-command deleted.
	(quail-conversion-keymap): Likewise.  Add key bindings for
	quail-self-insert-command.
	(quail-delete-overlays): Check overlay-start for overlays before
	deleting them.
	(quail-mode): This function deleted.
	(quail-inactivate, quail-activate): New functions.
	(quail-saved-current-map, quail-saved-current-buffer): These
	variables deleted.
	(quail-toggle-mode-temporarily, quail-execute-non-quail-command):
	These functions deleted.
	(quail-exit-conversion-mode, quail-prefix-arg): These variables
	deleted.
	(quail-error): New error condition.
	(quail-error): New function.
	(quail-translating, quail-converting): New variables.
	(quail-input-method, quail-overlay-region-events): New function.
	(quail-start-translation): Completely re-written.
	(quail-start-translation-in-conversion-mode): This function
	deleted.
	(quail-start-conversion): New function.
	(quail-terminate-translation): Just set quail-translating to nil.
	(quail-update-translation): Put some events back to
	unread-input-method-events instead of unread-command-events.  Call
	quail-error instead of error.
	(quail-self-insert-command): Adjusted for the change of
	quail-start-translation.
	(quail-next-translation): Don't call
	quail-execute-non-quail-command, instead, put an event back of
	unread-command-events.
	(quail-prev-translation, quail-next-translation-block)
	(quail-prev-translation-block): Likewise.
	(quail-conversion-backward-char): Call quail-error instead of
	error.  Set quail-translating to nil.
	(quail-conversion-forward-char): Likewise.
	(quail-conversion-delete-char): Call quail-error instead of error.
	If conversion region gets vacant, set quail-converting to nil.
	(quail-conversion-backward-delete-char): Likewise.
	(quail-no-conversion): Just set quail-converting to nil.
	(quail-mouse-choose-completion): Call quai-error instead of error.
	(quail-choose-completion-string): Likewise.
	(quail-help): Don't handle quail-mode-map.

	* language/ethiopic.el ("Ethiopic"): Typo in sample-text fixed.

1998-07-15  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* textmodes/sgml-mode.el (sgml-mode): Call kill-local-variables
	here directly, then set major-mode, then call sgml-mode-common.
	Run the hooks here at the end.
	(html-mode): Likewise.
	(sgml-mode-common): Don't call kill-local-variables; don't run hooks.

1998-07-15  Eli Zaretskii  <eliz@mescaline.gnu.org>

	* files.el (file-name-invalid-regexp): Fix the part which handles
	colons in file names.

1998-07-14  Gary D. Foster  <gfoster@suzieq.ml.org>

	* emulation/crisp.el:
	Added next-buffer/previous-buffer keybindings (bound to M-n/M-p).
	(crisp-unbury-buffer): New function.

	Fixed bogus XEmacs/Lucid string-match checking.
	Made modeline entry mouse2-able.

	(crisp-mode-map): Make this a sparse keymap parented from
	current-global-map.
	(crisp-mode-original-keymap): Don't copy the keymap.
	(crisp-last-last-command): Renamed from last-last-command.  defvar it.
	(crisp-mode): Honor ARG.

	(crisp-kill-line, crisp-copy-line): When a region isn't highlighted,
	use the region from point to eol.  Honor prefix argument.

	(crisp-submit-bug-report): New command, taken from cc-mode.

	Shortened the version numbering, removed the release-version tracking.

	(crisp-version): New function.
	New keybindings `C-home', `C-end', `M-home', `M-end', `C-f', `M-l',
	`M-m'.

	(crisp-copy-line): No need to save point.

	Removed S-right and S-left bindings.

	Abstract the marking and selection interfaces so that we can be
	compatible with both Emacs and XEmacs.  And try and make the
	behavior as close as possible under both environments so that there
	are no surprises.

1998-07-14  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* info.el (Info-read-node-name-1, Info-read-node-name):
	Rename completion-table to Info-read-node-completion-table.
	(Info-read-node-completion-table): Add defvar.
	(Info-complete-menu-buffer): Add defvar.

	* subr.el (read-quoted-char): Bind input-method-function to nil.

	* simple.el (do-auto-fill): Always break before any whitespace
	so that point ends up at the right place.

1998-07-13  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* rmailedit.el (rmail-edit-current-message, rmail-cease-edit):
	Save and restore save-buffer-coding-system in another local variable.

1998-07-13  Andrew Innes  <andrewi@delysid.gnu.org>

	* ps-print.el (ps-do-despool): Bind ps-printer-name to
	printer-name if the former is nil.

1998-07-12  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* mail/sendmail.el (mail-citation-prefix-regexp): New variable.
	(mail-fill-yanked-message): Pass mail-citation-prefix-regexp
	to fill-individual-paragraphs.

	* textmodes/fill.el (fill-individual-paragraphs-prefix): New
	subroutine taken from fill-individual-paragraphs.  Really check that
	JUST-ONE-LINE-PREFIX is longer than TWO-LINES-PREFIX in its whitespace.
	(fill-individual-paragraphs-citation): New subroutine.
	(fill-nonuniform-paragraphs): Arg MAILP renamed.
	(fill-individual-paragraphs): Arg MAILP renamed.

1998-07-12  Andrew Innes  <andrewi@delysid.gnu.org>

	* dos-w32.el (file-name-buffer-file-type-alist): Force tags files
	to be read as raw-text-dos (to handle files in DOS format).

1998-07-12  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* international/mule.el (set-selection-coding-system):
	Renamed from set-clipboard-coding-system.
	Set the variable's new name, selection-coding-system.

	* mail/rmailout.el (rmail-output-to-rmail-file):
	Clean up handling of relative file names in DEFAULT-FILE.

1998-07-10  Eric M. Ludlam  <zappo@ultranet.com>

	* speedbspec.el: Deleted; now integrated into speedbar.el.
	* speedbar.el: More commentary.
	(speedbar-xemacsp): Moved definition.
	(speedbar-initial-expansion-mode-list): Was
	`speedbar-initial-expansion-list' and now has multiple modes.
	(speedbar-stealthy-function-list): Now has mode labels.
	(speedbar-initial-expansion-list-name)
	(speedbar-previously-used-expansion-list-name)
	(speedbar-special-mode-key-map, speedbar-track-mouse-flag)
	(speedbar-tag-hierarchy-method, speedbar-tag-split-minimum-length)
	(speedbar-tag-regroup-maximum-length)
	(speedbar-hide-button-brackets-flag): New variables.
	(speedbar-special-mode-expansion-list): Updated documentation.
	(speedbar-navigating-speed, speedbar-update-speed): Phasing out.
	(speedbar-vc-indicator): Removed space from this var.
	(speedbar-indicator-separator, speedbar-obj-do-check)
	(speedbar-obj-to-do-point, speedbar-obj-indicator, speedbar-obj-alist)
	(speedbar-indicator-regex): New variables.
	(speedbar-directory-unshown-regexp): New variable.
	(speedbar-supported-extension-expressions): Added more extensions.
	(speedbar-add-supported-extension)
	(speedbar-add-ignored-path-regexp): Made interactive.
	(speedbar-update-flag): Nil w/ no window system.
	(speedbar-file-key-map): Moved some key bindings from
	`speedbar-key-map' to this map.
	(speedbar-make-specialized-keymap): New function.
	(speedbar-file-key-map): New key map.
	(speedbar-easymenu-definition-special): Updated to new functions.
	(speedbar-easymenu-definition-trailer): Changed conditional part.
	(speedbar-frame-mode): Removed commented code, fixed W32 cursor
	bug, Updated to better handle terminal frames.
	(speedbar-switch-buffer-attached-frame): New function.
	(speedbar-mode): Updated documentation, no local keymap,
	correct `temp-buffer-show-function' use, enable mouse-tracking.
	(speedbar-show-info-under-mouse): New function.
	(speedbar-reconfigure-keymaps): Was `speedbar-reconfigure-menubar'.
	Enable major display mode specific menus & key maps.
	(speedbar-temp-buffer-show-function): Fix use of `temp-buffer-show-hook'.
	(speedbar-track-mouse, speedbar-track-mouse-xemacs): New functions.
	(speedbar-restricted-move, speedbar-restricted-next)
	(speedbar-restricted-prev, speedbar-navigate-list)
	(speedbar-forward-list, speedbar-backward-list): New commands.
	(speedbar-refresh): Updated message printing & verbosity.
	(speedbar-item-load): Updated message.
	(speedbar-item-byte-compile): Updated doc & reset scanners.
	(speedbar-item-info): Overhauled with more details.
	(speedbar-item-copy): Update messages.
	(speedbar-generic-item-info): New function.
	(speedbar-item-delete): Update messages.
	(speedbar-item-object-delete): New function.
	(speedbar-select-window): Update doc.  Use `show-buffer'.
	(speedbar-make-button): Update doc.
	(speedbar-initial-expansion-list, speedbar-initial-menu)
	(speedbar-initial-keymap, speedbar-initial-stealthy-functions)
	(speedbar-add-expansion-list)
	(speedbar-change-initial-expansion-list): New functions.
	(speedbar-maybe-add-localized-support)
	(speedbar-add-localized-speedbar-support)
	(speedbar-remove-localized-speedbar-support): Imported from speedbspec.
	(speedbar-file-lists): Filter out some directories.
	(speedbar-make-tag-line): Can hide brackets.
	(speedbar-change-expand-button-char): Protect invisible text prop.
	(speedbar-insert-files-at-point): Ignore case during compares.
	(speedbar-apply-one-tag-hierarchy-method)
	(speedbar-create-tag-hierarchy): New functions.
	(speedbar-insert-generic-list): Now calls hierarchy functions on tags.
	(speedbar-update-contents): Handles localized support.
	(speedbar-update-directory-contents): Uses fn for expansion list.
	Fixed directory caching bug.
	(speedbar-timer-fn): Calls localized support function.
	(speedbar-stealthy-update-recurse): New variable.
	(speedbar-stealthy-updates): Handle new stealth function format.
	(speedbar-clear-current-file): Handle indicator regex.
	(speedbar-update-current-file): Ignores case, update handle
	indicator regex, Fix line positioning.
	(speedbar-add-indicator): Handles obj indicators now.
	(speedbar-check-objects, speedbar-check-obj-this-line): New functions.
	(speedbar-double-click): Fix triple click error.
	(speedbar-line-file, speedbar-goto-this-file): Handle indicator regex.
	(speedbar-line-path): Only try to get a file when in "files" display.
	(speedbar-line-depth): Handle indicator regex.
	(speedbar-dir-follow): Turn of smart-adjust to disable cache use.
	(speedbar-directory-buttons-follow): Hack for W32 emacs directories.
	(speedbar-buffers-key-map): New key map.
	(speedbar-buffer-easymenu-definition): New menu items.
	(speedbar-buffer-buttons, speedbar-buffer-buttons-temp)
	(speedbar-buffer-buttons-engine, speedbar-buffer-click)
	(speedbar-buffer-kill-buffer, speedbar-buffer-revert-buffer):
	New functions.

	* mail/rmail.el: No longer depends on speedbspec for byte compile.
	(rmail-speedbar-match-folder-regexp): New variable.
	(rmail-speedbar-menu-items): Updated speedbar menu items.
	(rmail-speedbar-key-map): New keymap.
	(rmail-install-speedbar-variables): New function.
	Install speedbar keymap only when speedbar is loaded.
	(rmail-speedbar-buttons): Use `rmail-speedbar-match-folder-regexp'.

	* info.el: No longer depends on speedbspec for byte compile.
	(Info-speedbar-key-map): New key map.
	(Info-install-speedbar-variables): New function.
	(Info-speedbar-menu-items): Update to new functions.
	Install speedbar keymap only when speedbar is loaded.
	(Info-speedbar-browser): New command.
	(Info-speedbar-hierarchy-buttons, Info-speedbar-goto-node)
	(Info-speedbar-expand-node, Info-speedbar-fetch-file-nodes): New fns.
	(Info-speedbar-buttons): Handle new node button commands.

	* gud.el (gud-speedbar-key-map): New variable.
	(gud-install-speedbar-variables): New function
	Install speedbar keymap only when speedbar is loaded.
	(gud-gdb-get-stackframe): Added ":" to regex for c++.

1998-07-09  Sam Steingold  <sds@usa.net>

	* emacs-lisp/cl-indent.el: Indent `handler-case' correctly.
	* font-lock.el (lisp-font-lock-keywords): Fontify
	`handler-case', `ccase', `ctypecase', `assert', `error'.

1998-07-09  Andrew Innes  <andrewi@harlequin.co.uk>

	* jka-compr.el (jka-compr-insert-file-contents): Replace incorrect
	inline code with call to find-operation-coding-system.

1998-07-09  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* simple.el (undo-in-progress): New variable.
	(undo-more): Bind it to t.

1998-07-08  Kenichi Handa  <handa@etl.go.jp>

	* international/fontset.el (x-complement-fontset-spec): Typo fixed.
	(create-fontset-from-fontset-spec): Likewise.
	(create-fontset-from-ascii-font): Likewise.

1998-07-08  Kenichi Handa  <handa@etl.go.jp>

	* language/hebrew.el ("Hebrew"): Add coding-priority.

	* language/misc-lang.el ("IPA"): Add coding-priority and coding-system.

1998-07-07  Kevin Rodgers  <kevinr@ihs.com>  (tiny change)

	* vc.el (vc-finish-logentry): Only delete windows in the
	selected frame displaying the *VC-log* buffer, in case another
	frame is dedicated to it (which will then be deleted via
	kill-buffer).

1998-07-07  Sam Steingold  <sds@goems.com>

	* scheme.el (scheme-font-lock-keywords-1): Fontify SCWM/Guile
	keywords starting with `define'.

1998-07-07  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* mail/rmail.el (rmail): If existing buffer, use local
	enable-multibyte-characters for rmail-enable-multibyte.
	(rmail-revert): Bind coding-system-for-read to raw-text,
	then convert and make buffer multibyte, as in `rmail'.

	* files.el (find-file-noselect-1): Use kill-local-variable on
	buffer-file-coding-system, instead of setting it.
	(save-buffer): Doc fix.
	(basic-save-buffer): Doc fix.

	* subr.el (add-hook): Use member if FUNCTION is a compiled function.

1998-07-06  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* textmodes/fill.el (fill-individual-paragraphs):
	Fix previous change.

	* textmodes/tex-mode.el (tex-delete-last-temp-files):
	Use file-name-sans-extensions.

1998-07-06  Kenichi Handa  <handa@etl.go.jp>

	* bindings.el: Make all multibyte characters self-insert.

	* isearch.el (isearch-mode-map): Make all multibyte characters
	search for themselves.

1998-07-05  Ken'ichi Handa  <handa@melange.gnu.org>

	* international/mule.el: Don't make the function charset-list
	obsolete.

1998-07-05  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* mail/mail-utils.el (rmail-dont-reply-to): Understand
	about doublequotes; don't be fooled by commas inside them.

1998-07-04  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* textmodes/fill.el (fill-individual-paragraphs):
	If JUST-ONE-LINE-PREFIX matches TWO-LINES-PREFIX except with
	longer whitespace, treat that as a match even is spaces
	are replaced with a tab.

1998-07-03  Michael Ernst  <mernst@alum.mit.edu>

	* dired-x.el (dired-omit-expunge): Message if skipping omitting
	because directory is too large; also unset dired-omit-files-p.
	(dired-omit-size-limit): Increase default from 20000 to 30000.

1998-07-03  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* international/mule-cmds.el (set-language-environment):
	Test unibyte-syntax instead of using a fixed list of
	latin-N character sets.

	* language/european.el: Define unibyte-syntax in each of these
	language environments.
	(setup-8-bit-environment): Let unibyte-syntax specify whether to
	load a file of syntax settings, and which one.

	* emacs-lisp/byte-opt.el (byte-boolean-vars):
	Add print-escape-multibyte.

	* progmodes/make-mode.el (makefile-font-lock-keywords):
	Recognize automatic variable references.
	(makefile-dependency-regex): Don't be fooled by colons in deps.

1998-07-03  Espen Skoglund  <espensk@stud.cs.uit.no>

	* pascal.el (pascal-insert-block): Fixed space-deletion bug in
	front of the "begin" string.
	(pascal-beg-of-defun): Used to locate the beginning of a function
	incorrectly when a function contained several begin-end blocks.
	Fixed.

1998-07-03  Dave Love  <d.love@dl.ac.uk>

	* calendar/diary-lib.el (diary-mail-addr): Fix custom type.

1998-07-03  Andrew Innes  <andrewi@harlequin.co.uk>

	* dos-fns.el (dos-print-region-function): Definition moved to
	dos-w32.el.
	(print-region-function): Initialization moved to dos-w32.el.
	(lpr-headers-switches, ps-lpr-command, ps-lpr-switches): Likewise.

	* dos-vars.el (dos-printer): Obsolete variable deleted.
	(dos-ps-printer): Likewise.

	* dos-w32.el (direct-print-region-function): Renamed from
	dos-print-region-function.  Added &rest keyword.
	(print-region-function): Set to direct-print-region-function.
	(lpr-headers-switches): Initialize.
	(ps-lpr-command): Initialize.
	(ps-lpr-switches): Initialize.

	* lpr.el (printer-name): New variable.
	(lpr-switches): Mention it in docstring.
	(print-region-1): Use it.

	* ps-print.el (ps-printer-name): New variable.
	(ps-do-despool): Use it.

1998-07-03  Robert J. Chassell  <bob@rattlesnake.com>

	* textmodes/texinfo.el (texinfo-environment-regexp):
	Add smalldisplay and smallformat.

	* info.el (Info-find-node): Handle cross references to an @anchor.

	* informat.el (Info-tagify): Finish previous change.
	Fix up some messages.

	* textmodes/texinfmt.el (texinfmt-version): Update version.
	number which is used in header of texinfmt-produced Info files.
	(texinfo-format-buffer): Now always tagify, on account of @anchor.
	(texi-format-region): Always tagify.
	(texi2info):          Always tagify.
	(texinfo-anchor):     Add @anchor command as place to which
	a cross reference may go.
	(texinfo-no-refill-regexp): Add smalldisplay, smallformat.
	(texinfo-format-uref):            New command: @uref.
	(texinfo-format-var):             New command: @acronym.
	(texinfo-format-code):            New commands: @command, @env, @url.
	(texinfo-format-option):          New command: @option.
	(texinfo-format-example):         New command: @smalldisplay.
	(texinfo-format-flushleft):       New command: @smallformat.
	(texinfo-discard-line-with-args): New commands: @novalidate, @pagesize,
	@setcontentsaftertitlepage, @setshortcontentsaftertitlepage.

1998-07-03  Eric Ludlam  <zappo@mescaline.gnu.org>

	* emacs-lisp/checkdoc.el (checkdoc): Updated commentary.
	(checkdoc-autofix-flag): Updated doc.
	(checkdoc-force-docstrings-flag): Updated doc.
	(checkdoc-force-history-flag): New flag.
	(checkdoc-triple-semi-comment-check-flag): Fixed name.
	(checkdoc-spellcheck-documentation-flag): Fixed doc.
	(checkdoc-ispell-lisp-words): Update default value.
	(checkdoc-generate-compile-warnings-flag, checkdoc-proper-noun-list)
	(checkdoc-proper-noun-regexp, checkdoc-symbol-words): New variables.
	(princ-list): Function created if it isn't bound.
	(checkdoc-interactive): Parts removed to `checkdoc-interactive-loop'.
	(checkdoc, checkdoc-message-interactive): New function.
	(checkdoc-interactive-loop): Was in `checkdoc-interactive', then
	added better keybindings, and better autofixing behavior,
	Cursor now sits next to the error, forcing scrolling if needed,
	and using a better centering algorithm, and much better error
	navigation after choosing "f"ix.
	(checkdoc-next-error): Added parameter ENABLE-FIX.
	(checkdoc-next-message-error, checkdoc-recursive-edit): New functions.
	(checkdoc-start): Was `checkdoc', uses new note taking system.
	(checkdoc-current-buffer, checkdoc-continue, checkdoc-comments):
	Updated to use new note taking system.
	(checkdoc-rogue-spaces, checkdoc-rogue-space-check-engine):
	Added INTERACT parameter, uses new warnings functions.
	(checkdoc-message-text, checkdoc-defun):
	Updated to use new note taking system.
	(checkdoc-ispell-current-buffer, checkdoc-ispell-interactive): Fix doc.
	(checkdoc-ispell-message-text, checkdoc-ispell-start): New function.
	(checkdoc-create-error, checkdoc-error-text, checkdoc-error-start)
	(checkdoc-error-end, checkdoc-error-unfixable): New functions.
	(checkdoc-minor-keymap): Updated keybinds to new interactive functions,
	completely re-arranged the minor-mode menu.
	(checkdoc-this-string-valid): Moved no doc-string warning here,
	and added autofix if a comment already exists there.
	(checkdoc-this-string-valid-engine): Fix doc, robusted doc finder.
	All previously returned errors now call `checkdoc-create-error'.
	Moved no doc string warning out.  Update allowed punctuation at
	end of first line.  Fixed up sentence joining.  Verb checking flag
	now only checks the first line of a function.  Added more safe
	conditions to ambiguous symbols.  Moved symbol quoting to end.
	Added autofix for variables that should end in `-flag'.
	Replaced use of `y-or-n-p' with `checkdoc-y-or-n-p'.
	Reading checkdoc-param comment no longer depends on list syntax.
	Fixed various error string spelling & format.
	(checkdoc-in-sample-code-p): List starting with all caps word is
	now considered sample code.
	(checkdoc-in-example-string-p, checkdoc-proper-noun-region-engine)
	(checkdoc-sentencespace-region-engine): New functions.
	(checkdoc-ispell-docstring-engine): Disable spell checking during
	if user never wants interaction.  We don't have a non-interactive
	spell checking method yet.
	(checkdoc-file-comments-engine): Now set up to check all possible
	conditions even after encountering an error.  Added auto-fixes
	for history and commentary.  All previously returned errors now call
	`checkdoc-create-error'.  Message spelling and format.
	(checkdoc-message-text-search):
	Moved parts to `checkdoc-message-text-next-string'.
	(checkdoc-message-text-next-string): New function.
	(checkdoc-message-text-engine): All previously returned errors
	now call `checkdoc-create-error'.  Can find/skip 'format' call
	after the call we are checking.  Added sentence/propernoun scans.
	`y-or-n-p' checks and fixes are now more robust.
	(checkdoc-y-or-n-p): New function.
	(checkdoc-autofix-ask-replace): Update doc.  Protect match-data.
	Correctly handle `checkdoc-autofix-flag' of 'never.  New behavior
	with `checkdoc-autofix-flag' of 'automatic-then-never.  Better
	overlay handling.
	(checkdoc-output-font-lock-keywords): Updated to new output format.
	(checkdoc-pending-errors): New variable.
	(checkdoc-find-error): Updated to new output format.
	(checkdoc-start-section, checkdoc-error): Improved the output.
	(checkdoc-show-diagnostics): Smarter show algorithm.

1998-07-03  Kenichi Handa  <handa@etl.go.jp>

	* faces.el (x-create-frame-with-faces): If an ASCII font is
	specified in PARAMETERS, create a fontset from the font and use it
	for the new frame.

	* international/fontset.el (create-fontset-from-fontset-spec):
	Returns a created fontset.
	(create-fontset-from-ascii-font): New function.

	* term/x-win.el: Fill weight and slant fields of a fontset
	generated from the specified ASCII font by values got from the
	resolved ASCII font name.

1998-07-02  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* emacs-lisp/bytecomp.el (byte-compile-file):
	Bind set-auto-coding-for-load to t.

	* international/mule.el (set-auto-coding-for-load): New variable.
	(set-auto-coding): If set-auto-coding-for-load is non-nil,
	look for `unibyte file variable first, then for `coding'.
	(load-with-code-conversion): Bind set-auto-coding-for-load to t.

	* cus-edit.el (customize-changed-options):
	Clean up previous change.

	* progmodes/cc-menus.el: Don't require imenu.

	* menu-bar.el (menu-bar-mode): Doc fix.

1998-07-02  Dave Love  <fx@gnu.org>

	* progmodes/fortran.el (fortran-mode-map) <menu>: Tweak the imenu
	menu entry.
	(end-of-fortran-subprogram): Check if we're on the END statement.

1998-07-02  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* textmodes/texinfmt.el (texinfo-anchor): New function.

	* informat.el (Info-tagify): Handle tags for @anchor.

	* menu-bar.el (menu-bar-kill-ring-save): Fix message typo.

1998-07-01  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* derived.el (derived-mode-hooks-name): Use -hook, not -hooks,
	in mode hook name.
	(derived-mode-hook-name): Renamed from ...-hooks; caller changed.

1998-07-01  Ken'ichi Handa  <handa@melange.gnu.org>

	* international/mule.el (mule-version): Changed to 4.0.
	(mule-version-date): Updated.

1998-06-30  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* menu-bar.el (menu-bar-edit-menu): Rename Paste most Recent
	to simply Paste, and put it above Select and Paste.

	* comint.el (comint-exec-1): Setup coding systems appropriately.

1998-06-29  Dirk Herrmann  <D.Herrmann@tu-bs.de>

	* bibtex.el (bibtex-hide-entry-bodies): When entry
	bodies are hidden, the last entry is no longer omitted.

1998-06-29  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* mail/supercite.el (sc-help-address): Use an alias at gnu.org.

1998-06-29  Stephen Eglen  <stephen@gnu.org>

	* calendar/diary-lib.el (diary-mail-entries): Call exit-calendar
	when finished.

1998-06-28  Peter Stephenson  <pws@ibmth.difi.unipi.it>

	* vcursor.el: Use defcustom to define faces.
	(vcursor-bind-keys): New function.
	(vcursor-key-bindings): Use vcursor-bind-keys for :set.
	(vcursor-cs-binding): Function to handle bindings,
	handles differences between Emacs and XEmacs.
	(vcursor-post-command): Handle vcursor-auto-disable non-nil
	and not t to toggle off copying.

1998-06-28  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* gnus/message.el (message-cite-original): If mail-citation-hook
	is non-nil, just run that and do nothing else.
	(message-cite-function): Don't initialize from mail-citation-hook.

	* mail/mh-utils.el (mh-find-progs): Avoid WTA error
	when mh-progs is nil.  Give a clear specific error message instead.

	* shell.el (shell-copy-environment-variable): Fix doc typo.

	* ffap.el (ffap-read-file-or-url):
	Bind minibuffer-completing-file-name to t.

	* informat.el (Info-split): Convert positions to bytes to put in file.
	(Info-tagify): Likewise.

	* info.el (Info-find-node): Use byte-to-position.

1998-06-28  Lars Magne Ingebrigtsen  <larsi@ifi.uio.no>

	* message.el (message-cite-function): Initialized from
	`mail-citation-hook', if that variable is bound and non-nil.

1998-06-28  Lars Magne Ingebrigtsen  <larsi@gnus.org>

	* ange-ftp.el (ange-ftp-send-cmd): When listing a directory that
	contains space(s), cd to the directory first to avoid problems
	with (some) ftp servers.

1998-06-27  Dan Nicolaescu  <done@ece.arizona.edu>

	* cus-dep.el: Fix typo.

1998-06-27  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* startup.el (command-line) <handling LANG>: Change 9 to 5, not 5 to 9.
	(command-line-1): Fix mouse startup message.

	* textmodes/text-mode.el (text-mode): Locally set indent-line-function.

	* find-dired.el (find-dired): Bind dired-buffers so it can't change.
	Use abbreviate-file-name.

	* imenu.el (imenu-space-replacement): Use `.'.

	* textmodes/sgml-mode.el (html-imenu-regexp): New defvar.
	(html-imenu-index): New function.
	(html-mode): Set up local vars to use html-imenu-index.
	Don't sort the menu.

	* international/mule.el (set-keyboard-coding-system): Doc typo.

1998-06-26  Michael Ernst  <mernst@alum.mit.edu>

	* sendmail.el (mail): Avoid changing auto-save file name.

1998-06-26  Dan Nicolaescu  <done@ece.arizona.edu>

	* textmodes/flyspell.el (flyspell): Add :version.

1998-06-26  Ken'ichi Handa  <handa@melange.gnu.org>

	* language/greek.el: Add coding-priority.

1998-06-26  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* mail/mailalias.el (mail-complete): Fix the test of (mail-header-end).

1998-06-26  Kenichi Handa  <handa@etl.go.jp>

	* international/fontset.el (create-fontset-from-fontset-spec):
	Generate ASCII font names of style variants fontsets from a
	resolved ASCII font name of a base fontset.

	* language/korea-util.el (isearch-toggle-korean-input-method)
	(isearch-hangul-switch-symbol-ksc, isearch-hangul-switch-hanja):
	New functions.
	(korean-key-bindings): Renamed from exit-korean-environment-data.
	Initialized appropriately.
	(setup-korean-environment): Setup key bindings according to
	korean-key-bindings.
	(exit-korean-environment): Revert key bindings only if the current
	key bindings is the same as what set by setup-korean-environment.

1998-06-25  Andrew Innes  <andrewi@harlequin.co.uk>

	* faces.el (set-face-font): For now, don't call
	resolve-fontset-name on Windows.
	(set-face-font-auto): Likewise.

1998-06-25  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* textmodes/flyspell.el: Delete defcustom definition.
	(flyspell-auto-correct-binding): Fix custom type.
	(mail-mode-flyspell-verify): Check for `Subject:'.
	(flyspell-mouse-map): Use cond, not if.
	(flyspell-region): Update message only every 100 actions.

1998-06-25  Jens-Ulrik Petersen  <petersen@kurims.kyoto-u.ac.jp>

	* find-func.el: Require `loadhist'.
	(find-function-function): Variable removed.
	(find-function-regexp): New variable, taken from former constant
	in `find-function-noselect'.  Can now find function definitions
	with parameters on a new line.
	(find-variable-regexp): New variable.
	(find-function-recenter-line): New variable.
	(find-function-after-hook): New variable.
	(find-function-search-for-symbol): Subroutine, from
	of `find-function-noselect'.
	(find-function-search-for-symbol): `regexp-quote' the symbol name:
	needed to find-function `mapcar*' for example.
	(find-function-noselect): Improved docstring.  Don't include
	`library' in let.
	Use `symbol-file' instead of `describe-symbol-find-file'.
	(find-function-read): Renamed from `find-function-read-function'.
	With optional arg now read a variable.
	(find-function-read): Separate `completing-read' calls for
	variables and functions.
	(find-function-do-it): If buffer found was already current push
	mark.  Added parameter to indicate if a variable is being searched for.
	(find-function-do-it): Mention new `find-function-recenter-line'
	and `find-function-after-hook' in docstring.  Use them.
	(find-function): Remove optional arg.  Use `find-function-do-it'
	and `find-function-read'.
	(find-function-other-window): Ditto.
	(find-function-other-frame): Ditto.
	(find-function): Mention `find-function-recenter-line' and
	`find-function-after-hook' in docstring.
	(find-function-other-window): Remove most of docstring and add
	reference to `find-function' instead.
	(find-function-other-frame): Ditto.
	(find-variable-noselect): New function for finding the point of
	definition of variables, modeled on `find-function-noselect'.
	(find-variable-noselect): Use `symbol-file' instead of
	`describe-symbol-find-file'.
	(find-variable): New function.
	(find-variable-other-window): Ditto.
	(find-variable-other-frame): Ditto.
	(find-variable): Mention `find-function-recenter-line' and
	`find-function-after-hook' in docstring.
	(find-variable-other-window): Remove most of docstring and add
	reference to `find-variable' instead.
	(find-variable-other-frame): Ditto.
	(find-function-on-key): Simplified.  Removed stuff now taken care
	of by interactive "k".
	(find-function-at-point): New function.
	(find-variable-at-point): Ditto.

1998-06-25  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* mail/rmail.el (mail-unsent-separator): Add new alternative.

1998-06-25  Karl Heuer  <kwzh@gnu.org>

	* mail/feedmail.el: Style and doc fixes.

1998-06-24  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* textmodes/flyspell.el: New file.

	* dabbrev.el (dabbrev-ignored-buffer-names):
	Fix typo.  Add *Buffer List*.

1998-06-24  Andrew Innes  <andrewi@mescaline.gnu.org>

	* dos-w32.el (null-device): Renamed from grep-null-device.

1998-06-24  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* custom.el (custom-set-default): New function.
	(custom-set-variables): Use custom-set-default.
	(custom-local-buffer): New variable.
	(defcustom): Doc fix.

1998-06-24  Andreas Schwab  <schwab@issan.informatik.uni-dortmund.de>

	* international/fontset.el (fontset-default-styles): Fix custom type.

1998-06-24  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* international/mule-cmds.el (set-language-environment):
	Allow all language environments, even in unibyte mode.
	But set the terminal coding system only in the known few.

	* language/japanese.el (iso-2022-jp): Delete spurious quote.

1998-06-23  Andreas Schwab  <schwab@issan.informatik.uni-dortmund.de>

	* ange-ftp.el (ange-ftp-default-user)
	(ange-ftp-generate-anonymous-password): Use `other' widget type.
	* autoinsert.el (auto-insert, auto-insert-query): Use `other'
	widget type.
	* bookmark.el (bookmark-save-flag, bookmark-version-control): Use
	`other' widget type.
	* comint.el (comint-input-autoexpand): Use `other' widget type.
	* complete.el (PC-first-char): Use `other' widget type.
	* cus-edit.el (custom-magic-show): Use `other' widget type.
	* cus-start.el (selective-display, suggest-key-bindings)
	(message-log-max): Use `other' widget type.
	* dabbrev.el (dabbrev-case-fold-search, dabbrev-case-replace)
	(dabbrev-check-other-buffers): Use `other' widget type.
	* dired-aux.el (dired-backup-overwrite): Use `other' widget type.
	* dired-x.el (dired-vm-read-only-folders): Use `other' widget
	type.
	* dos-vars.el (dos-ps-printer): Use `other' widget type.
	* ediff-init.el (ediff-autostore-merges): Use `other' widget
	type.
	* emacs-lisp/advice.el (ad-redefinition-action)
	(ad-default-compilation-action): Use `other' widget type.
	* emacs-lisp/bytecomp.el (byte-compile-generate-call-tree):
	Use `other' widget type.
	* emacs-lisp/checkdoc.el (checkdoc-autofix-flag): Use `other'
	widget type.
	* emacs-lisp/copyright.el (copyright-query): Use `other' widget
	type.
	* fast-lock.el (fast-lock-verbose): Use `other' widget type.
	* files.el (version-control, delete-old-versions)
	(require-final-newline, enable-local-variables, enable-local-eval):
	Use `other' widget type.
	* font-lock.el (font-lock-verbose): Use `other' widget type.
	* gnus/gnus-art.el (gnus-prompt-before-saving): Use `other' widget
	type.
	* gnus/gnus-async.el (gnus-use-article-prefetch): Use `other'
	widget type.
	* imenu.el (imenu-always-use-completion-buffer-p): Use `other'
	widget type.
	* isearch.el (search-upper-case): Use `other' widget type.
	* ispell.el (ispell-highlight-p, ispell-check-comments)
	(ispell-help-in-bufferp, ispell-skip-sgml): Use `other' widget
	type.
	* lazy-lock.el (lazy-lock-defer-on-scrolling)
	(lazy-lock-defer-contextually): Use `other' widget type.
	* mail/mh-comp.el (mh-yank-from-start-of-msg): Use `other' widget
	type.
	* mail/rmail.el (rmail-enable-mime): Use `other' widget type.
	* mail/supercite.el (sc-cite-region-limit): Use `other' widget
	type.
	* mouse-sel.el (mouse-sel-default-bindings): Use `other' widget
	type.
	* progmodes/etags.el (tags-add-tables): Use `other' widget type.
	* progmodes/executable.el (executable-query): Use `other' widget
	type.
	* ps-print.el (ps-print-control-characters): Use `other' widget
	type.
	* rlogin.el (rlogin-process-connection-type)
	(rlogin-directory-tracking-mode): Use `other' widget type.
	* shadowfile.el (shadow-noquery): Use `other' widget type.
	* textmodes/bibtex.el (bibtex-include-OPTkey): Use `other' widget
	type.

1998-06-23  Ken'ichi Handa  <handa@melange.gnu.org>

	* international/fontset.el (x-style-funcs-alist): Remove
	duplicated code.

1998-06-23  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* cus-edit.el (custom-buffer-create-internal): New optional arg LOCAL;
	set custom-local-buffer locally to that.
	(custom-buffer-create): New optional arg LOCAL.
	(customize-local-variables): New function.
	(custom-default-value): New function.
	(custom-variable-value-create): Use custom-default-value.
	(customize-set-variable): Use custom-set-default.
	(customize-save-variable): Likewise.
	(custom-variable-set, custom-variable-reset-standard): Likewise.
	(custom-variable-save, custom-variable-reset-saved): Likewise.

1998-06-23  Eli Zaretskii  <eliz@is.elta.co.il>

	* progmodes/executable.el (executable-binary-suffixes): New variable.
	(executable-find): Use it to look for executable program files.

1998-06-23  Michael Ernst  <mernst@alum.mit.edu>

	* bibtex.el: Numerous documentation fixups.
	Delete periods from error messages.

	* bibtex.el (bibtex-move-outside-of-entry): If outside an entry,
	try not to move point, or only move it minimally.

	* bibtex.el (bibtex-autokey-get-titlestring): Omit delimiters.

1998-06-23  Dave Love  <fx@gnu.org>

	* files.el (auto-mode-alist): Map .xml to sgml-mode.

1998-06-23  Kenichi Handa  <handa@etl.go.jp>

	* language/japan-util.el: Introduce new character code property
	`composition'.  Add property `jisx0208' to Japanese hankaku characters.
	(japanese-kana-table): Add more data.
	(japanese-symbol-table): Change the order of elements.
	(japanese-katakana-region): Adjusted for the above changes.  Check
	character code properties directly here.
	(japanese-hiragana-region): Likewise.
	(japanese-hankaku-region): Likewise.
	(japanese-zenkaku-region): Likewise.

1998-06-22  WJ Carpenter  <bill@carpenter.ORG>

	* mail/feedmail.el: New file.

1998-06-22  Andrew Innes  <andrewi@harlequin.co.uk>

	* term/w32-win.el (internal-face-interactive): Handle case where
	BOOL is `color'.

1998-06-22  Richard Stallman  <rms@sucrose.ai.mit.edu>

	* progmodes/compile.el (grep-command): Initialize to nil.
	(grep-find-command): Initialize to nil.
	(grep-find-use-xargs): Initialize to nil.
	(grep-compute-defaults): New function, sets those three vars properly.
	(grep, grep-find): Call grep-compute-defaults if ...command variable
	is still nil.
	(grep-program): Doc fix.

1998-06-21  Richard Stallman  <rms@sucrose.ai.mit.edu>

	* files.el (find-file-noselect-1): Init buffer-file-coding-system
	from default-buffer-file-coding-system.

	* files.el (find-file-noselect-1): Return the buffer that is current
	after after-find-file.
	(find-file-noselect): Return whatever find-file-noselect-1 returns.

	* emacs-lisp/cl-macs.el (buffer-modified-p): Make defsetf handle
	buffer argument.

	* mail/rmailout.el (rmail-output): Handle directories properly
	in suggestions for the alist.

1998-06-21  Dan Nicolaescu  <done@ece.arizona.edu>

	* midnight.el (midnight): Put :version to the defgroup and delete
	it from all the variables.

	* net-utils.el (net-utils): Add :version.

1998-06-21  Dan Nicolaescu  <done@ece.arizona.edu>

	Add support for loading the files that contain :version when doing
	`customize-changed-options' so it can know which variables have
	changed even in files that were not loaded at the time it was called.
	* cus-edit.el (customize-changed-options): Remember all the
	versions and load the corresponding files before we show the
	customization buffer.  Change the sorting to show the groups first
	in the customization buffer.

	(custom-buffer-create-internal): Move the ... before %.

	* cus-dep.el (custom-make-dependencies): Also remember if the
	variable is autoloaded or not.
	Create the information needed by customize-changed-options.

1998-06-21  Eli Zaretskii  <eliz@mescaline.gnu.org>

	* vc.el (vc-binary-suffixes): New variable.
	(vc-find-binary): Append every suffix from vc-binary-suffixes when
	looking for executable files.

1998-06-20  Richard Stallman  <rms@gnu.org>

	* apropos.el (apropos-print): Delete arg DOC-FN.
	Callers changed to do that work before calling apropos-print.
	Make *Apropos* buffer read only.

	* replace.el (occur): Set buffer-read-only.

1998-06-20  Per Starbäck  <starback@strindberg.ling.uu.se>

	* international/characters.el, ispell.el, startup.el: Doc fixes.

	* ispell.el (ispell-skip-region): Don't complain when
	ispell-check-comments is 'exclusive and there are no more
	comments.  Just skip to the end instead.

1998-06-20  Kenichi Handa  <handa@etl.go.jp>

	* international/fontset.el (x-style-funcs-alist): If
	x-make-font-demibold or x-make-font-bold return nil, don't try
	further style modification.

	* international/encoded-kb.el (encoded-kbd-self-insert-sjis):
	Handle katakana-jisx0201 correctly.

	* isearch.el (isearch-range-invisible): Handle the case that
	buffer-invisibility-spec is t (i.e. not a list).

	* language/devan-util.el (devanagari-digit-viram-visarga): Set the
	correct value.
	(devanagari-composite-glyph-unit): Likewise.
	(devanagari-char-to-glyph-rules): Likewise.

	* language/ethio-util.el: Delete codes for ethio-mode, which
	includes deletion of variable ethio-mode, variable
	ethio-mode-map, and function ethio-mode.
	(exit-ethiopic-environment-data): New variable.
	(setup-ethiopic-environment): Recode information of changed key
	bindings in exit-ethiopic-environment-data.  Add
	ethio-select-a-translation to quail-mode-hook.
	(exit-ethiopic-environment): New function.
	(ethio-find-file): Don't check ethio-mode.
	(ethio-write-file): Likewise.

	* language/ethiopic.el: Set `exit-function' of Ethiopic
	lang. env. to exit-ethiopic-environment.

	* term/x-win.el: When creating a fontset from a specified ASCII
	font, don't use the resolved font name for the new fontset name.

1998-06-19  Karl Heuer  <kwzh@gnu.org>

	* emacs-lisp/checkdoc.el (checkdoc-eval-defun): Doc fix.
	(checkdoc-continue, checkdoc-triple-semi-comment-check-flag): Ditto.
	(checkdoc-common-verbs-wrong-voice): Use dotted pairs.

1998-06-19  Richard Stallman  <rms@gnu.org>

	* startup.el (normal-top-level):
	For root, set backup-by-copying-when-mismatch to t.

	* international/fontset.el (x-style-funcs-alist):
	Fix the elements that call two x-... functions
	so they don't call the second if the first gives nil.
	(fontset-default-styles): New variable.
	(create-fontset-from-fontset-spec): Use fontset-default-styles.

1998-06-19  Andreas Schwab  <schwab@issan.informatik.uni-dortmund.de>

	* progmodes/dcl-mode.el (dcl): Define as customize group, not
	as option.

1998-06-19  Stephen Gildea  <gildea@stop.mail-abuse.org>

	* time-stamp.el (time-stamp): Handle newlines in time-stamp-pattern.
	(time-stamp-string-preprocess): Handle more than one numeric arg.

1998-06-19  Dave Love  <fx@gnu.org>

	* browse-url.el (browse-url-netscape): Encode `)' too.

1998-06-16  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* vc.el (vc-find-binary): Accept only non-directories.

1998-06-15  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* mail/rmail.el (rmail): Make the buffer multibyte
	even if it was already nonempty, if it should be multibyte.

	* custom.el (custom-declare-variable): Update current-load-list.

1998-06-14  Andreas Schwab  <schwab@issan.informatik.uni-dortmund.de>

	* wid-edit.el (widget-default-get): Doc fix.
	(widget-editable-list-entry-create): Apply :value-to-external to
	the value returned from widget-default-get.

1998-06-14  Ken'ichi Handa  <handa@melange.gnu.org>

	* international/mule.el (set-auto-coding): Redo the previous change.

	* tar-mode.el (tar-extract): Adjusted for the change of the spec
	of set-auto-coding-function.

1998-06-14  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* play/gamegrid.el, play/snake.el, play/tetris.el: New file.

	* uncompress.el (uncompress-while-visiting):
	Bind coding-system-for-write and coding-system-for-read.

	* tmm.el (tmm-get-keymap): Handle :filter.

1998-06-14  Eli Zaretskii  <eliz@mescaline.gnu.org>

	* files.el (file-name-invalid-regexp): Add control characters for
	the case of DOS/Windows: they are disallowed by these filesystems.

1998-06-14  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* net-utils.el: New file.

1998-06-13  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* emacs-lisp/sregex.el: New file.

	* startup.el (command-line-1): Check that user-init-file non-nil.

	* files.el (user-init-file): Default value now nil.

	* help.el (help-map): C-h 4 i runs info-other-window.

	* info.el (info-other-window): New function.

	* mail/rmail.el (rmail-variables): Locally bind
	local-enable-local-variables, not enable-local-variables.
	(rmail): Don't switch buffers inside the binding of
	enable-local-variables.

	* arc-mode.el (archive-mode): Locally bind
	local-enable-local-variables, not enable-local-variables.

	* tar-mode.el (tar-mode): Locally bind local-enable-local-variables,
	not enable-local-variables.

	* files.el (local-enable-local-variables): New variable.
	(set-auto-mode): Test it.

	* wid-edit.el (other): Doc fix.

	* repeat.el (repeat):
	Don't set obsolete var repeat-num-input-keys-at-prefix.

	* files.el (find-file-noselect): Delete unused local var `error'.
	(find-file-noselect-1): Add local var `error'.

	* ispell.el (ispell-region): Return non-nil if not aborted.
	(ispell-highlight-spelling-error-generic): Fix doc typo.

1998-06-12  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* midnight.el (midnight-mode): New variable.
	(midnight-timer-function): New function.
	(midnight-delay-set): Make the timer run midnight-timer-function.

1998-06-12  Andre Spiegel  <spiegel@inf.fu-berlin.de>

	* vc.el (vc-dired-hook): Don't use dired-kill-line to remove
	directory lines in terse mode.
	(vc-dired-purge): If the top level dir is empty, make it look
	a little nicer.

1998-06-12  Dave Love  <fx@gnu.org>

	* loadhist.el (read-feature): Doc fix.
	(loadhist-hook-functions): New variable.
	(unload-feature): Act on FEATURE-unload-hook or look for unloaded
	functions on hooks and remove them.

1998-06-12  Ken'ichi Handa  <handa@melange.gnu.org>

	* international/mule.el (set-auto-coding): Cancel the previous change.

1998-06-12  Kenichi Handa  <handa@etl.go.jp>

	* faces.el (set-face-font): Pay attention to fontset.
	(set-face-font-auto): Call resolve-fontset-name.

	* international/fontset.el (instantiate-fontset): Delete
	duplicated call of x-complement-fontset-spec.  Call new-fontset
	with a correct argument.
	(x-compose-font-name): Argument name adjusted for the doc-string.
	(x-complement-fontset-spec): Don't alter the contents of the
	arguments XLFD-FIELDS and FONTLIST.
	(x-style-funcs-alist): The format changed.
	(x-modify-font-name): New function.
	(create-fontset-from-fontset-spec): The arg STYLE-VARIANT-P is
	changed to STYLE-VARIANT, the format also changed.  Use
	x-modify-font-name instead of calling functions in
	x-style-funcs-alist directly.
	(instantiate-fontset): Use x-modify-font-name instead of calling
	functions in x-style-funcs-alist directly.
	(resolve-fontset-name): New function.

	* term/x-win.el: While creating fontsets of style variants, pay
	attention to X resources XXX.attributeFont.

1998-06-12  Thien-Thi Nguyen  <ttn@delysid.gnu.org>

	* progmodes/hideshow.el: Require `easymenu'.  Rework to
	use easymenu.  Remove eol ws.
	(hs-hide-level-recursive, hs-hide-level): Add.
	(hs-unbalance-handler-method): Delete.
	(hs-show-block-at-point): Always use `top-level'
	unbalanced-handler case.
	(hs-minor-mode): Use `make-local-variable' not
	`make-variable-buffer-local'.

1998-06-12  Kenichi Handa  <handa@etl.go.jp>

	* international/mule.el (set-auto-coding): Argument is changed to SIZE.
	Now finds the text to be scanned in the current buffer.

1998-06-11  Rob Riepel  <riepel@Zathras.Stanford.EDU>

	* tpu-edt.el (tpu-include) Use insert-file-contents, remove
	save-excursion.

1998-06-11  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* help.el (describe-key, describe-key-briefly):
	Don't discard up event after down event.

	* emacs-lisp/find-func.el (find-function-on-key):
	Don't discard up event after down event.

1998-06-11  Felix Lee  <flee@cygnus.com>

	* gud.el (gud-filter): Extend scope of binding of
	gud-filter-defer-flag.

1998-06-11  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* jka-compr.el (jka-compr-insert-file-contents): Don't run
	after-insert-file-functions, since caller does that.

	* midnight.el: New file.

1998-06-11  Andre Spiegel  <spiegel@inf.fu-berlin.de>

	* dired.el (dired-readin): Insert headerline only if necessary.
	(Not in recursive listings.)

	* vc.el (vc-dired-recurse, vc-dired-terse-display): New user options.
	(vc-next-action-dired): Cleanup.  Let vc-dired-terse-mode be nil here,
	so that checked-in files don't vanish.
	(vc-dired-toggle-terse-mode): New function.
	(vc-dired-hook): Don't show "." and "..".  Handle terse mode.
	(vc-dired-purge): New function.
	(vc-directory): Handle vc-dired-recurse.

1998-06-11  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* mail/rmail.el (rmail-toggle-header): Fix previous change.

1998-06-10  Dave Love  <fx@gnu.org>

	* mail/metamail.el (metamail-region): Don't use concat with
	numeric arg.

	* browse-url.el: Don't require dired when compiling.
	(browse-url-lynx-input-delay, browse-url-lynx-input-attempts):
	Remove customization.
	(browse-url-grail): Respect new-window arg (Barry Warsaw).

1998-06-10  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* progmodes/cc-langs.el (c-mode-menu): Use (mark t), not (mark),
	in enable-expressions.

	* wid-edit.el (other): New widget type.

	* emacs-lisp/eval-reg.el (elisp-eval-region):
	Accept new arg read-function; also handle load-read-function.

1998-06-10  Andrew Innes  <andrewi@harlequin.co.uk>

	* startup.el (command-line): Set `temporary-file-directory' based
	on environment settings, before processing init files.

1998-06-10  Alan Shutko  <ats@acm.org>

	* bindings.el (ctl-x-map): Change vi-dot binding to repeat.

1998-06-09  Per Abrahamsen  <abraham@dina.kvl.dk>

	* wid-edit.el (widget-specify-secret): New function.
	(widget-after-change): Use it.
	(widget-specify-field): Use it.

1998-06-09  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* emacs-lisp/lisp-mode.el (eval-defun): Pass read function to
	eval-region as arg, instead of binding load-read-function.

	* files.el (find-file-noselect): Use find-file-noselect-1
	after "Save file and revisit literally? ".

	* help.el (help-make-xrefs): When scanning keymap binding listings,
	scan from the very beginning.
	(help-follow-mouse): Avoid save-excursion, so can set point properly.

	* mail/uce.el: Several fixes in doc string style.
	(uce-mail-reader): Use defcustom.

1998-06-09  Ed Reingold  <reingold@cs.uiuc.edu>

	* calendar/cal-tex.el (cal-tex-list-diary-entries): Set
	diary-display-hook correctly.

	* calendar/cal-menu.el (calendar-mouse-holidays)
	(calendar-mouse-view-diary-entries)
	(calendar-mouse-view-other-diary-entries): Rewritten to put results
	in popup menu to be consistent with other functions.

	* calendar/diary-lib.el (view-other-diary-entries): Don't override
	default value of diary-file.

1998-06-09  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* mail/sendmail.el (mail-header-end): Widen.
	(mail-text-start): Widen.

	* progmodes/cperl-mode.el (pod2man-program): Var reinstalled.
	(cperl-pod-to-manpage, cperl-pod2man-build-command): Fns reinstalled.

1998-06-09  stanislav shalunov  <shalunov@mccme.ru>

	* mail/uce.el (uce-message-text):
	Change the text of message that is sent.

	* mail/uce.el (uce-reply-to-uce): Do not assume all Received lines
	are on top of message without headers like `From' or `To'.

	* mail/uce.el (uce-reply-to-uce): Parse Received lines better.

	* mail/uce.el (uce-mail-reader): New user option.
	(uce-reply-to uce): Add support for Gnus.  User is supposed to set
	uce-mail-reader to `gnus' if using Gnus to read mail.  The default
	is to assume Rmail.  There's no magic to determine what mail
	reader is currently active, so it is not possible to mix using
	uce.el with Rmail and Gnus.

1998-06-08  Dan Nicolaescu  <done@ece.arizona.edu>

	* generic.el (generic-mode-with-type): Set major-mode to be the
	actual mode, not generic-mode.

1998-06-08  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* apropos.el (apropos-print): The cross ref for a variable
	should always do just describe-variable.

	* ange-ftp.el (ange-ftp-expand-dir): Use null-device.

	* progmodes/compile.el (grep-null-device): Variable deleted.
	(grep-command, grep-find-use-xargs): Use null-device.
	(grep, grep-find): Use null-device.

	* files.el (null-device): New variable.

	* progmodes/cperl-mode.el (Man-filter-list): Unused variable deleted.
	(cperl-perldoc, cperl-perldoc-at-point): Functions reinstalled.

1998-06-08  Andrew Innes  <andrewi@harlequin.co.uk>

	* ange-ftp.el (ange-ftp-file-name-completion): Use
	ange-ftp-this-dir instead of literal "/" when calling real
	completion function.

1998-06-08  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* textmodes/texnfo-upd.el (texinfo-insert-master-menu-list):
	Insert \n after @detailmenu.

1998-06-07  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* progmodes/cperl-mode.el (cperl-problems): Doc fix.

	* progmodes/cperl-mode.el (cperl-pod-to-manpage): Function deleted.
	(cperl-pod2man-build-command, cperl-perldoc-at-point): Likewise.
	(cperl-perldoc): Likewise.
	(pod2man-program): Variable deleted.

	* repeat.el: Renamed from vi-dot.el.
	All functions and variables renamed.
	(repeat-last-kill-command): Variable deleted;
	use real-last-command instead.
	(kill-region): Advice definition deleted.
	(universal-argument-more, universal-argument-other-key)
	(typematic-universal-argument-more-or-less): Advice deleted.
	(repeat-prefix-arg): Variable deleted.
	(repeat-num-input-keys-at-prefix): Variable deleted.
	(repeat): Use last-prefix-arg.

1998-06-07  Stephen Eglen  <stephen@gnu.org>

	* iswitchb.el (iswitchb-require-match, iswitchb-temp-buflist)
	(iswitchb-bufs-in-frame): Variables declared with defvar to quieten
	the byte compiler.

1998-06-06  Andrew Innes  <andrewi@harlequin.co.uk>

	* ange-ftp.el (ange-ftp-file-name-completion): Do hostname
	completion in root directory of all drives on Windows.
	(ange-ftp-file-name-all-completions): Fix regexp for detecting
	root directory on drives.

	(file-name-handler-alist): Remove the autoload tag from the
	top-level form which changes file-name-handler-alist to support
	Windows hostname completion.

1998-06-06  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* gnus/message.el (message-mode): Set paragraph-start and
	paragraph-separate as in mail-mode.

	* mail/sendmail.el (mail-mode): Include `-- ' and `---+' in
	paragraph-start and paragraph-separate.

	* progmodes/fortran.el (fortran-electric-line-number):
	Add delete-selection property.

	* simple.el (comment-region): Check for enough chars to delete
	in the numarg != t case as in the numarg = t case.

1998-06-06  Dan Nicolaescu  <done@ece.arizona.edu>

	* emacs-lisp/autoload.el (make-autoload): Add support for
	`define-generic-mode' and `easy-mmode-define-minor-mode' and
	update the doc string accordingly.

1998-06-06  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* mail/rmail.el (rmail): Prevent find-file from calling
	rmail-mode for a new buffer.  Do it later, instead.

	* rect.el (string-rectangle-line): Delete the rectangle first.
	(string-rectangle): Doc fix.

	* files.el (find-file-noselect-1): New function.
	(find-file-noselect): If want to visit literally and buffer is
	visited the ordinary way, or vice versa, ask user whether
	to re-visit, or save and revisit.  Use find-file-noselect-1.

1998-06-05  Vinicius Jose Latorre  <vinicius@cpqd.com.br>

	* ps-print.el: Fix spooled file bugs.
	(ps-print-version): New version number (3.06.3) and doc fix.
	(ps-page-postscript): New var.
	(ps-begin-file): Initialize PostScript page number,
	eliminate total page and line number.
	(ps-begin-job): Eliminate PostScript Trailer section on spooled buffer,
	initialize total page and line number.
	(ps-end-file): Use PostScript page number.
	(ps-header-page): Adjust header page.
	(ps-generate): Adjust page and line count setting.
	(ps-do-despool): Eliminate PostScript Trailer section setting.

1998-06-05  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* man.el (Man-kill, Man-quit): Use quit-window.

	* ps-print.el (ps-generate): Call set-buffer-multibyte.

	* textmodes/fill.el (fill-paragraph):
	Bind fill-paragraph-function to nil, if it doesn't do the job.

1998-06-05  Ed Reingold  <reingold@melange.gnu.org>

	* calendar/cal-menu.el (cal-menu-update): Fix menu separators.

1998-06-05  Andrew Innes  <andrewi@harlequin.co.uk>

	* jka-compr.el (jka-compr-write-region): Ensure
	`last-coding-system-used' is updated, so that basic-save-buffer
	sees the right value.

1998-06-05  Richard Stallman  <rms@gnu.org>

	* loadup.el: Clean up mechanism for removing -l loadup from end.

1998-06-05  Andre Spiegel  <spiegel@inf.fu-berlin.de>

	* dired.el (dired-internal-noselect): Call either dired-mode
	or MODE, but not both.

	* vc.el (vc-directory): Bind vc-dired-switches in order to
	pass switches to vc-dired-mode.
	(vc-dired-mode): Check for vc-dired-switches.

1998-06-04  Dan Nicolaescu  <done@ece.arizona.edu>

	* rsz-mini.el (resize-minibuffer-mode):
	* iswitchb.el (iswitchb-read-buffer): Add autoload cookie.

1998-06-03  Kevin Rodgers  <kevinr@ihs.com>  (tiny change)

	* replace.el (esc-map): Bind C-M-% to query-replace-regexp.

1998-06-03  Richard Stallman  <rms@gnu.org>

	* cus-edit.el (customize-group-other-window): Fix previous change.

	* international/mule-diag.el (list-character-sets-1): New subroutine.
	(list-character-sets): Use it.
	(list-coding-systems-1): New subroutine.
	(list-coding-systems): Use it.
	(list-input-methods-1): New subroutine.
	(list-input-methods): Use it.
	(mule-diag): Avoid method of displaying text in *Help* then copying it.
	Instead, insert it directly into *Mule-Diagnosis*.
	Use list-character-sets-1, list-coding-systems-1, list-input-methods-1.
	Copy the code from list-fontsets and list-coding-categories.
	Improve the display buffer's header.

	* files.el (toggle-read-only): When exiting View mode, locally
	set view-read-only to t so another toggle will re-enable View mode.

	* view.el (View-exit-and-edit): Bind view-no-disable-on-exit to nil.

1998-06-03  Michael Ernst  <mernst@alum.mit.edu>

	* mail/rmailsum.el (rmail-summary-rmail-update): Set message
	unseen only if `rmail-summary-put-back-unseen' is non-nil.

	* mail/rmail.el (rmail-toggle-header): Redo previous change;
	don't move point if possible.
	(rmail-count-screen-lines): Add.

1998-06-03  Per Starbäck  <starback@update.uu.se>

	* emacs-lisp/bytecomp.el (byte-compile-lambda): Fix previous
	change.

1998-06-03  Dan Nicolaescu  <done@ece.arizona.edu>

	* locate.el (locate, locate-with-filter):
	* generic.el (define-generic-mode): Correct typo in autoload
	cookie that prevented appropriate autoloads to be generated.

1998-06-03  Andre Spiegel  <spiegel@inf.fu-berlin.de>

	* vc.el (vc-dired-hook): Kill excluded directories recursively.

1998-06-03  Andreas Schwab  <schwab@issan.informatik.uni-dortmund.de>

	* emacs-lisp/find-func.el (find-function-noselect): Don't call
	format twice with the error message.  Quote the function name
	before splicing into regexp.

1998-06-02  Dave Love  <fx@gnu.org>

	* docref.el: Deleted in view of current approach to doc strings.

	* startup.el (normal-top-level-add-subdirs-to-load-path): Ignore
	CVS directories too.

1998-06-02  Richard Stallman  <rms@gnu.org>

	* cus-edit.el (customize-group, customize-group-other-window)
	(custom-buffer-create, custom-buffer-create-other-window)
	(customize-browse): Use pop-to-buffer.
	(same-window-regexps): Add autoload to add regexp to match custom bfrs.

	* info.el (Info-exit): Use quit-window.

	* mail/rmail.el (rmail-toggle-header): Preserve point
	and window-start (more or less) when reverting to original header.

1998-06-01  Richard Stallman  <rms@gnu.org>

	* window.el (shrink-window-if-larger-than-buffer):
	Switch to the specified window and its buffer at the outset.
	(count-windows): Doc fix.

	* help.el (help-setup-xref): Change all callers to
	use (function args...) instead of (function . arg).  Doc fix.
	(help-follow): Put (point) at front of elts of help-xref-stack.
	(help-xref-stack): Elt format now (POSITION FUNCTION ARGS).
	(help-xref-stack-item): Doc fix.
	(help-xref-go-back): Assume new format for help-xref-stack.
	(help-follow): Look for prop on previous char if next char has none.
	Avoid error at beginning or end of buffer.
	(describe-bindings): New optional arg BUFFER.
	Use help-setup-xref.

	* simple.el (event-apply-alt-modifier, etc): Doc fixes.

1998-06-01  Andrew Innes  <andrewi@harlequin.co.uk>

	* arc-mode.el (archive-extract): Fix handling of 'view option.

1998-06-01  Per Starbäck  <starback@update.uu.se>

	* apropos.el (apropos-variable): Fixed argument to apropos-command.
	(apropos-command): Let `var-predicate' have higher priority than
	`do-all'.

1998-06-01  Dave Love  <fx@gnu.org>

	* textmodes/sgml-mode.el (sgml-font-lock-keywords-1): Add -. as
	NMCHARs.  Elide upper case (see font-lock-defaults).  Generalize
	comment declaration not to exclude markup.

1998-05-31  Richard Stallman  <rms@gnu.org>

	* which-func.el (which-func-ff-hook): If imenu gets error,
	clear which-func-mode.

	* progmodes/compile.el (grep): Fix previous change.

	* international/mule-diag.el: Many doc fixes.

	* tar-mode.el (tar-extract): Pass HIGHEST=t to detect-coding-region.

	* simple.el (keyboard-quit): Doc fix.

	* textmodes/two-column.el: Bind f2 and C-x 6 prefixes
	only via an autoload, not when this file is loaded.

	* international/mule.el (coding-system-mnemonic):
	Don't crash if arg is nil.

1998-05-31  Alan Shutko  <shutkoa@ugsolutions.com>

	* emacs-lisp/easy-mmode.el (easy-mmode-define-minor-mode): Add
	missing format arg.

1998-05-30  Dave Love  <fx@gnu.org>

	* finder.el (finder-known-keywords): Fix `convenience' entry.

1998-05-30  Richard Stallman  <rms@gnu.org>

	* textmodes/tex-mode.el: Undo May 15 change.

	* international/mule-diag.el (mule-diag): Don't call help-mode.
	Instead, call print-help-return-message.

	* ffap.el (ffap-bindings): Fix the dired-at-point binding.

1998-05-30  Sam Steingold  <sds@usa.net>

	* compile.el (compilation-scroll-output): Correct the :version
	keyword to be a string.

1998-05-30  Michael Kifer  <kifer@cs.sunysb.edu>

	* ediff-mult.el (ediff-mark-for-hiding-at-pos)
	(ediff-mark-for-operation-at-pos): Renamed from
	ediff-mark-for-hiding, ediff-mark-for-operation.
	(ediff-mark-session-for-hiding, ediff-mark-session-for-operation)
	(ediff-unmark-all-for-operation, ediff-unmark-all-for-hiding): New
	functions.
	(ediff-setup-meta-map): Changed bindings.

	* viper-cmd.el (viper-backward-Word, viper-skip-separators): Bugfix.
	(viper-switch-to-buffer, viper-switch-to-buffer-other-window): Bugfix.
	* viper-util.el (viper-skip-syntax): Bug fix for eob/bob cases.
	* viper-mous.el (viper-surrounding-word): Added '_' to alpha modifiers.

1998-05-30  Ralph Schleicher  <rs@purple.UL.BaWue.DE>

	* info-look.el: Added support for Scheme.
	Removed Info-lookup minor mode.
	(info-lookup-file-name-alist): New variable.
	(info-lookup-select-mode): New function.  Select help mode
	according to info-lookup-file-name-alist or fall back to the
	buffer's major mode.
	(info-lookup): Use info-lookup-select-mode.
	(info-lookup-interactive-arguments): Likewise.
	(info-complete-symbol): Likewise.
	(info-complete-file): Likewise.
	(info-complete): Likewise.

1998-05-28  Andrew Innes  <andrewi@harlequin.co.uk>

	* ange-ftp.el (ange-ftp-expand-file-name): Set default to
	default-directory if nil.  Check whether default starts with a
	drive specifier on windows-nt, as well as name, and call real
	function if so.  Remove code to strip prefix before // or /~ since
	`expand-file-name' itself no longer does that.
	(ange-ftp-expand-dir): Use `grep-null-device' instead of
	"/dev/null", which is incorrect on windows-nt.
	(ange-ftp-file-name-all-completions): Fix root directory regexp
	for windows-nt.
	(ange-ftp-start-process): On windows-nt, always send a "help foo"
	command to ensure the ftp process produces some output, and force
	the process to use raw-text-dos decoding.
	(ange-ftp-canonize-filename): On windows-nt, strip drive specifier
	from expanded remote name.
	(ange-ftp-write-region): Allow binary transfer on windows-nt if
	remote host type is unix.  Ensure `last-coding-system-used' is
	given an appropriate value, so that basic-save-buffer isn't
	confused by the coding used with the ftp process.
	(ange-ftp-insert-file-contents): Ditto.
	(ange-ftp-copy-file-internal): Ditto.
	(ange-ftp-real-expand-file-name): Use standard definition on
	windows-nt.
	(ange-ftp-real-expand-file-name-actual): Remove obsolete function.
	(ange-ftp-disable-netrc-security-check): Make default value be t
	on windows-nt.

	Remove windows-nt entry on file-name-handler-alist for
	ange-ftp-hook-function, since ange-ftp remote names do not start
	with a drive specifier.  Keep ange-ftp-completion-hook-function
	entry to allow hostname completion when completing in the root
	directory of a drive.

1998-05-28  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* ange-ftp.el (ange-ftp-start-process): Undo previous change.

	* mail/sendmail.el (mail-from-style):
	New alternative, `system-default'.

1998-05-27  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* mail/sendmail.el (sendmail-send-it):
	If mail-from-style isn't angles, parens or nil, don't use -f option.

1998-05-27  Ed Reingold  <reingold@cs.uiuc.edu>

	* calendar/calendar.el (calendar-buffer-list): Add
	other-calendars-buffer.
	(calendar-mode): Use activate-menubar-hook only in a window system.

1998-05-27  Dave Love  <fx@gnu.org>

	* info-look.el: Add an entry for Scheme mode.

1998-05-27  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* comint.el (comint-mode-map): Move bindings of
	comint-next-matching-input-from-input to C-c M-r, and
	comint-previous-matching-input-from-input to C-c M-s.
	Move comint-get-next-from-history to C-c C-x.

	* mail/rmailout.el (rmail-output-to-rmail-file):
	Specify the coding system for writing.

1998-05-27  Ed Reingold  <reingold@cs.uiuc.edu>

	* calendar/calendar.el (calendar-print-other-dates): New function.
	* calendar/calendar.el (calendar-mode-map): Put it on a key.
	* calendar/calendar.el (other-calendars-buffer): New constant.
	* calendar/cal-x.el (special-display-buffer-names): Add to special
	list.

1998-05-27  Dave Love  <fx@gnu.org>

	* imenu.el (imenu-syntax-alist): Doc fix.

1998-05-26  Dan Nicolaescu  <done@ece.arizona.edu>

	* ffap.el: Add convenience keyword and add the toplevel defgroup
	to the convenience group.
	* emulation/pc-select.el:
	* follow.el:
	* imenu.el:
	* hippie-exp.el:
	* speedbar.el:
	* filecache.el:
	* iswitchb.el:
	* dabbrev.el:
	* completion.el:
	* complete.el:
	* autorevert.el:
	* autoinsert.el:
	* abbrev.el: Likewise.

1998-05-26  Emilio Lopes  <Emilio.Lopes@Physik.TU-Muenchen.DE>
            Karl Fogel  <kfogel@red-bean.com>

	* bookmark.el: Changes so bookmark list mode works with Info:
	(bookmark-jump-noselect): Use an inner save-window-excursion.
	(bookmark-bmenu-switch-other-window): Temporarily set
	pop-up-windows, same-window-buffer-names, and same-window-regexps,
	to override Info's special display behaviors.

1998-05-26  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* emacs-lisp/autoload.el (make-autoload): Doc fix.

1998-05-25  Dave Love  <fx@gnu.org>

	* f90.el (f90-comment-indent): Don't attempt to indent trailing
	comment as code.
	(f90-looking-at-if-then): Don't lose with scan-lists on bad
	syntax.

1998-05-25  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* emacs-lisp/lisp-mode.el (eval-defun): Pass proper beg to eval-region.

	* faces.el (frame-update-face-colors): Call frame-set-background-mode.

	* frame.el (make-frame-on-display): Check for nonsense display name.

	* mail/rmailedit.el (rmail-old-pruned): New permanent local.
	(rmail-edit-current-message): Set rmail-old-pruned,
	then display full headers.
	(rmail-cease-edit): rmail-old-pruned controls whether to prune headers.

1998-05-25  Dan Nicolaescu  <done@ece.arizona.edu>

	* emacs-lisp/autoload.el (make-autoload): Add support for
	define-derived-mode.  Update the doc-string accordingly.

	* zone-mode.el (zone-mode): Don't require zone-mode.
	Use make-local-hook on a hook, not make-variable-buffer-local.

1998-05-25  Andreas Schwab  <schwab@issan.informatik.uni-dortmund.de>

	* emacs-lisp/byte-opt.el (byte-boolean-vars):
	Add print-escape-nonascii.

	* emacs-lisp/autoload.el (generate-file-autoloads): Set
	print-escape-nonascii when printing autoload form.

1998-05-25  Kenichi HANDA  <handa@etl.go.jp>

	* international/mule.el (set-coding-priority): Call
	set-coding-priority-internal at the tail.

1998-05-24  Stephen Eglen  <stephen@cns.ed.ac.uk>

	* help.el (describe-variable): Add a button to call
	customize-variable if the variable can be customized.

1998-05-24  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* mail/rmail.el (rmail-msg-is-pruned): Delete junk in definition.

	* apropos.el (apropos-command): Change 3rd arg to VAR-PREDICATE
	and use it as a predicate for which variables to match.
	(apropos-variable): Use that feature to match all documented vars,
	if have prefix arg.
	(apropos-command): If DO-ALL is set, search functions, not variables.

	* loadup.el (loaddefs.el): Load it earlier, and GC before and after
	and a few more times later on.

	* comint.el (comint-get-next-from-history): New command.
	(comint-accumulate, comint-goto-process-mark): Likewise.
	(comint-set-process-mark, comint-bol-or-process-mark): Likewise.
	(comint-save-input-ring-index): New permanent local var.
	(comint-accum-marker): Likewise.
	(comint-send-input): Clear comint-input-ring-index
	and comint-accum-marker.
	(comint-previous-matching-input-from-input):
	Use comint-accum-marker if set.
	(comint-previous-matching-input): Likewise.
	(comint-mode): Make those vars buffer-local and initialize.
	(comint-mode-map): Make C-c C-a run comint-bol-or-process-mark.
	Bind C-c SPC to comint-accumulate.  Bind C-c C-q to
	comint-get-next-from-history.

	* window.el (split-window-vertically): Doc fix.

	* ffap.el (dired-at-point): Eliminate var dired-function; use `dired'.
	(ffap-bindings): Include a binding for C-x d.

	* gud.el (gud-jdb-class-source-alist): defvar moved up.
	(gud-jdb-analysis-buffer): Likewise.

	* rect.el (string-rectangle-string): New variable.
	(string-rectangle): Bind it.
	(string-rectangle-line): Use it.
	(operate-on-rectangle-lines): New variable.
	(extract-rectangle-line): Update it.
	(delete-extract-rectangle, extract-rectangle): Bind and use it.

	* emacs-lisp/cl-indent.el (common-lisp-indent-function):
	Bind lisp-indent-error-function.
	(lisp-indent-report-bad-format): Use lisp-indent-error-function.
	(lisp-indent-error-function): New variable.

	* play/solitaire.el (solitaire-possible-move):
	Use funcall to invoke movesymbol.

	* uncompress.el (find-compressed-version): Don't set `error' here.

1998-05-24  Eli Zaretskii  <eliz@is.elta.co.il>

	* man.el (Man-getpage-in-background): Bind coding-system-for-write
	to raw-text-unix instead of binding inhibit-eol-conversion to t.

1998-05-23  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* dos-w32.el (minibuffer-history-case-insensitive-variables):
	Add file-name-history to it.

	* simple.el (minibuffer-history-case-insensitive-variables): New var.
	(previous-matching-history-element): Implement it.

	* progmodes/compile.el (grep-tag-default): New function.
	(grep): New default arg when prefix arg is specified.

	* menu-bar.el (toggle-case-fold-search): New command.
	(menu-bar-options-menu): Put that in the menu.

	* dired.el (dired-mark-files-containing-regexp): New command.
	(dired-mode-map): Bind it to %g and in menu bar.

	* rect.el (close-rectangle): New command.

1998-05-23  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* international/mule-cmds.el (register-input-method):
	Rename arg ENV to LANG-ENV.

1998-05-22  Vinicius Jose Latorre  <vinicius@cpqd.com.br>

	* ps-print.el (ps-print-version): Doc fix.
	(ps-print-prologue-1): Adjust doLineNumber PostScript function.

1998-05-22  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* jka-compr.el (jka-compr-compression-info-list): Add elts for bzip.

	* uncompress.el (uncompress-while-visiting): Leave point at beginning.

	* find-file.el (ff-emacs-19, ff-xemacs): Functions deleted.
	(ff-goto-click, ff-mouse-find-other-file)
	(ff-mouse-find-other-file-other-window): Just one definition.
	(locate-file): Definition deleted.

	* international/mule.el (make-translation-table): Doc fix.
	(define-translation-table): Doc fix.

1998-05-22  Inge Frick  <inge@nada.kth.se>

	* easymenu.el (easy-menu-do-add-item): Small simplifications.
	(easy-menu-precalculate-equivalent-keybindings): New customization
	variable.
	(easy-menu-add): Precalculate key bindings if
	`easy-menu-precalculate-equivalent-keybindings' is on.

1998-05-22  Kenichi Handa  <handa@etl.go.jp>

	* ccl.el: Change term "character translation table" to
	"translation table".
	* mule.el: Likewise.
	Use translation-table, not character-translation-table,
	as char-table subtype.
	(define-translation-table):
	Renamed from define-character-translation-table.
	* mule-util.el: Likewise.
	* mule-conf.el: Likewise.
	(standard-translation-table-for-decode)
	(standard-translation-table-for-encode):
	Renamed from standard-character-translation-table-...

1998-05-21  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* textmodes/sgml-mode.el (sgml-font-lock-keywords-1):
	Accept upper case like lower case.

	* files.el (insert-directory): When WILDCARD is nil,
	expand ~ if necessary.

	* mail/rnewspost.el (news-inews): Fix typo in prev change.

1998-05-21  Eli Zaretskii  <eliz@is.elta.co.il>

	* tar-mode.el (tar-mode): Position point on the name of the first file.
	(tar-extract): Detect coding-system of the archive member and
	decode it like insert-file-contents does.
	(tar-alter-one-field): Reposition point on the file name of the
	current tar entry.
	(tar-subfile-save-buffer): Encode the file when updating it in the
	archive, and use the size of encoded text to update the header
	block.  Set last-coding-system-used to coding-system of the file.
	Restore point of tar-superior-buffer after updating the descriptor
	line.

1998-05-21  Sam Steingold  <sds@usa.net>

	* emacs-lisp/cl-indent.el: Indent `with-standard-io-syntax' correctly.

1998-05-21  Michael Ernst  <ernst@cs.washington.edu>

	* dired-x.el (dired-guess-shell-alist-default): Handle .tgz files.
	Handle .pdf files.

1998-05-21  Eli Zaretskii  <eliz@mescaline.gnu.org>

	* arc-mode.el (archive-file-name-invalid-regexp): Remove.  All
	users changed to use file-name-invalid-regexp instead.
	* files.el (file-name-invalid-regexp): New variable, moved here
	from arc-mode.el.

1998-05-21  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* progmodes/vhdl-mode.el (vhdl-customize-colors):
	Renamed from vhdl-use-default-colors, and sense reversed.
	(vhdl-customize-faces):
	Renamed from vhdl-use-default-faces, and sense reversed.
	(vhdl-font-lock-init, vhdl-ps-init): Implement those changes.
	(vhdl-submit-bug-report): Use new variable names.

1998-05-20  Kenichi Handa  <handa@etl.go.jp>

	* term/x-win.el: Generate style variants fontset for
	standard-fontset-spec.  Generate a fontset based on resolved font
	name of a font specified by X resource or -fn command line arg.

	* international/fontset.el (x-font-name-charset-alist): New var.
	(register-alternate-fontnames): Doc-string modified.
	(x-complement-fontset-spec): Likewise.
	(x-complement-fontset-spec): Delete unused local variable.  Delete
	ad hoc code for Latin-1, instead refer to x-font-name-charset-alist.
	(uninstantiated-fontset-alist): Format changed (BASE-FONTSET ->
	FONTLIST).
	(x-style-funcs-alist): New variable.
	(create-fontset-from-fontset-spec): 2nd optional arg is changed
	from STYLE to STYLE-VARIANT-P.  The meaning also changed.  Delete
	unused code.  Adjusted for the change of
	uninstantiated-fontset-alist.
	(instantiate-fontset): Adjusted for the change of
	uninstantiated-fontset-alist.

	* international/mule.el (make-coding-system): If ISO2022 based
	8-bit coding system allows alternative designation, set the coding
	category to `coding-category-iso-8-else'.

1998-05-20  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* mail/rmail.el (rmail-default-body-file): New variable.

	* mail/rmailsum.el (rmail-summary-output-body): New function.
	(rmail-summary-mode-map): Bind w to that.  Put it in menu bar.
	Bind q to rmail-summary-wipe.

	* mail/rmailout.el (rmail-output-body-to-file):
	Avoid error if message has no subject.
	Use and set rmail-default-body-file.

	* gud.el (gud): Doc fix.

	* textmodes/fill.el (fill-region-as-paragraph):
	Don't add a newline at the end, when there is none.

1998-05-20  Michael Ernst  <ernst@cs.washington.edu>

	* play/solitaire.el (solitaire): Doc fix.

	* gud.el: Support pdb.
	(pdb): New function.
	(gud-pdb-command-name): New variable.
	(pdb-minibuffer-local-map): Likewise.
	(gud-pdb-find-file): New function.
	(gud-pdb-marker-filter): New function.
	(gud-pdb-marker-regexp*): New variables.
	(gud-pdb-massage-args): New function.
	(gud-pdb-history): New variable.

	* simple.el (set-variable): Offer variable at point as default.

1998-05-20  Kenichi Handa  <handa@etl.go.jp>

	* international/fontset.el (x-font-name-charset-alist): New
	variable.
	(register-alternate-fontnames): Doc-string modified.
	(x-complement-fontset-spec): Likewise.
	(x-complement-fontset-spec): Delete unused local variable.  Delete
	ad hoc code for Latin-1, instead refer to
	x-font-name-charset-alist.
	(uninstantiated-fontset-alist): Format changed (BASE-FONTSET ->
	FONTLIST).
	(x-style-funcs-alist): New variable.
	(create-fontset-from-fontset-spec): 2nd optional arg is changed
	from STYLE to STYLE-VARIANT-P.  The meaning also changed.  Delete
	unused code.  Adjusted for the change of
	uninstantiated-fontset-alist.
	(instantiate-fontset): Adjusted for the change of
	uninstantiated-fontset-alist.

	* international/mule.el (make-coding-system): If ISO2022 based
	8-bit coding system allows alternative designation, set the coding
	category to `coding-category-iso-8-else'.

	* term/x-win.el: Generate style variants fontset for
	standard-fontset-spec.  Generate a fontset based on resolved font
	name of a font specified by X resource or -fn command line arg.

1998-05-20  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* international/mule-cmds.el (set-language-info):
	Delete args describe-map and setup-map.  Don't set up menus at all.
	(set-language-info-alist): Set up menus here.
	(register-input-method): Fix previous change.
	(setup-specified-language-environment): Doc fix.

	* gud.el (gud-perldb-marker-acc): Variable deleted.
	(gud defgroup): Doc fix.

	* mail/rmail.el (mail-unsent-separator):
	Handle "returned message follows".

1998-05-19  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* international/mule-cmds.el: Several doc fixes.
	(get-language-info, set-language-info): Rename argument.
	(set-language-info-alist): Likewise.
	(find-coding-systems-region-subset-p): Renamed from subset-p.
	(find-coding-systems-region): Use new name.
	(register-input-method): Rename argument.
	(activate-input-method): If INPUT-METHOD is nil, deactivate.

1998-05-19  Ed Reingold  <reingold@uiuc.edu>

	* calendar/cal-tex.el (cal-tex-list-holidays): Rewritten.

1998-05-19  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* gnus/message.el (message-mode): Locally bind adaptive-fill-regexp
	and adaptive-fill-first-line-regexp.

	* simple.el (kill-region): Set this-command unconditionally
	in a read-only buffer.

	* custom.el (defcustom): Doc fix.

	* uniquify.el (uniquify-ignore-buffers-re): New variable.
	(uniquify-rationalize-file-buffer-names): Implement it.

1998-05-18  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* emacs-lisp/checkdoc.el: Many doc fixes.
	Put two spaces between sentences.
	(checkdoc-this-string-valid-engine): Fix message.
	(checkdoc-ispell-lisp-words): Add "emacs".

	* emacs-lisp/bytecomp.el (byte-compile-insert-header):
	Do not look for multibyte characters here.
	Generate the right file header for use if there are none.
	Insert a line of semicolons for subsequent deletion if needed.
	(byte-compile-fix-header): New function.
	This updates the file header if the file uses multibyte characters.
	(byte-compile-from-buffer): Call byte-compile-insert-header
	before compiling, and byte-compile-fix-header at the end.

	* which-func.el (which-func-modes): Fix custom type.
	(which-func-non-auto-modes): Likewise.

	* mail/rmail.el (rmail-mime-feature): Doc fix.

	* vi-dot.el: Customized.
	(vi-self-insert): New function.
	(vi-dot): Use that.
	(vi-dot-insertion-function): Variable deleted.

	* finder.el (finder-known-keywords): Add `convenience'.

1998-05-18  Michael Ernst  <mernst@alum.mit.edu>

	* mail/rmail.el (rmail-toggle-header): Ensure blank line between
	headers and body.

1998-05-17  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* international/fontset.el (create-fontset-from-fontset-spec):
	Add autoload cookie.

1998-05-18  Kenichi HANDA  <handa@etl.go.jp>

	* international/ccl.el: Change term translate-XXX-map to map-XXX
	throughout the file.  Change terms unify/unification to
	translate/translation respectively throughtout the file.

	* international/quail.el (quail-completion): Consecutive call of
	this command scrolls the Quail completion buffer.

	* international/mule.el: Change term unification to translation
	throughtout the file.
	(set-clipboard-coding-system): New function.

	* international/mule-conf.el: Change term unification to
	translation throughtout the file.

	* international/mule-util.el: Change term unification to
	translation throughtout the file.

1998-05-17  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* emacs-lisp/debug.el (debugger-frame-clear): Doc fix.

1998-05-17  Andre Spiegel  <spiegel@inf.fu-berlin.de>

	* vc-hooks.el (vc-parse-cvs-status): Grok new form of conflict
	message.

1998-05-17  Eric Ludlam  <zappo@mescaline.gnu.org>

	* emacs-lisp/checkdoc.el: Added message text checks, and
	ambiguous symbol checking.
	(checkdoc-message-text): New command.
	(checkdoc-message-text-search, checkdoc-message-text-engine):
	New functions.
	(checkdoc-this-string-valid-engine):
	Added ambiguous function/symbol checking.  Added new auto-fix
	for missing parameters.

1998-05-16  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* international/mule-cmds.el (find-coding-systems-region-subset-p):
	Renamed from subset-p.
	(find-coding-systems-for-charsets): Call changed.

1998-05-16  Dan Nicolaescu  <done@ece.arizona.edu>

	* generic-x.el (generic-x): Add :version.

	* progmodes/hideshow.el (hs-life-goes-on): Use the new backquote
	syntax.

1998-05-16  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* mail/rmail.el (rmail-retry-failure):
	Use mail-sendmail-delimit-header, not mail-send-delimit-header.

	* faces.el (frame-background-mode): Define a :set function
	to update the background mode of existing frames.

	* ange-ftp.el (ange-ftp-tmp-name-template):
	Use temporary-file-directory.
	* arc-mode.el (archive-tmpdir): Use temporary-file-directory.
	* browse-url.el (browse-url-temp-dir): Use temporary-file-directory.
	* ediff-init.el (ediff-temp-file-prefix): Use temporary-file-directory.
	* emerge.el (emerge-temp-file-prefix): Use temporary-file-directory.
	* jka-compr.el (jka-compr-temp-name-template):
	Use temporary-file-directory.
	* progmodes/cmacexp.el (c-macro-expansion):
	Use temporary-file-directory.  Choose temp file name properly.
	* vc.el (vc-update-change-log): Use temporary-file-directory.
	Use expand-file-name on it.

	* files.el (temporary-file-directory):
	Renamed from system-tmp-directory.
	Value is now a directory name, not a file name.

	* dired-aux.el (dired-mark-subdir-files): Doc fix.

1998-05-15  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* ps-print.el (ps-file-end): Put Trailer and Pages before EndDoc.
	(ps-print-control-characters): Doc fix.

	* textmodes/tex-mode.el (tex-command-end): New variable.
	(tex-start-tex): Use it.
	(plain-tex-mode): Locally set tex-command-end.
	(tex-common-initialization): Make local binding for it.

	* ange-ftp.el (ange-ftp-start-process): Handle Windows ftp client.

	* language/european.el (setup-8-bit-environment):
	After loading latin-N, reset the standard case table
	and each buffer's case table.

	* emacs-lisp/byte-opt.el (byte-decompile-bytecode-1):
	Cope with an out-of-range constvec index.

	* dos-fns.el (dos-ps-printer, dos-printer, msdos-shells):
	Defcustoms replaced with defvars.
	(dos-fns): defgroup deleted.
	* dos-vars.el: New file, holds custom stuff from dos-fns.el.
	* loadup.el: Load dos-vars along with dos-fns.

	* type-break.el (type-break-mode): Don't alter global-mode-string.
	Instead, add an element to minor-mode-alist.

	* cus-edit.el (convenience): New group.

	* info.el (Info-find-node): Use info-file-exists-p.
	(info-insert-file-contents): Use info-file-exists-p.
	(info-file-exists-p): New function.

1998-05-15  Geoff Voelker  <voelker@cs.washington.edu>

	* files.el (system-tmp-directory): New variable.

	* ange-ftp.el (ange-ftp-tmp-name-template): Use system-tmp-directory.
	* arc-mode.el (archive-tmpdir): Use system-tmp-directory.
	* browse-url.el (browse-url-temp-dir): Use system-tmp-directory.
	* ediff-init.el (ediff-temp-file-prefix): Use system-tmp-directory.
	* emerge.el (emerge-temp-file-prefix): Use system-tmp-directory.
	* jka-compr.el (jka-compr-temp-name-template): Use system-tmp-directory
	* progmodes/cmacexp.el (c-macro-expansion): Use system-tmp-directory.
	* vc.el (vc-update-change-log): Use system-tmp-directory.

1998-05-15  Francesco Potortì  <F.Potorti@cnuce.cnr.it>

	* mail/mailalias.el (define-mail-alias): Compensate for not
	resetting the match data when string-match fails.

1998-05-14  Erik Naggum  <erik@naggum.no>

	* bindings.el: Add binding for C-x z to vi-dot here.
	* vi-dot.el: Remove faulty autoloaded binding for C-x z.

1998-05-14  Ed Reingold  <reingold@melange.gnu.org>

	* calendar/cal-hebrew.el (holiday-passover-etc): Fix misspelling.

1998-05-14  Eli Zaretskii  <eliz@mescaline.gnu.org>

	* arc-mode.el (archive-tmpdir): Make the prefix of the temporary
	directory absolute.
	(archive-file-name-invalid-regexp): New variable.
	(archive-zip-case-fiddle): Doc fix.
	(archive-remote): Make it permanent-local.
	(archive-member-coding-system): New variable.
	(archive-mode): Don't use write-contents-hooks for remote
	archives.  Archives whose names are invalid for the current
	filesystem are marked read-only.
	(archive-summarize): Optional argument SHUT-UP makes it silent.
	All callers changed.
	(archive-unique-fname): New function.
	(archive-maybe-copy): Use it.
	(archive-maybe-copy, archive-write-file): Bind
	coding-system-for-write to no-conversion.
	(archive-maybe-update, archive-mode-revert): Bind
	coding-system-for-read to no-conversion.
	(archive-maybe-update): Remain at the same line in the archive
	listing, after updating the archive.  Print the buffer name of the
	archive to be saved.
	(archive-extract): Mark archive members whose names are invalid as
	read-only.  Don't set buffer-file-type.  Remove the write-contents
	hook for remote archives.  Warn about read-only archives inside
	other archives.
	(archive-write-file-member): Handle remote archives.  Restore
	value of last-coding-system-used.
	(archive-*-write-file-member): Handle archives inside other
	archives.  Save the value of last-coding-system-used.
	(archive-write-file): New optional variable FILE: where to write
	the archive; defaults to buffer-file-name, for remote archives.
	(archive-zip-summarize, archive-zip-chmod-entry): Support VFAT
	type of host filesystem.
	(archive-zip-summarize): Don't fiddle letter case of mixed-case
	file names.

1998-05-14  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* emacs-lisp/advice.el (ad-handle-definition, defadvice):
	Fix error messages.

	* help.el (describe-key-briefly): When INSERT, put cmd name in `...'.

	* files.el (recover-session-finish): Unmark the current line
	so that the file being used for recovery will not get deleted.

1998-05-13  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* startup.el (locale-translation-file-name): New variable.
	(command-line): Use it to decode locale aliases.

	* emacs-lisp/disass.el (disassemble-1): Reference bytecode string
	as unibyte.

	* format.el (format-alist): Use -f when running recode.

	* emacs-lisp/bytecomp.el (byte-compile-insert-header): Fix prev chg.

	* international/mule.el (set-auto-coding): Exclude \n when
	matching the coding system name.

1998-05-12  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* type-break.el (type-break-mode-line-message-mode): Doc fix.
	Fix some messages.
	(type-break-mode): Doc fix.

	* emacs-lisp/bytecomp.el (byte-compile-from-buffer):
	Insert the output file header after compiling all the input.
	(byte-compile-output-file-form): Major cleanup.
	If output file contains multibyte chars,
	insist on Emacs 20 when loading.

	* mail/smtpmail.el (smtpmail-via-smtp): Specify process coding system.

1998-05-12  Ed Reingold  <reingold@melange.gnu.org>

	* calendar/cal-menu.el (cal-menu-update): Add separators.

1998-05-11  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* calendar/cal-menu.el (calendar-mode-map): Rename `holidays'
	menu to `Holidays'.
	(cal-menu-update): Similar renamings; change the arg to
	easy-menu-change also.  Change some item names.

	* emacs-lisp/easymenu.el (easy-menu-change): Add autoload cookie.

1998-05-11  Dave Love  <fx@gnu.org>

	* tar-mode.el (tar-subfile-mode): Call auto-save-mode with -1.

1998-05-11  Ed Reingold  <reingold@melange.gnu.org>

	* calendar/calendar.el (calendar-mode): Add hook to update holiday
	button on menu bar.
	(exit-calendar): Don't signal error when user changes mind.

	* calendar/cal-menu.el (calendar-mode-map): Remove static menu
	definition for holidays from menu bar.
	(easymenu): Require it.
	(cal-menu-update): New function.
	(cal-menu-today-holidays): New function.

1998-05-10  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* startup.el (normal-top-level-add-subdirs-to-load-path):
	Ignore subdirectories whose names start with nonalphanumeric
	or that have a file called .nosearch.

	* international/mule-cmds.el (last-coding-system-specified): New var.
	(select-safe-coding-system): Set var if user specifies a coding system.

	* international/mule.el (after-insert-file-set-buffer-file-coding-system):
	Don't make buffer unibyte unless we seem to be visiting a file.

	* mail/rmail.el (rmail-decode-babyl-format):
	Set save-buffer-coding-system instead of buffer-file-coding-system.
	Decode the whole Babyl text at once, not message by message.
	Don't alter global value of rmail-file-coding-system.
	(rmail-show-message): Set buffer-file-coding-system from
	X-Coding-System header field.
	(rmail-ignored-headers): Ignore X-Coding-System header.
	Ignore Return-Path, Errors-To, X-Attribution, X-Disclaimer.
	(rmail-convert-to-babyl-format): Record X-Coding-System header
	for each message that was converted.
	(rmail-variables): Make local binding for save-buffer-coding-system,
	and set it from buffer-file-coding-system if not already non-nil.

	* files.el (save-buffer-coding-system): New variable.
	(basic-save-buffer-1): Obey it.
	(basic-save-buffer): Set save-buffer-coding-system instead of
	buffer-file-coding-system, if save-buffer-coding-system is already
	non-nil.

	* add-log.el (add-log-current-defun): Fix previous change--skip
	tab and newline also.

1998-05-09  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* emacs-lisp/bytecomp.el (byte-compile-output-docform):
	Use position-bytes.

1998-05-09  Richard Stallman  <rms@psilocin.gnu.org>

	* disp-table.el (standard-display-european): Doc fix.

	* mail/sendmail.el (mail-signature): Allow expression as value.
	Improve prompts in custom type.  Add risky-local-variable property.
	(mail-setup): Implement that feature.

	* wid-edit.el (widgets: sexp, variable, list, vector): Doc fixes.

	* mail/mail-utils.el (mail-strip-quoted-names):
	Delete comments, then delete leading/trailing whitespace.

1998-05-08  Richard Stallman  <rms@psilocin.gnu.org>

	* ps-print.el (ps-alist-position): Renamed from ps-position.
	Look for ITEM as the car of an element.
	(ps-font-number): Use ps-alist-position.
	(ps-font-alist): Renamed from ps-font-list.

	* mail/reporter.el (reporter-bug-hook): Use rfc822-goto-eoh.

1998-05-07  Andreas Schwab  <schwab@issan.informatik.uni-dortmund.de>

	* emacs-lisp/autoload.el (generate-file-autoloads): Handle progn
	forms generated by make-autoload: print just the first subform
	with print-escape-newlines.

	* ispell.el (ispell-dictionary-alist-1): Doc fix.
	(ispell-dictionary-alist-2): Doc fix.

	* cus-edit.el (customize-group-other-window): Handle groups not
	yet loaded.  If buffer exists, use it unchanged.  Rename parameter
	and update doc string.

1998-05-07  Richard Stallman  <rms@psilocin.gnu.org>

	* emacs-lisp/edebug.el (edebug-all-forms): Add autoload cookie.
	(edebug-all-defs): Likewise.

	* ispell.el (ispell-word): Make M-$ binding using esc-map.

	* vc-hooks.el (vc-consult-rcs-headers): Fix previous change.

1998-05-07  Andrew Innes  <andrewi@harlequin.co.uk>

	* disp-table.el (standard-display-european): Don't call
	set-terminal-coding-system when window-system is w32.

1998-05-07  Erik Naggum  <erik@naggum.no>

	* emacs-lisp/find-func.el (find-function-noselect): Autoload it.

1998-05-07  Richard Stallman  <rms@psilocin.gnu.org>

	* progmodes/sh-script.el (sh-shell-file): Add cmdproxy to MS shells.

	* international/mule-diag.el (list-input-methods): Doc fix.

1998-05-07  Kenichi Handa  <handa@etl.go.jp>

	* international/ccl.el: Cancel the previous change for
	customization, customized variables are changed to constant.

1998-05-07  Richard Stallman  <rms@psilocin.gnu.org>

	* mail/emacsbug.el (report-emacs-bug): After reinserting
	the signature, leave point before it.
	Don't display *Bug Help* if report-emacs-bug-no-explanations.

	* help.el (describe-function-1): Use find-function-noselect
	instead of find-function.
	(view-lossage): Set help-xref-stack* in the help buffer.
	(describe-bindings): Likewise.
	(help-xref-go-back): New arg BUFFER.
	(help-make-xrefs): Specify the help buffer as arg for
	help-xref-go-back.

	* textmodes/sgml-mode.el (sgml-mode-common):
	Make local binding from adaptive-fill-regexp.

1998-05-06  Richard Stallman  <rms@psilocin.gnu.org>

	* international/mule-diag.el (print-coding-system):
	Handle (SYMBOL . SYMBOL) as the flags of a type 4 coding system.

	* which-func.el (which-func-non-auto-modes): New variable.
	(which-func-amodes): Variable deleted.
	(which-func-ff-hook): Use which-func-non-auto-modes instead of
	which-func-amodes.

1998-05-06  Sam Steingold  <sds@usa.net>

	* window.el (quit-window): Fixed FRAME to be the frame and
	never window.

1998-05-06  Michael Kifer  <kifer@cs.sunysb.edu>

	* ediff-init.el (ediff-highlight-all-diffs, ediff-use-faces):
	Changed the defaults.

1998-05-06  Richard Stallman  <rms@psilocin.gnu.org>

	* which-func.el (which-function-mode): New alias.

1998-05-06  Dave Love  <fx@gnu.org>

	* imenu.el (imenu-create-index-function): Remove autoload cookie
	to avoid nil default value.

1998-05-06  Andre Spiegel  <spiegel@inf.fu-berlin.de>

	* vc-hooks.el (vc-consult-rcs-headers): Avoid bug with ci -k in
	RCS 5.7.

1998-05-06  Richard Stallman  <rms@psilocin.gnu.org>

	* calendar/diary-lib.el (diary-mail-entries): Add autoload cookie.

	* dired.el (dired-mode-map): Bind *t to dired-do-toggle.

	* ps-print.el (ps-header-title-font-size): Doc fix.
	(ps-print-control-characters, ps-setup, ps-header-pad): Doc fixes.
	(ps-printing-region, ps-nb-pages): Doc fixes.

1998-05-05  Vinicius Jose Latorre  <vinicius@cpqd.com.br>

	* ps-print.el: Some doc fixes, eliminate (require cl).
	(ps-print-version): New version number (3.06.1) and doc fix.
	(ps-print-control-characters, ps-extend-face): Doc fix.
	(ps-font-lock-face-attributes): Eliminate `pop'.
	(ps-font): Eliminate `loop' and `return'.
	(ps-fonts): Eliminate `loop'.
	(ps-font-number): Replace `position' by `ps-position'.
	(ps-select-font): Eliminate `flet'.
	(ps-lookup, ps-size-scale): New macros.
	(ps-output-string-prim): Handle multibyte characters.
	(ps-position): New function.
	(ps-begin-file): Eliminate `loop'.
	(ps-header-page): Eliminate `incf'.

1998-05-05  Richard Stallman  <rms@psilocin.gnu.org>

	* mouse.el (mouse-major-mode-menu): Run activate-menubar-hook here.

	* tmm.el (tmm-get-keymap): Fix previous change;
	access the equiv string from the cache properly.

1998-05-05  Simon Marshall  <simon@gnu.org>

	* font-lock.el (lisp-font-lock-keywords-1): Fixed 1998-04-24 change;
	moved defpackage to here from lisp-font-lock-keywords-2.

1998-05-05  Andreas Schwab  <schwab@issan.informatik.uni-dortmund.de>

	* comint.el (comint-replace-by-expanded-history-before-point):
	When none of the ! or ^ constructs match, move forward one char.

1998-05-05  Richard Stallman  <rms@psilocin.gnu.org>

	* add-log.el (add-log-current-defun) <lisp>:
	If element 1 of the defun is a list, use first symbol
	within it (the car of the car.... of it).

1998-05-04  Richard Stallman  <rms@psilocin.gnu.org>

	* cus-face.el (custom-face-attributes): Doc fix.

1998-05-04  Kenichi Handa  <handa@etl.go.jp>

	* international/mule-cmds.el (toggle-input-method): Use a more
	appropriate default value while reading an input method.

1998-05-04  Michael Kifer  <kifer@cs.sunysb.edu>

	* ediff-util.el (ediff-get-lines-to-region-start):
	Protect from window-end returning the nil.
	(ediff-file-checked-in/out): Use vc-backend.
	Add dependence on vc-hooks.
	(ediff-make-bottom-toolbar): Now checks for toolbar support before
	referring toolbars.

	* ediff-wind.el (ediff-setup-control-frame):
	Now checks for toolbar support before referring toolbars.

	* ediff-init.el (ediff-has-toolbar-support-p, ediff-use-toolbar-p):
	Moved here from ???.

	* ediff-vers.el (cvs-run-ediff-on-file-descriptor):
	Set default-directory.

1998-05-04  Michael Kifer  <kifer@cs.sunysb.edu>

	* emulation/viper.el (viper-vi-state-mode-list): New variable.
	(viper-emacs-state-mode-list, viper-insert-state-mode-list): New vars.
	(viper-set-hooks): No longer uses major mode hooks to impose
	viper-mode on major modes.  Use change-major-mode-hook instead.
	(viper-major-mode-modifier-list): New variable.
	(viper-mode-string): Add defvar to avoid warning.

	* emulation/viper-util.el, emulation/viper-cmd.el (viper-add-hook)
	(viper-remove-hook): Functions deleted.  Use add/delete-hook instead.
	(viper-file-checked-in, viper-file-checked-out): New functions.

	* emulation/viper-init.el: Use make-local-hook for viper's local hooks.
	(viper-minibuffer-exit-hook): Make initially nil.

	* emulation/viper-cmd.el (viper-find-char): Now works in multiline mode.

	* emulation/viper-ex.el (viper-get-ex-pat): Fix delimiter handling.
	(ex-edit): Handle file names that have spaces in them.
	(viper-ex): Check for writing into a checked in file.
	(ex-substitute): Allow newlines in substitutions.
	(viper-ex): Bug fix.

1998-05-04  Richard Stallman  <rms@psilocin.gnu.org>

	* server.el (server-buffer-done): Bind server-kill-buffer-running
	around places that might kill the buffer.
	Do something reasonable if server-done-hook kills the buffer.
	(server-kill-buffer-running): Doc fix.
	(server-kill-buffer): Do nothing unless server-buffer-clients.
	(server-done): Doc fix.

	* server.el (server-buffer-done): Test of for-killing was backwards.

1998-05-04  Eli Zaretskii  <eliz@mescaline.gnu.org>

	* follow.el (follow-intercept-processes): When asynchronous
	subprocesses aren't supported, default to nil.

1998-05-04  Andreas Schwab  <schwab@delysid.gnu.org>

	* progmodes/compile.el (compilation-directory-stack): Doc fix.
	(compilation-mode): Accept optional parameter and initialize
	mode-name from it.
	(compile-internal): Pass name-of-mode to compilation-mode.  Don't
	set mode-name here.
	(compilation-minor-mode): Don't let mode-line-process change.
	(compilation-next-error-locus): Use forward-char instead of
	move-to-column.
	(compilation-parse-errors): Set default-directory from head of
	compilation-directory-stack.

1998-05-03  Dave Love  <d.love@dl.ac.uk>

	* add-log.el (add-log-current-defun): Fix previous fortran change.

1998-05-03  Richard Stallman  <rms@psilocin.gnu.org>

	* generic.el (generic-make-keywords-list): Delete spurious paren.

	* add-log.el (add-log-debugging): New variable.
	(add-change-log-entry): Set it.

1998-05-03  Erik Naggum  <erik@naggum.no>

	* emacs-lisp/shadow.el (list-load-path-shadows): Don't say
	anything, if we are not interactive and nothing is wrong.

1998-05-03  Eli Zaretskii  <eliz@mescaline.gnu.org>

	* progmodes/sh-script.el (sh-shell-file): If $SHELL evaluates to
	one of MS-DOS or MS-Windows shells, use "bin/sh" instead.

1998-05-03  Richard Stallman  <rms@psilocin.gnu.org>

	* Makefile (TAGS-LISP): New target.
	(lisptagsfiles1, lisptagsfiles2): New variables.
	(TAGS, TAGS-LISP): Use lisptagsfiles1, lisptagsfiles2.

	* mail/mh-e.el (mh-quit): Undo 3/3 change (and the subsequent fix).

1998-05-02  Richard Stallman  <rms@psilocin.gnu.org>

	* startup.el (command-line): When choosing a language from LANG,
	call set-language-environment in unibyte and multibyte mode.
	Don't call standard-display-european; instead, call
	standard-display-european-internal and set-terminal-coding-system.
	But do them only for latin-1 ... latin-5.

1998-05-02  Dan Nicolaescu  <done@ece.arizona.edu>

	* menu-bar.el (menu-bar-custom-menu): Add an entry for Changed
	Options.

1998-05-02  Richard Stallman  <rms@psilocin.gnu.org>

	* info.el (Info-up): New arg SAME-FILE: don't move to different file.
	(Info-next-preorder): Pass new arg to Info-up.
	(Info-last-preorder): Likewise.
	(Info-last-preorder): Don't follow the Prev if it's same as the Up.
	Instead, follow it as the Up.

1998-05-02  Andre Spiegel  <spiegel@inf.fu-berlin.de>

	* vc-hooks.el (vc-parse-cvs-status): Optimized.  Ignore
	"Locally Removed" files.

	* vc.el (vc-fetch-cvs-status): Don't specify DIR on the command line.
	(vc-dired-hook): Optimized for CVS.

1998-05-02  Richard Stallman  <rms@psilocin.gnu.org>

	* apropos.el (apropos-mode-map): Bind q to quit-window.

1998-05-01  Sam Steingold  <sds@usa.net>

	* mail-utils.el (rmail-default-dont-reply-to-names):
	Don't set the variable in this file.

1998-05-01  Erik Naggum  <erik@naggum.no>

	* simple.el (rfc822-goto-eoh): Stop at a blank line, too.

1998-05-01  Stephen Eglen  <stephen@gnu.org>

	* calendar/diary-lib.el (diary-mail-entries): Write year in subject
	line using four digits, not two.

1998-05-01  Carsten Dominik  <cd@delysid.gnu.org>

	* textmodes/reftex.el: Added :version tags to defcustom.

1998-05-01  Andrew Hall  <ahall@fmrco.com>

	* paren.el (show-paren-ring-bell-on-mismatch): New option.
	(show-paren-function): Beep on mismatch, if requested.

1998-04-30  Milan Zamazal  <pdm@fi.muni.cz>

	* language/czech.el (setup-czech-environment):
	Call latin-2's setup function.
	* language/slovak.el (setup-slovak-environment):
	Call latin-2's setup function.

1998-04-30  Geoff Voelker  <voelker@cs.washington.edu>

	* w32-win.el (w32-drag-n-drop-debug, w32-drag-n-drop)
	(w32-drag-n-drop-other-frame): New functions.
	Bind them to the drag-n-drop events.

1998-04-30  Peter Breton  <pbreton@ne.mediaone.net>

	* filecache.el (file-cache-add-file): Checks to see if file exists
	before adding it.  Non-existing files are simply skipped.
	(file-cache-add-directory): Checks to see if directory exists
	before adding it.  Non-existing directories are simply skipped.

	* generic.el (generic): Added defgroup declaration.
	(generic-make-keywords-list): Uses regexp-opt.
	(generic-mode-set-font-lock): Uses regexp-opt.

	* generic-x.el (generic-x): Added defgroup declaration.

	* generic-x.el (generic-bat-mode-setup-function): Fixed comment-start
	variable.

	* generic-x.el (generic-define-mswindows-modes): Enable
	hosts-generic-mode and apache-generic-mode.
	(generic-define-unix-modes): Enable alias-generic-mode.
	(java-properties-generic-mode): Changed regexp to allow property
	and value to be separated by whitespace or an equal sign.
	(alias-generic-mode): Check generic-extras-enable-list before
	defining this mode.

	* generic-x.el (installshield-statement-keyword-list): New variable.
	(installshield-system-functions-list): Likewise.
	(installshield-system-variables-list): Likewise.
	(installshield-types-list): Likewise.
	(installshield-funarg-constants-list): Likewise.
	(rul-generic-mode): Uses the variables listed above instead of
	hard-coding the lists of keywords.

1998-04-30  Richard Stallman  <rms@psilocin.gnu.org>

	* emacs-lisp/lmenu.el (popup-menu-popup): Fix typo: set menu-keymap.

1998-05-01  Kenichi Handa  <handa@etl.go.jp>

	* international/mule-cmds.el (find-coding-systems-for-charsets):
	Consider priority of each coding system too.
	(select-safe-coding-system): Show mime-charset name (if it is also
	a coding system) instead of base coding system name.
	(select-safe-coding-system): Always delete *Warning* buffer.
	(universal-coding-system-argument): Use buffer-file-coding-system
	as default.

	* international/quail.el (quail-show-translations): Show
	followable keys in alphabetic order.

1998-04-29  Richard Stallman  <rms@psilocin.gnu.org>

	* progmodes/cperl-mode.el (perl-mode):
	Do not alias this to cperl-mode.

	* progmodes/perl-mode.el (perl-mode): Add autoload cookie.

1998-04-29  Eric S. Raymond  <esr@snark.thyrsus.com>

	Many small changes that mostly eliminate the explicit mail separator
	variable and use the new rfc822-goto-eoh primitive instead:

	* ispell4.el (ispell-message): Use rfc822-goto-eoh.

	* language/ethio-util.el (ethio-sera-to-fidel-mail):
	Use rfc822-goto-eoh.
	(ethio-fidel-to-sera-mail): Likewise.

	* mail/rnewspost.el (news-reply-mode): Don't load sendmail here.
	Don't set paragraph-start or paragraph-separate.
	(news-setup): Set them here.
	(news-inews): Use mail-header-end, etc.
	Use mail-sendmail-delimit-header at the end.

	* mail/emacsbug.el (report-emacs-bug): Use rfc822-goto-eoh.

	* mail/mail-hist.el: Require sendmail.
	(mail-hist-current-header-name): Use mail-text-start.
	(mail-hist-forward-header): Use mail-header-end.
	(mail-hist-current-header-contents): Use mail-header-start.
	(mail-hist-put-headers-into-history): Use mail-text-start.

	* mail/mailalias.el (expand-mail-aliases): Doc fix.
	(expand-mail-aliases, mail-complete): Use mail-header-end.

	* mail/mailabbrev.el (mail-abbrev-in-expansion-header-p):
	Use mail-header-end.

	* mail/mailpost.el (post-mail-send-it):
	Use mail-sendmail-undelimit-header.

	* mail/reporter.el (reporter-calculate-separator): Function deleted.
	(reporter-submit-bug-report): Major rewrite.

	* mail/rmail.el (rmail-forward): Use mail-text-start.
	(rmail-resend): Don't bind mail-header-separator.
	(rmail-retry-failure): Use mail-send-delimit-header, etc.

	* mail/rnews.el: Require sendmail.
	(news-caesar-buffer-body): Use mail-text-start.

	* mail/smtpmail.el (smtpmail-send-it):
	Use mail-sendmail-undelimit-header.

	* mail/supercite.el: Require sendmail.el.
	(sc-no-blank-line-or-header): Use mail-header-end.

	* mail/uce.el (uce-reply-to-uce): Use mail-sendmail-delimit-header.

	* simple.el (rfc822-goto-eoh): New function.
	(sendmail-user-agent-compose): Use rfc822-goto-eoh.

	* mail/sendmail.el (send-mail-function): Doc fix.
	(mail-header-end, mail-text-start): New functions.
	(mail-sendmail-delimit-header): New function.
	(mail-sendmail-undelimit-header): New function.
	(mail-mode-auto-fill): Use mail-header-end.
	(mail-mode-fill-paragraph, mail-send, sendmail-send-it): Likewise.
	(mail-sent-via, mail-position-on-field): Likewise.
	(mail-fill-yanked-message, mail-text): Use mail-text-start.

1998-04-29  Dave Love  <d.love@dl.ac.uk>

	* imenu.el (imenu--generic-function): Doc fix.  Rewritten to be faster.
	(defgroup imenu): Add :link.
	(imenu-use-markers, imenu-auto-rescan-maxout)
	(imenu-generic-expression, imenu--make-index-alist)
	(imenu-default-goto-function): Doc fix.
	(imenu-max-item-length, imenu-sort-function)
	(imenu-scanning-message): Custom tweak.
	(imenu-progress-message): Use real backquote syntax.
	(imenu--in-alist): Unused function deleted.
	(imenu--flatten-index-alist): Likewise.
	(imenu-case-fold-search): Add autoload cookie.
	(imenu--completion-buffer): Offer function at point as default.
	(imenu--subalist-p): Don't use caadr.
	(imenu): Don't use caddr.
	(imenu-add-menubar-index): New function.

1998-04-29  Dave Love  <fx@gnu.org>

	* tar-mode.el (tar-mode-write-file): Protect from null
	tar-header-offset.

1998-04-29  Andrew Innes  <andrewi@harlequin.co.uk>

	* tar-mode.el (tar-extract): Use `!' instead of `:' to construct
	buffer-file-name (`:' is invalid in file names on Windows).

1998-04-29  Richard Stallman  <rms@psilocin.gnu.org>

	* ange-ftp.el (ange-ftp-real-expand-file-name-actual):
	Locally bind old-name, new-name, final, drive-letter.

	* ielm.el (*, **, ***): Add defvars.

	* dired.el (dired-sort-toggle): Handle spaces in dired-actual-switches.

1998-04-29  Ken Stevens  <stevens@kdstevens.com>

	* ispell.el: Generalized region skipping added.
	Checks comments only in code.
	Added backward compatible support for customize.
	(ispell-query-replace-choices, ispell-message-dictionary-alist)
	(ispell-grep-command, ispell-grep-options, ispell-look-command)
	(ispell-look-options, ispell-use-ptys-p, ispell-local-dictionary)
	(ispell-dictionary-alist): Now customizable.
	Fixed type of custom variables: ispell-help-in-bufferp.
	(ispell-use-framepop-p): New variable.
	(ispell-dictionary-alist): Added dictionaries: castellano, castellano8
	czech, esperanto, esperanto-tex, norsk, russian.
	Capitalize XEmacs correctly, and change lucid to xemacs in code.
	(ispell-menu-lucid): Renamed to ispell-menu-xemacs.
	Changed string compares for version number to be correct for XEmacs.
	Fixed to work with string properties.
	(ispell-recursive-edit-marker): New marker saving return point.
	(ispell-skip-region-alist): New variable defining regions.
	(ispell-tex-skip-alists): New variable for LaTeX regions.
	(ispell-skip-sgml): Now buffer-mode aware.
	(ispell-highlight-p): Support block cursors.
	(ispell-message-text-end): Don't check signatures.
	(ispell-comments-and-strings): New command, added to menu.
	(ispell-int-char): New function for character incrementing.
	(ispell-word): Produces message on error when called from
	ispell-minor-mode.  Potential infinite loop removed.
	(ispell-command-loop): prevent XEmacs modeline hiding.
	Allow temporary split of dedicated windows.  Improve recursive
	edit support.  Support block cursors.
	(ispell-show-choices): New function cleaning up command loop.
	(ispell-highlight-spelling-error-generic): Block cursor support added.
	(ispell-highlight-spelling-error-xemacs): Block cursor, name change.
	(ispell-overlay-window): dedicated window splitting, XEmacs changes.
	(ispell-parse-output): Displays ispell process error messages.
	(check-ispell-version): Interactive mode that shows ispell versions.
	(ispell-begin-skip-region-regexp): New region skipping function.
	(ispell-begin-tex-skip-regexp): New tex mode region skipping function.
	(ispell-begin-skip-region): New region skipping function.
	(ispell-tex-arg-end): New tex mode region skipping function.
	(ispell-skip-region): New region skipping function.
	(ispell-get-line): New function to clean up command loop.
	(ispell-process-line): New function cleaning up command loop.
	(ispell-continue): Improve recursive editor support.
	(ispell-complete-word): Interior fragment support improved.
	(ispell-message): Region skipping vastly improved.

1998-04-28  Eli Zaretskii  <eliz@mescaline.gnu.org>

	* ps-print.el (ps-output-string-prim): Don't quote multibyte
	characters.

1998-04-28  Richard Stallman  <rms@psilocin.gnu.org>

	* ps-print.el (ps-remove-duplicates): New function.
	(ps-begin-file): Use it.

	* progmodes/compile.el (compilation-initial-position): New option.
	(compile-internal): Obey it.

1998-04-28  Dave Love  <fx@gnu.org>

	* info.el (Info-mode): Doc fix.

	* finder.el (finder-insert-at-column): Simplify.
	(finder-mouse-face-on-line): New function.
	(finder-list-keywords, finder-list-matches): Use it.
	(finder-commentary, finder-select): Doc.
	(finder-mouse-select): Doc.  Remove spurious let.

1998-04-28  Richard Stallman  <rms@psilocin.gnu.org>

	* mail/rmailedit.el (rmail-cease-edit):
	Call rmail-show-message even if message text is unchanged.

1998-04-28  Inge Frick  <inge@nada.kth.se>

	* emacs-lisp/easymenu.el (easy-menu-define-key): Fixed bug with BEFORE
	argument.  Now it works also if you repeat an identical call to
	easy-menu-define-key.

1998-04-27  Richard Stallman  <rms@psilocin.gnu.org>

	* window.el (quit-window): Don't try to switch buffers
	in a dedicated window or a minibuffer window.
	Treat minibuffer window as dedicated in other ways too.

	* ielm.el (ielm-eval-input): More of previous change.

	* ps-print.el (ps-remove-duplicates): New function.
	(ps-begin-file): Use that instead of remove-duplicates.

	* isearch.el (isearch-yank-x-selection): Doc fix.

	* widget.el (define-widget-keywords): Don't use backquote.

	* view.el (view-really-at-end): Undo previous change.

1998-04-26  Richard Stallman  <rms@psilocin.gnu.org>

	* simple.el (assoc-ignore-representation): New function.
	(assoc-ignore-case): Use compare-strings.

	* textmodes/outline.el (outline-discard-overlays):
	Interpret PROP as a value for `invisible', not as property name.

	* textmodes/sgml-mode.el (sgml-font-lock-keywords-1):
	Copy initialization from sgml-font-lock-keywords.
	(sgml-font-lock-keywords): Initialize from sgml-font-lock-keywords-1.
	(sgml-font-lock-keywords-2): New variable.
	(sgml-mode-common): Make buffer-local binding for
	sgml-font-lock-keywords-2 and initialize it.
	Use it in font-lock-defaults.

	* ielm.el (ielm-eval-input): Use variables *, **, *** not :, ::, :::.
	(inferior-emacs-lisp-mode): Corresponding changes.

	* language/european.el (setup-8-bit-environment):
	Don't do anything special here for unibyte mode.
	That is done in set-language-environment.

	* international/mule-cmds.el (set-language-environment):
	Fix previous change.  Call standard-display-european-internal.
	Call set-terminal-coding-system.
	(standard-display-european-internal): New subroutine.

	* disp-table.el (standard-display-european):
	Use set-language-environment
	instead of loading a syntax definitions file.
	Use standard-display-european-internal.
	Let current-language-environment specify terminal coding system.

	* files.el (set-auto-mode): When just-from-file-name is set, don't
	actually switch modes if the new mode is the same as the current one.

	* view.el (view-mode-exit): Don't alter view-return-to-alist.

1998-04-25  Richard Stallman  <rms@psilocin.gnu.org>

	* international/mule-cmds.el (set-language-environment):
	Check for language environments that can't work in unibyte.

	* language/european.el (setup-8-bit-environment):
	Test of default-enable-multibyte-characters was backwards.

	* view.el (view-mode-enter, view-mode-exit): Doc fixes.

1998-04-24  Richard Stallman  <rms@psilocin.gnu.org>

	* Makefile (custom-deps, updates): Allow cus-dep to be used compiled.
	(custom-deps, autoloads, finder-data, updates): Print list of dirs.

	* finder.el (finder-compile-keywords):
	Avoid error for nonexistent directory.
	Ignore files that are actually Emacs lock files.

	* emacs-lisp/copyright.el (copyright-regexp):
	Move \251 before the multibyte copyright symbol.

	* cus-dep.el (custom-make-dependencies): Don't give up
	on a whole file, the first time eval gets an error.

	* Makefile (custom-deps): Ignore =... subdirs.

	* mail/mailalias.el (mail-complete-alist):
	Don't refer to mail-address-field-regexp.

	* add-log.el (change-log-mode): Undo previous change.

1998-04-24  Sam Steingold  <sds@usa.net>

	* emacs-lisp/cl-indent.el: Indent defpackage correctly.

	* font-lock.el (lisp-font-lock-keywords-2): Added `defpackage'.

1998-04-23  Geoff Voelker  <voelker@cs.washington.edu>

	* dired.el (dired-chmod-program) [windows-nt]: Use chmod.

1998-04-23  Andrew Innes  <andrewi@harlequin.co.uk>

	* scroll-bar.el (scroll-bar-mode, toggle-scroll-bar): By default,
	put scroll bars on the right on MS-Windows (since that is the
	convention on Windows).

1998-04-23  Richard Stallman  <rms@psilocin.gnu.org>

	* ffap.el (dired-at-point): Add autoload cookie.

1998-04-23  Jens-Ulrik Petersen  <petersen@kurims.kyoto-u.ac.jp>

	* ffap.el (dired-at-point-require-prefix): New option.
	(dired-at-point): New command.
	(dired-at-point-prompter): New function.

1998-04-23  Inge Frick  <inge@nada.kth.se>

	* easymenu.el: Use new menu item format.  Don't simulate button prefix.
	(easy-menu-create-menu): Understand also keywords :active,
	:label and :visible.  Don't worry about button prefix.
	(easy-menu-button-prefix): Modified value.
	(easy-menu-do-add-item): Extensive changes to use new menu item format.
	(easy-menu-define-key, easy-menu-always-true): New functions.
	(easy-menu-make-symbol): Don't use indirection for symbols.  Property
	`menu-alias' not set.
	(easy-menu-filter, easy-menu-update-button): Deleted.
	(easy-menu-add-item): Don't worry about button prefix.
	(easy-menu-remove-item): Don't worry about button prefix.  Use
	`easy-menu-define-key'.
	(easy-menu-is-button, easy-menu-have-button): Deleted.
	(easy-menu-real-binding, easy-menu-change-prefix): Deleted.

1998-04-23  Richard Stallman  <rms@psilocin.gnu.org>

	* international/mule.el (load-with-code-conversion):
	Don't pass extra arg to eval-buffer.
	(set-auto-coding): Doc fix.

1998-04-23  Eli Zaretskii  <eliz@is.elta.co.il>

	* frame.el (frame-name-alist): Remove this variable.
	(select-frame-by-name): Recompute the list of frames instead of
	saving it in a global variable.

1998-04-23  Dave Love  <fx@gnu.org>

	* delsel.el: Don't require cl.  Minor doc fixes.
	(insert-parentheses): Add `delete-selection' property.
	(delete-selection-pre-hook): Simplify slightly.

	* add-log.el (change-log-mode): Add `* ' to paragraph-start.

1998-04-22  Richard Stallman  <rms@sucrose.gnu.org>

	* comint.el (comint-replace-by-expanded-history): New arg START.
	Don't display a message about doing history expansion.
	(comint-replace-by-expanded-history-before-point): New arg START.
	(comint-send-input): Pass START to comint-replace-by-expanded-history.

1998-04-22  Richard Stallman  <rms@psilocin.gnu.org>

	* language/european.el (setup-8-bit-environment):
	If default-enable-multibyte-characters is nil,
	call standard-display-european, and don't set nonascii-insert-offset
	or default-input-method.

	* language/english.el (setup-english-environment):
	Don't set default-enable-multibyte-characters.

1998-04-22  Eli Zaretskii  <eliz@delysid.gnu.org>

	* term/pc-win.el (x-select-text, x-get-selection-value): Replace
	win16 with w16.

1998-04-22  Dave Love  <fx@gnu.org>

	* help.el (help-mode-map): Add S-tab, like backtab.

1998-04-22  Stephen Eglen  <stephen@gnu.org>

	* iswitchb.el: Only require cl if cadr and last are not defined.

1998-04-22  Richard Stallman  <rms@psilocin.gnu.org>

	* mail/rmail.el (rmail): Don't bind enable-local-variables.

1998-04-21  Richard Stallman  <rms@psilocin.gnu.org>

	* info.el (Info-fontify-node): For menu items, use info-xref font.
	Use info-node font for the node's own name,
	and do not make it mouse-sensitive.

	* international/encoded-kb.el (encoded-kbd-mode): Doc fix.

	* help.el (help-highlight-face): Use `face' as custom type.

1998-04-21  Dave Love  <fx@gnu.org>

	* which-func.el: Fix header comments.
	(which-func-mode): Add autoload cookie.
	(which-func-mode-global): Customize.

	* subr.el (remove-hook): Fix spurious quote.

	* help.el (describe-function-1): Make hyperlink to library file
	name, if available.

1998-04-21  Richard Stallman  <rms@psilocin.gnu.org>

	* info.el (Info-find-node): Update Info-history after switching buffer.
	(info): If no arg, and *info* buffer exists, just go to it
	and don't alter it.

	* emacs-lisp/easymenu.el (easy-menu-do-add-item):
	Do the right thing when nil is specified as criterion for activeness.
	Fix string used to report an invalid item.

	* tmm.el (tmm-get-keymap): Handle new format menu item w/o cache.
	(tmm-prompt): If reach an empty menu, get an error.

1998-04-20  Per Starbäck  <starback@update.uu.se>

	* dired.el (dired-move-to-filename-regexp): There might be a space
	after the year instead of before it.

1998-04-20  Richard Stallman  <rms@psilocin.gnu.org>

	* emacs-lisp/bytecomp.el (byte-compile-file):
	Always read the file in multibyte mode
	unless the file itself specifies unibyte mode.

	* international/mule-conf.el (file-coding-system-alist):
	Use emacs-mule for .elc files.

	* emacs-lisp/cl-macs.el (cl-do-arglist): Undo previous change.

1998-04-20  Piet van Oostrum  <piet@cs.ruu.nl>

	* smtpmail.el (smtpmail-send-it): Deleted all code related
	to Resent-To: processing.
	(smtpmail-deduce-address-list): Changed the search for
	Resent-\(To\|Cc\|Bcc\) headers.
	(smtpmail-do-bcc): Delete Resent-Bcc: headers.

1998-04-20  Sam Steingold  <sds@usa.net>

	* mouse.el (mouse-buffer-menu-mode-mult): New variable.
	(mouse-buffer-menu): Obey mouse-buffer-menu-mode-mult.
	Also avoid some consing.

1998-04-20  Andreas Schwab  <schwab@delysid.gnu.org>

	* view.el (view-really-at-end): Return true when at end and not
	reverting.

1998-04-20  Richard Stallman  <rms@psilocin.gnu.org>

	* international/mule.el (load-with-code-conversion):
	Undo previous change.  Instead, pass the UNIBYTE arg to eval-buffer.

1998-04-20  Werner Lemberg  <wl@gnu.org>

	* textmodes/fill.el (justify-current-line):
	Use new algorithm to apportion the spaces to be added.

1998-04-19  Dan Nicolaescu  <done@ece.arizona.edu>

	* language/romanian.el: Add coding: tag.

	* bindings.el (debug-ignored-errors): Add an error from cus-edit.el.

	* time.el (display-time-mode): Add :version.
	* hscroll.el (hscroll-global-mode):
	* type-break.el (type-break-mode):
	* avoid.el (mouse-avoidance-mode):
	* rsz-mini.el (resize-minibuffer-mode):
	* mail/mailabbrev.el (mail-abbrevs-mode):
	* gnus/gnus-art.el (gnus-show-traditional-method)
	(gnus-article-hide-pgp-hook):
	* international/ccl.el (ccl-extended-code-table):
	* progmodes/octave-mod.el (octave-auto-indent):
	* calendar/diary-lib.el (diary-mail-addr, diary-mail-days)
	(diary-unknown-time):
	* emacs-lisp/debug.el (debugger-mode-hook)
	(debugger-record-buffer):
	* progmodes/sh-script.el (sh-imenu-generic-expression):
	* cus-edit.el (custom-variable-default-form)
	(custom-face-default-form):
	* desktop.el (desktop-enable):
	* dabbrev.el (dabbrev-ignored-buffer-names):
	* hexl.el (hexl-follow-ascii):
	* progmodes/etags.el (find-tag-marker-ring-length):
	* replace.el (query-replace-to-history-variable)
	(query-replace-from-history-variable):
	* vc-hooks.el (vc-ignore-vc-files):
	* vc.el (vc-default-init-version):
	* vcursor.el (vcursor-interpret-input, vcursor-string):
	* frame.el (focus-follows-mouse):
	* mail/rmail.el (rmail-movemail-flags): Likewise.

1998-04-20  Kenichi Handa  <handa@etl.go.jp>

	* international/ccl.el (ccl-compile-unify-character): Inhibit
	unification tables specified by integer value.
	(ccl-compile-translate-single-map): Likewise.
	(ccl-compile-multiple-map-function): Likewise.
	(ccl-compile-translate-multiple-map): Modified for nested tables.
	(ccl-dump-iterate-multiple-map): Handle the case that ID is not
	integer.
	(ccl-dump-translate-multiple-map): Likewise.
	(ccl-dump-translate-single-map): Likewise.
	(declare-ccl-program): New optional arg VECTOR.
	(check-ccl-program): New macro.

	* international/mule.el (make-coding-system): If TYPE is 4, FLAGS
	can be a cons of CCL-PROGRAM symbols.

	* international/quail.el (quail-start-translation): Bind
	prefix-arg to current-prefix-arg.
	(quail-mode): Doc-string modified.

	* language/cyrillic.el: FLAGS arguments for make-coding-system
	changed.

	* language/romanian.el: Set t to `documentation' info for Romanian.

	* language/vietnamese.el: FLAGS arguments for make-coding-system
	changed.

1998-04-19  Dan Nicolaescu  <done@ece.arizona.edu>

	* speedbar.el (speedbar): Add :version.

1998-04-18  Geoff Voelker  <voelker@cs.washington.edu>

	* makefile.nt (interdontcompile): New macro.
	(install): Copy uncompiled files from international subdir.

1998-04-18  Dave Love  <fx@gnu.org>

	* array.el (array-mode): Add autoload cookie.

	* ph.el (ph-install-menu): Use easy-menu-create-menu, not
	easy-menu-create-keymaps.

	* add-log.el (change-log-mode): Revert 1997-12-03 doc change.
	(add-change-log-entry): Replace 1997-12-03 changes with simple
	implementation of add-log-keep-changes-together.  Doc fix.
	(change-log-add-make-room): Function deleted.
	(add-change-log-entry-other-window, change-log-mode)
	(add-log-keep-changes-together): Doc fix.
	(add-log-lisp-like-modes): Add dsssl-mode.
	(add-log-current-defun): Generalize Fortran case.

	* progmodes/scheme.el (scheme-imenu-generic-expression)
	(dsssl-imenu-generic-expression): Remove leading space in submenus.

1998-04-18  Dan Nicolaescu  <done@delysid.gnu.org>

	* which-func.el (which-func): Add defgroup.

	* emacs-lisp/checkdoc.el (checkdoc): Added :version.

	* play/gametree.el (gametree): Likewise.

	* progmodes/vhdl-mode.el (vhdl): Likewise.
	Don't require hideshow, not needed.

1998-04-18  Dan Nicolaescu  <done@ece.arizona.edu>

	* cus-edit.el (customize-changed-options): Add support for showing
	groups with a :version option.
	It's recommended that all new packages added to the distribution
	contain a :version option in the toplevel defgroup.

1998-04-18  Stephen Eglen  <stephen@gnu.org>

	* international/ccl.el, international/iso-ascii.el: Customized.
	* international/iso-acc.el, international/ogonek.el: Customized.

1998-04-18  Richard Stallman  <rms@psilocin.gnu.org>

	* ange-ftp.el (file-name-handler-alist): Fix previous change.

	* emacs-lisp/edebug.el (edebug-compute-previous-result):
	Don't pass floating value to single-key-description.

1998-04-17  Richard Stallman  <rms@psilocin.gnu.org>

	* ps-print.el (ps-output-string-prim): Use skip-chars-forward.

	* info.el (Info-menu): Allow extra spaces at start of menu item.
	(Info-extract-menu-item): Likewise.
	(Info-insert-dir, Info-complete-menu-item, Info-index): Likewise.
	(Info-try-follow-nearest-node, Info-find-emacs-command-nodes): Likewise.
	(Info-fontify-node, Info-speedbar-buttons): Likewise.

	* mail/rmail.el (rmail-message-regexp-p):
	Handle unreformatted messages for real.
	(rmail-message-recipients-p): Undo previous change.

	* international/mule.el (load-with-code-conversion):
	Don't bind default-enable-multibyte-characters to t.

	* bindings.el (debug-ignored-errors): Add and remove strings.

1998-04-17  Geoff Voelker  <voelker@cs.washington.edu>

	* jka-compr.el (jka-compr-use-shell) [ms-dos, windows-nt]: Do not
	use a shell.
	(jka-compr-temp-name-template) [ms-dos, windows-nt]: Check common
	locations for tmp directory.

1998-04-17  Stephen Eglen  <stephen@gnu.org>

	* emulation/tpu-edt.el, emulation/tpu-extras.el: Customize.
	emulation/vip.el: Customize.

1998-04-17  Dan Nicolaescu  <done@delysid.gnu.org>

	* language/romanian.el (setup-romanian-environment): Change the
	input method to latin-2-postfix.
	Save the file using iso-2022-7bit encoding.

1998-04-17  Geoff Voelker  <voelker@cs.washington.edu>

	* ange-ftp.el (ange-ftp-tmp-name-template) [windows-nt]: Look for
	common temp directories.
	(ange-ftp-parse-netrc-group): Skip carriage returns.
	(ange-ftp-expand-file-name): Handle files with drive letters.
	(ange-ftp-write-region): Don't treat as unix.
	(ange-ftp-insert-file-contents): Determine file type by transfer mode.
	(ange-ftp-copy-file-internal): Don't treat as unix.
	(ange-ftp-file-name-all-completions): Handle Windows filenames.
	(file-name-handler-alist) [windows-nt]: Add patterns for name with
	drive letters.
	(ange-ftp-dired-call-process, ange-ftp-call-chmod): Use
	dired-chmod-program.
	(ange-ftp-disable-netrc-security-check) [windows-nt]: Disable by
	default.
	(ange-ftp-real-expand-file-name-actual): New function.

	* comint.el (comint-filename-chars): Combine DOS and Windows strings.

	* fast-lock.el (fast-lock-cache-name): Replace '\' with '#'.

	* files.el (path-separator): Delete variable.

	* ls-lisp.el (ls-lisp-dired-ignore-case): New variable.
	(ls-lisp-handle-switches): Obey ls-lisp-dired-ignore-case.

	* shell.el (shell-file-name-chars): Add ',' and ':'.

	* makefile.nt (install): Copy elisp files that are not compiled.
	(clean): Delete patch scratch files in all subdirectories.

	* w32-fns.el (w32-system-shells): Add 4dos and 4nt.
	(w32-allow-system-shell, w32-valid-locales): New variable.
	(w32-check-shell-configuration): Make interactive.
	Obey w32-allow-system-shell.
	(w32-get-valid-locale-ids, w32-list-locales): New functions.
	(w32-init-info): Fix relative path to info directory.

1998-04-16  Ilya Zakharevich  <ilya@math.ohio-state.edu>

	* progmodes/cperl-mode.el (cperl-style-alist):
	New variable, since `c-mode' is no longer loaded.
	- (Somebody who uses the styles should check that they work OK!)
	- (a lot of work is needed, especially with new
	  `cperl-fix-line-spacing').
	Old value of style is memorized when choosing a new style, may be
	restored from the same menu.
	(cperl-perldoc, cperl-pod-to-manpage): New commands; thanks to
	Anthony Foiani <afoiani@uswest.com> and Nick Roberts
	<Nick.Roberts@src.bae.co.uk>.
	(`Perl doc', `Regexp'): New submenus (latter to allow short displays).
	(cperl-clobber-lisp-bindings): New cfg variable.
	(cperl-find-pods-heres): $a->y() is not y///.
	(cperl-after-block-p): Add save-excursion.
	(cperl-init-faces): Was failing.
	Init faces when loading `ps-print'.
	(cperl-toggle-autohelp): New command.
	(cperl-electric-paren): `while SPACE LESS' was buggy.
	(cperl-init-faces): `-text' in `[-text => 1]' was not highlighted.
	(cperl-after-block-p): Was FALSE after `sub f {}'.
	(cperl-electric-keyword): `foreachmy', `formy' expanded too,
	Expands `=pod-directive'.
	(cperl-linefeed): Behaves reasonable in POD-directive lines.
	(cperl-message-electric-keyword): New cfg variable.
	(cperl-electric-keyword): Print a message, governed by
	`cperl-message-electric-keyword'.
	(cperl-electric-paren): Typing `}' was not checking for being
	block or not.
	(cperl-beautify-regexp-piece): Did not know about lookbehind;
	finding *which* level to work with was not intuitive.
	(cperl-beautify-levels): New command.
	(cperl-electric-keyword): Allow here-docs contain `=head1'
	and friends for keyword expansion.
	Fix for broken `font-lock-unfontify-region-function'.  Should
	preserve `syntax-table' properties even with `lazy-lock'.
	(cperl-indent-region-fix-else): New command.
	(cperl-fix-line-spacing): New command.
	(cperl-invert-if-unless): New command (C-c C-t and in Menu).
	(cperl-hints): Mention 20.2's goods/bads.
	(cperl-extra-newline-before-brace-multiline): Started to use it.
	(cperl-break-one-line-blocks-when-indent): New cfg variable.
	(cperl-fix-hanging-brace-when-indent): New cfg variable.
	(cperl-merge-trailing-else): New cfg variable.
	Workaround for another `font-lock's `syntax-table' text-property bug.
	`zerop' could be applied to nil.
	At last, may work with `font-lock' without setting `cperl-font-lock'.
	(cperl-indent-region-fix-constructs): Renamed from
	`cperl-indent-region-fix-constructs'.
	(cperl-fix-line-spacing): Could be triggered inside strings, would not
	know what to do with BLOCKs of map/printf/etc.
	(cperl-merge-trailing-else): Handle `continue' too.
	(cperl-fix-line-spacing): Likewise.
	(cperl-calculate-indent): Knows about map/printf/etc before {BLOCK};
	treat after-comma lines as continuation lines.
	(cperl-mode): `continue' made electric.
	(cperl-electric-keyword): Electric `do' inserts `do/while'.
	(cperl-fontify-syntaxically): New function.
	(cperl-syntaxify-by-font-lock): New cfg variable.
	Make syntaxification to be autoredone via `font-lock',
	switched on by `cperl-syntaxify-by-font-lock', off by default so far.
	Remove some commented out chunks.
	(cperl-set-style-back): Old value of style is memorized when
	choosing a new style, may be restored from the same menu.
	Mode-documentation added to micro-docs.
	(cperl-praise): Updated.
	(cperl-toggle-construct-fix): New command.  Added on C-c C-w and menu.
	(auto-fill-mode): Added on C-c C-f and menu.
	(cperl-style-alist): `PerlStyle' style added.
	(cperl-find-pods-heres): Message for termination of scan corrected.
	(cperl-speed): New variable with hints.
	(cperl-electric-else): Make backspace electric after
	expansion of `else/continue' too.
	Fixed customization to honor cperl-hairy.
	Created customization groups.
	All the compile-time warnings fixed.
	(cperl-syntaxify-by-font-lock): Interaction with `font-lock-hot-pass'
	fixed.
	(cperl-after-block-and-statement-beg): It is BLOCK if we reach lim
	when backup sexp.
	(cperl-after-block-p, cperl-after-expr-p): Likewise.
	(cperl-indent-region): Make a marker for END - text added/removed.
	(cperl-style-alist): Include `cperl-merge-trailing-else'
	where the value is clear.
	(cperl-styles-entries): Likewise.
	(cperl-tips, cperl-problems): Improvements to docs.

1998-04-16  Richard Stallman  <rms@psilocin.gnu.org>

	* ispell.el (ispell-word): In ispell-check-only mode,
	display a message for misspelled word.
	(ispell-get-word): No error if can't find a word to check.
	(ispell-word): Don't fuss about a word if not adjacent to it.
	(ispell-minor-check): Use save-excursion.

	* emacs-lisp/byte-opt.el (byte-after-unbind-ops): Delete byte-equal.

	* help.el (help-with-tutorial): Locally bind file and filename.

	* emacs-lisp/find-func.el (find-function-on-key):
	If definition is a list, don't call find-function-other-window.
	Handle mouse events (code copied from describe-key-briefly).
	(find-function-do-it): Doc fix.
	(find-function-noselect): Doc fix.

	* locate.el (locate): Doc fix.

	* man.el (Man-notify-when-ready) <newframe>:
	Mark frame's window as dedicated.

	* subr.el (local-set-key, global-set-key):
	Return what define-key returns.

	* custom.el (defcustom, defgroup, defface): Don't use backquote.

1998-04-15  Eli Zaretskii  <eliz@delysid.gnu.org>

	* ps-print.el (ps-do-despool): Bind coding-system-for-write to
	raw-text-unix instead of using binary-process-input.

	* arc-mode.el (archive-extract-by-stdout): Don't use
	binary-process-output.  Bind coding-system-for-read `undecided',
	so coding system is determined on the fly.  Bind
	inherit-process-coding-system to t.
	(archive-dos-members): Remove.
	(archive-extract): Don't call archive-check-dos.  Handle pkunzip
	errors.
	(archive-*-extract): Handle pkzip errors.
	(archive-check-dos): Remove.
	(archive-subfile-dos): Remove.
	(archive-extract): Don't bind archive-subfile-dos.
	(archive-write-file-member): Don't DOSify DOS-style archive
	members.
	(archive-zip-extract): Make pkzip use -o- flag, to make it more
	silent.

	* lpr.el (print-region-1): Stop using binary-process-{in,out}put,
	bind coding-system-for-{read,write} instead.

	* dos-fns.el (dos-print-region-function): Except for binary files,
	force conversion to DOS EOLs, but leave text conversions alone.

	* hexl.el (hexlify-buffer, dehexlify-buffer): Don't bind
	binary-process-{in,out}put; setup coding-systems instead.

1998-04-15  Dave Love  <d.love@dl.ac.uk>

	* international/mule-cmds.el (global-map [menu-bar mule]):
	Conditionalize on default-enable-multibyte-characters.

1998-04-15  Andre Spiegel  <spiegel@inf.fu-berlin.de>

	* vc.el (vc-dired-mode): Redefine dired-move-to-filename-regexp
	locally.
	(vc-dired-reformat-line): Streamlined.  Should handle all sorts of
	date formats now.

1998-04-15  Andreas Schwab  <schwab@delysid.gnu.org>

	* vc.el (vc-backend-revert): Fix missing argument for
	vc-file-setprop.

1998-04-15  Kenichi Handa  <handa@etl.go.jp>

	* international/mule-util.el (coding-system-change-eol-conversion):
	New function.
	(coding-system-change-text-conversion): New function.

1998-04-15  Richard Stallman  <rms@gnu.org>

	* mail/mh-e.el (mh-quit): mh-show-buffer can be nil.

	* mail/sendmail.el (mail-mode): Doc fix.

1998-04-15  Simon Marshall  <simon@gnu.org>

	* textmodes/outline.el (outline-font-lock-level): New function.

1998-04-15  François Pinard  <pinard@iro.umontreal.ca>

	* emacs-lisp/bytecomp.el
	(byte-compile-warn-about-unresolved-functions): Fix whitespace.

1998-04-14  Dan Nicolaescu  <done@ece.arizona.edu>

	* language/romanian.el: New file.

	* loadup.el: Load language/romanian.

1998-04-14  Dave Love  <fx@gnu.org>

	* progmodes/fortran.el: Don't eval-*and*-compile font-lock stuff.

1998-04-14  Stephen Eglen  <stephen@gnu.org>

	* mail/mspools.el (mspools-folder-directory): Takes default value of
	~/MAIL/ if vm-folder-directory not bound.
	(mspools-vm-system-mail): Customize the variable so that if the
	environment variable $MAIL is not set, the user can easily set
	it.
	(mspools-vm-system-mail-crash): Variable deleted; we now use
	vm-crash-box.
	(mspools-set-vm-spool-files): Error if mspools-folder-directory
	hasn't been set.  Use mspools-folder-directory rather
	than vm-folder-directory.
	(mspools-get-spool-files): Error if mspools-folder-directory is nil.
	(mspools-get-spool-files): Add $ to regexp to ensure mspools-suffix
	matches the end of the filename.
	(mspools-mode-map): Bind n and p to next-line and previous-line.

1998-04-14  Richard Stallman  <rms@gnu.org>

	* files.el (find-file-noselect): Set buffer-file-coding-system
	if RAWFILE.

1998-04-14  Andre Spiegel  <spiegel@inf.fu-berlin.de>

	* vc.el (vc-next-action-on-file): Don't check out after
	registering.  This is two steps instead of one, and the second
	does not make sense under CVS.
	(vc-next-action): Changed doc string to reflect the above.

1998-04-14  Andreas Schwab  <schwab@mescaline.gnu.org>

	* mail/rmail.el (rmail-movemail-flags): Fix customize type.

	* language/korean.el ("Korean"): Doc fix.

	* emacs-lisp/bytecomp.el (byte-compile-warnings): Fix customize
	type.

	* ediff-init.el (ediff-autostore-merges): Doc fix.

1998-04-14  Andre Spiegel  <spiegel@inf.fu-berlin.de>

	* startup.el (command-line-1): Better wording in mouse startup
	message.

1998-04-14  Kenichi Handa  <handa@etl.go.jp>

	* international/titdic-cnv.el (titdic-convert): Message improved.
	(tit-process-header): Change `Do byte-compile' to `Byte-compile'.
	(batch-titdic-convert): Likewise.

1998-04-13  Richard Stallman  <rms@gnu.org>

	* mail/emacsbug.el (report-emacs-bug-hook): Don't absolutely
	reject non-ASCII characters.

	* tmm.el (tmm-get-keymap): Handle `menu-item' menu items.

1998-04-13  Eli Zaretskii  <eliz@delysid.gnu.org>

	* international/mule-util.el (coding-system-eol-type-mnemonic):
	Return correct eol-type mnemonics for the non-unix cases.

1998-04-12  Ken'ichi Handa  <handa@melange.gnu.org>

	* language/korean.el: Fix previous change.

1998-04-12  Richard Stallman  <rms@gnu.org>

	* help.el (describe-function-1): New function.
	(describe-function): Use describe-function-1.
	(describe-key): Likewise.

	* emacs-lisp/lisp-mode.el (eval-defun): Arrange to use eval-region
	even if we have to alter the form.

	* gnus/gnus-art.el (gnus-emphasis-alist): Use nth, not caddr.

	* emacs-lisp/autoload.el (generate-autoload-section-header): Doc fix.
	(update-file-autoloads): Use autoload-read-section-header.
	(update-autoloads-from-directories): Likewise.
	(generate-autoload-section-continuation): New variable.
	(autoload-read-section-header): New function.
	(update-file-autoloads): Don't call save-buffer if no changes.
	(generate-file-autoloads): Split the section header line
	into multiple comments.

	* mail/mail-extr.el (mail-extract-address-components):
	Rename local :-pos to colon-pos.

1998-04-12  Erik Naggum  <erik@naggum.no>

	* emacs-lisp/cl-macs.el (cl-do-arglist): Intern initializes the
	value of keyword symbols, so don't do it again.

1998-04-11  Kenichi Handa  <handa@etl.go.jp>

	* international/mule.el (generic-char-p): A character of code 0 is
	not a generic char.

	* international/mule-cmds.el (describe-language-environment):
	Print the language environment at the head.

	* language/czech.el: Put Czech lang. env. under European.

	* language/slovak.el: Put Slovak lang. env. under European.

1998-04-10  Eli Zaretskii  <eliz@is.elta.co.il>

	* international/mule-diag.el (list-input-methods): Fix doc string.
	(describe-font, describe-fontset, list-fontsets, mule-diag): Don't
	use fontset-related features if global-fontset-alist is not bound.

1998-04-10  Ken'ichi Handa  <handa@melange.gnu.org>

	* language/slovak.el: Delete tutorial file entry.

1998-04-10  Ken'ichi Handa  <handa@melange.gnu.org>

	* language/czech.el: Fix previous change, TUTORIAL.ch > TUTORIAL.cs.

1998-04-10  Kenichi Handa  <handa@etl.go.jp>

	* language/czech.el: Tutorial file name changed to TUTORIAL.ch.
	* language/japanese.el: Tutorial file name changed to TUTORIAL.ja.
	* language/korean.el: Tutorial file name changed to TUTORIAL.ka.
	* language/slovak.el: Tutorial file name changed to TUTORIAL.sk.

1998-04-09  Karl Heuer  <kwzh@gnu.org>

	* progmodes/vhdl-mode.el (vhdl-loop, vhdl-while-loop): Add backslash.

	* emacs-lisp/cl.el: Don't defconst the colon symbols, since they
	evaluate to themselves now anyway.

	* simple.el (newline): Mark as hard the newline that was just
	typed, not the previous one.  Suppress optimization if there's a
	marker either before or after the newline.

1998-04-09  Andre Spiegel  <spiegel@inf.fu-berlin.de>

	* vc.el (vc-next-action): Fixed bug that prevented registering
	files using C-x v v.

1998-04-09  Stephen Eglen  <stephen@gnu.org>

	* progmodes/c-mode.el, progmodes/cplus-md.el: Customize.
	progmodes/m4-mode.el: Customize.

1998-04-09  Dan Nicolaescu  <done@ece.arizona.edu>

	* progmodes/vhdl-mode.el (vhdl-mode): Add autoload cookie.

1998-04-09  Kenichi Handa  <handa@etl.go.jp>

	* language/slovak.el: Add tutorial file name for Slovak.

	* help.el (help-with-tutorial-alist): This variable deleted.
	(help-with-tutorial): Get a tutorial file name by
	get-language-info instead of help-with-tutorial-alist.

	* language/devan-util.el: Typos in comment fixed.
	(devanagari-vertical-modifier-p): Target string to be matched with
	GLYPH is modified.
	(devanagari-non-vertical-modifier-p): Likewise.
	(devanagari-wide-to-narrow-char): New function.
	(devanagari-wide-to-narrow-iter): The second arg is changed to
	2-COL-GLYPH.

1998-04-08  Dan Nicolaescu  <done@ece.arizona.edu>

	* textmodes/outline.el: Add support for showing hidden outlines
	when doing isearch.  (Thanks to Peter S Galbraith for the idea)
	(outline-isearch-open-invisible): New function.
	(outline-flag-region): Use it.

1998-04-08  Derek L. Davies  <ddavies@world.std.com>

	* gud.el (jdb): Do proper analysis of classes defined in a Java
	source.  This removes the restriction of one class per file.
	(gud-jdb-package-of-file): Removed.  Replaced with parsing routines.
	(gud-jdb-skip-whitespace): New function.
	(gud-jdb-skip-single-line-comment): New function.
	(gud-jdb-skip-traditional-or-documentation-comment): New function.
	(gud-jdb-skip-whitespace-and-comments): New function.
	(gud-jdb-skip-id-ish-thing): New function.
	(gud-jdb-skip-string-literal): New function.
	(gud-jdb-skip-character-literal): New function.
	(gud-jdb-skip-block): New function.
	(gud-jdb-analyze-source): New function.
	(gud-jdb-build-class-source-alist-for-file): New function.
	(gud-jdb-analysis-buffer): New variable.
	(gud-jdb-build-class-source-alist): Cleaner at the expense of new
	variable.

1998-04-08  Richard Stallman  <rms@gnu.org>

	* mail/rmail.el (rmail-message-regexp-p): Handle messages
	whose headers have not been reformatted.
	(rmail-message-recipients-p): Likewise.

	* mail/rmailedit.el (rmail-cease-edit): Call kill-all-local-variables.
	Call rmail-variables.
	(rmail-edit-mode): Call text-mode.  Don't run text-mode-hook here.
	(rmail-edit-map): Use set-keymap-parent.
	(rmail-old-text): Add defvar.

	* mail/rmail.el (rmail-movemail-program): Customized.
	(rmail-message-filter): Customized.
	(rmail-display-summary): Customized.
	(rmail-inbox-list, rmail-keywords, rmail-current-message)
	(rmail-total-messages, rmail-message-vector, rmail-deleted-vector)
	(rmail-msgref-vector, rmail-overlay-list, rmail-view-buffer)
	(rmail-last-label, rmail-last-regexp): Now permanent locals.
	(rmail-perm-variables): Set up all permanent locals here.
	(rmail-variables): Not here.
	(rmail-variables): Set enable-local-variables here.
	(rmail-mode-2): Not here.

1998-04-08  Dave Love  <fx@gnu.org>

	* progmodes/fortran.el (fortran-fill-paragraph): Return t here.
	(fortran-fill-statement): Not here.

1998-04-08  Stephen Eglen  <stephen@gnu.org>

	* mail/mail-utils.el (mail-use-rfc822): Customize.

1998-04-07  Milan Zamazal  <pdm@fi.muni.cz>

	* language/czech.el: Add coding-priority.  Improve sample text.
	Correct starting commentary.
	* language/slovak.el: Add coding-priority.  Use iso-8859-2 instead
	of iso-latin-2.  Correct starting commentary.

1998-04-07  Dave Love  <d.love@dl.ac.uk>

	* progmodes/fortran.el: Use regexp-opt and eval-and-compile to
	build font-lock patterns.
	(fortran-mode): Define indent-region-function, indent-line-function.
	(fortran-tab-mode-string): Make buffer-local.
	(fortran-comment-indent-style): Custom tweak.
	(fortran-comment-region, fortran-electric-line-number)
	(fortran-analyze-depth, fortran-break-before-delimiters)
	(fortran-mode): Doc fix.
	(fortran-font-lock-keywords-1): Add "select", "case"; allow
	double-quoted strings.
	(fortran-mode-map): Add fill-paragraph menu item.  Don't define \t.
	(fortran-mode): Make `fill-column' buffer-local; set
	`fill-paragraph-function', `indent-region-function',
	`indent-line-function'.
	(calculate-fortran-indent): Renamed to `fortran-calculate-indent'.
	(fortran-split-line): Simplify.
	(fortran-remove-continuation): New function.
	(fortran-join-line): Use it.
	(fortran-end-prog-re1, fortran-end-prog-re): New variables.
	(beginning-of-fortran-subprogram, end-of-fortran-subprogram): Use them.
	(fortran-blink-matching-if, fortran-blink-matching-do)
	(fortran-indent-new-line): Bind case-fold-search.
	(fortran-end-do, fortran-beginning-do, fortran-end-if)
	(fortran-beginning-if): Bind case-fold-search.  Allow labeled blocks.
	Use fortran-end-prog-re.
	(fortran-if-start-re): New variable.
	(fortran-calculate-indent): Allow labeled blocks.  Simplify the conds.
	Make select case indentation work.
	(fortran-is-in-string-p): Ignore Emacs 18 bug kluge.
	(fortran-fill): Allow double quotes in check for string.
	(fortran-fill-paragraph): New function.
	(fortran-fill-statement): New function.

1998-04-07  Richard Stallman  <rms@gnu.org>

	* subr.el (add-to-list): Always return updated value of LIST-VAR.

	* shadowfile.el (find-file-visit-truename): Don't setq this.

1998-04-07  Stephen Eglen  <stephen@gnu.org>

	* cus-start.el: next-screen-context-lines is an integer, not boolean.

	* mail/rmail.el (rmail-mode): Doc fix.

1998-04-06  Jonathan I. Kamens  <jik@kamens.brookline.ma.us>

	* mail/rmail.el (rmail-movemail-flags): New customizable variable
	to specify additional flags to pass to movemail.
	(rmail-insert-inbox-text): Use rmail-movemail-flags.

1998-04-06  Richard Stallman  <rms@gnu.org>

	* startup.el (command-line-1): Fix punctuation in startup screen.

1998-04-06  Dave Love  <fx@gnu.org>

	* help.el (help-make-xrefs): Grok commands in keymap table
	expansions.
	(help-xref-button): Simplify.
	(help-make-xrefs): Set overriding keymap properly.

1998-04-06  Kenichi Handa  <handa@etl.go.jp>

	* language/japanese.el: Set exit-function to
	exit-japanese-environment for Japanese environment.

	* language/japan-util.el (setup-japanese-environment): Setup
	sentence-end suitable for Japanese text.
	(exit-japanese-environment): New function.

	* international/mule-cmds.el (subset-p): Renamed from
	find-safe-coding-system-list-subset-p.
	(find-coding-systems-region, find-coding-systems-string): New
	functions.
	(find-coding-systems-for-charsets): Renamed from
	find-safe-coding-system.  This is now a helper function of the
	above two.
	(select-safe-coding-system): Adjusted for the above changes.

1998-04-05  Per Abrahamsen  <abraham@dina.kvl.dk>

	* widget.el (:default-get): New keyword.

	* wid-edit.el (default, widget-default-default-get): Define it.
	(group, widget-group-default-get): Define it.
	(menu-choice, widget-choice-default-get): Define it.
	(widget-default-get): New function.
	(widget-choice-action): Call it.
	(widget-editable-list-entry-create): Call it.

1998-04-05  Andre Spiegel  <spiegel@inf.fu-berlin.de>

	* vc.el (vc-dired-mode): Make dired-after-readin-hook a local
	hook, not a local variable.

	* vc.el (vc-merge, vc-backend-merge): New functions.
	(vc-resolve-conflicts): Added optional parameters for buffer names.
	(vc-branch-p): New function.

	* vc-hooks.el (vc-prefix-map): Added "m" for vc-merge.

	* vc.el (vc-ensure-vc-buffer): New function.
	(vc-registration-error): Replaced by the above.  Updated all callers.
	(file-executable-p-18, file-regular-p-18): Removed.

1998-04-05  Richard Stallman  <rms@psilocin.gnu.org>

	* emacs-lisp/autoload.el (update-file-autoloads):
	Redo 1997-08-23 change.

1998-04-05  Stephen Eglen  <stephen@gnu.org>

	* play/bruce.el, play/decipher.el, play/gametree.el: Customize.
	* play/gomoku.el, play/handwrite.el, play/landmark.el: Customize.
	* play/mpuz.el, play/solitaire.el, play/spook.el: Customize.
	* play/yow.el, play/dunnet.el: Customize.
	* emacs-lisp/advice.el, emacs-lisp/backquote.el: Customize.
	* emacs-lisp/cust-print.el, emacs-lisp/debug.el: Customize.
	* emacs-lisp/gulp.el, emacs-lisp/lisp-mnt.el, pp.el: Customize.
	* emacs-lisp/profile.el, emacs-lisp/shadow.el: Customize.
	* emacs-lisp/trace.el: Customize.

1998-04-05  Dave Love  <fx@gnu.org>

	* startup.el (command-line): Fix paren error.

1998-04-05  Richard Stallman  <rms@psilocin.gnu.org>

	* mouse.el (mouse-save-then-kill): Get point-before-scroll
	from the right buffer.

	* scroll-bar.el (scroll-bar-drag): Set point-before-scroll
	in the right buffer, from point in the right window.
	(scroll-bar-scroll-down, scroll-bar-scroll-up): Likewise.

1998-04-04  SL Baur  <steve@altair.xemacs.org>

	* webjump.el (webjump): Use assoc-ignore-case for locating the
	proper URL.

1998-04-04  Richard Stallman  <rms@psilocin.gnu.org>

	* mail/emacsbug.el (report-emacs-bug-hook): Use skip-chars-forward
	to check for non-ASCII characters, and to find them.
	Don't use find-charset-region.
	(report-emacs-bug-pretest-address): Update address.
	(report-emacs-bug-address): Likewise.

1998-04-04  Dave Love  <d.love@dl.ac.uk>

	* help.el (help-highlight-face): Use underline.
	(help-mode-maybe): Ensure read-only.
	(help-xref-button): Obey help-highlight-p.
	(help-follow): Remove check for args being a list.
	(help-mode): Doc fix.
	(help-highlight-face): Customize.
	(help-highlight-p): Put in help group.

	* help.el (help-make-xrefs): Insert button label in scope of
	inhibit-read-only binding.
	(help-mode-map, help-make-xrefs): Define TAB, RET correctly.

1998-04-03  Andre Spiegel  <spiegel@inf.fu-berlin.de>

	* vc-hooks.el (vc-parse-cvs-status): New function.
	(vc-fetch-master-properties): Moved cvs status retrieval to
	the above.
	(vc-backend): If a file is not registered, remember that by setting
	the property to `none'.
	(vc-name): Use the mechanism of vc-backend to compute the value.
	(vc-after-save): Don't access vc-backend property directly.

	* vc.el (vc-next-action-dired): Use dired-do-redisplay.  Handle
	window configuration correctly.
	(vc-next-action): Save window configuration for vc-next-action-dired.
	(vc-finish-logentry): Only kill log buffer if it does exist.
	(vc-dired-mode): Rewritten so that it works entirely through
	dired-after-readin-hook.  Subdirectories are handled just as in
	ordinary dired.
	(vc-dired-hook): New function.
	(vc-state-info, vc-dired-reformat-line): Adapted.
	(vc-dired-update, vc-dired-update-line): Removed.
	(vc-directory): Rewritten.
	(vc-directory-18): Removed.
	(vc-dired-mark-locked): New function, bound to "*l" in vc-dired-mode.
	(vc-do-command): Only compute vc-name if it is really needed.
	(vc-fetch-cvs-status): New function.
	(vc-dired-hook): Use it.

1998-04-03  Richard Stallman  <rms@psilocin.gnu.org>

	* mail/emacsbug.el (report-emacs-bug-hook):
	Don't bind enable-multibyte-characters.

1998-04-03  Dave Love  <d.love@dl.ac.uk>

	* startup.el (command-line): If already unibyte, just load
	latin-N instead of calling set-language-environment.

1998-04-03  Richard Stallman  <rms@psilocin.gnu.org>

	* mail/emacsbug.el (report-emacs-bug): Use set-buffer-multibyte.

	* mail/rmail.el (rmail-mode-2): Locally set enable-local-variables
	to nil, so a local var list in a message won't confuse things.

	* mail/emacsbug.el (report-emacs-bug-hook): Fix the regexp for
	matching non-ASCII characters.

1998-04-02  Richard Stallman  <rms@psilocin.gnu.org>

	* generic-x.el (rul-generic-mode): Use font-lock-builtin-face,
	not font-lock-emphasized-face.

	* help.el (help-highlight-face): Use `highlight'.

1998-04-02  Dave Love  <d.love@dl.ac.uk>

	* help.el: Make hyperlinks for cross-reference info intuited from
	*Help* buffer.
	(help-font-lock-keywords): Removed.
	(help-mode-map): Define keys for navigating hyperlinks.
	(help-xref-stack, help-xref-stack-item): New permanent-local
	variables.
	(help-mode): Set font-lock-defaults to nil.
	(help-mode-maybe): Invoke help-make-xrefs in Help mode.
	(help-setup-xref): New function.
	(describe-key, describe-mode, describe-function)
	(describe-variable): Call it.
	(view-lossage, describe-bindings): Nullify help-xref-stack,
	help-xref-stack-item.
	(help-highlight-p): New option.
	(help-highlight-face): New customized face.
	(help-back-label, help-xref-symbol-regexp, help-xref-info-regexp):
	New variables.
	(help-setup-xref, help-make-xrefs, help-xref-button)
	(help-xref-interned, help-xref-mode, help-follow-mouse)
	(help-xref-go-back, help-go-back, help-follow, help-next-ref): New
	functions.

1998-04-02  Richard Stallman  <rms@psilocin.gnu.org>

	* wid-edit.el (widget-beginning-of-line): Don't set zmacs-region-stays.
	(widget-end-of-line): Likewise.
	(widget-glyph-click): Use read-event.
	(widget-color-choice-list): Delete compatibility code.
	(widget-color-sample-face-get): Likewise.
	(widget-choose): Likewise.
	(widget-event-point): Fix paren error.

1998-04-01  Richard Stallman  <rms@psilocin.gnu.org>

	* wid-edit.el: Delete some compatibility code.
	(widget-event-point, widget-read-event): Define unconditionally.

	* info-look.el (info-lookup->topic-cache): Use defun, not defsubst.
	(info-lookup->mode-cache, info-lookup->initialized): Likewise.
	(info-lookup->completions, info-lookup->refer-modes): Likewise.
	(info-lookup->all-modes): Likewise.

	* info-look.el (info-lookup-quick-all-modes): New function.
	(info-complete): Find the symbol to complete first,
	then compute list of completions.

	* info-look.el (lisp-mode): Add info-lookup-maybe-add-help for it.

1998-04-01  Derek L. Davies  <ddavies@world.std.com>

	* gud.el: Add support for jdb (Java debugger).
	(jdb): New function.
	(gud-jdb-history): New variable.
	(gud-jdb-directories): New variable.
	(gud-jdb-source-files): New variable.
	(gud-jdb-build-source-files-list): New function.
	(gud-jdb-package-of-file): New function.
	(gud-jdb-class-source-alist): New variable.
	(gud-jdb-build-class-source-alist): New function.
	(gud-jdb-massage-args): New function.
	(gud-jdb-find-source-file): New function.
	(gud-jdb-marker-filter): New function.
	(gud-jdb-find-file): New function.
	(gud-jdb-command-name): New variable.
	(gud-perldb-command-name): Variable renamed from perldb-command-name.

1998-03-31  Anders Lindgren  <andersl@csd.uu.se>

	* follow.el (follow-scroll-up): Cope if `window-end' returns nil.
	(follow-select-if-end-visible): Likewise.
	(follow-mode-version): Variable removed.

1998-04-01  Andre Spiegel  <spiegel@inf.fu-berlin.de>

	* vc.el (vc-revert-buffer): Rewrote handling of vc-diff buffer,
	so that the file's buffer is always current when the actual
	revert is done.

1998-04-01  Andreas Schwab  <schwab@gnu.org>

	* emacs-lisp/copyright.el: Customized.

1998-03-31  Richard Stallman  <rms@psilocin.gnu.org>

	* files.el (hack-one-local-variable):
	Variables named ...-predicate are treated as risky.
	(write-file): Omit directory part when making default file name.

1998-03-31  Stephen Eglen  <stephen@gnu.org>

	* iswitchb.el: Many doc fixes.
	(iswitchb-method): No longer a user variable.
	(iswitchb-minibuffer-setup-hook): Customized.
	(iswitchb-default): New variable.
	(iswitchb-complete): Use iswitchb-common-match-string rather than
	recomputing the value.
	(iswitchb-toggle-ignore): Recompute list of buffers.
	(iswitchb-init-XEmacs-trick): Renamed from iswitchb-init-Xemacs-trick.

1998-03-31  Andre Spiegel  <spiegel@inf.fu-berlin.de>

	* vc.el (vc-resolve-conflicts): New function.
	(vc-next-action-on-file): Use it.
	(vc-backend-revert): For CVS, revert to the version the buffer was
	based on, not the latest on the current branch (same behavior as
	for RCS).  For SCCS, forget vc-workfile-version so that it gets
	recomputed.
	(vc-revert-buffer): Rewrote doc string to explain the above.
	(vc-finish-logentry): Don't add extra newline.

1998-03-29  Ralph Schleicher  <rs@purple.UL.BaWue.DE>

	* battery.el (battery-linux-proc-apm): Re-use the temporary
	buffer.

	* battery.el (battery-insert-file-contents): Disable code
	conversion.

1998-03-29  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* textmodes/tex-mode.el (tex-send-command): Return the process.
	(tex-start-tex): New function.
	(tex-region, tex-file): Use tex-start-tex.
	(tex-start-tex-marker): New variable.
	(tex-compilation-parse-errors): Parse only the most recent
	TeX compilation's output.  If the error is in the zap file,
	use the buffer it was zapped from.
	(tex-start-shell): Call compilation-minor-mode.

1998-03-29  Ian T Zimmerman  <itz@kronstadt.rahul.net>

	* textmodes/tex-mode.el (tex-compilation-parse-errors):
	Completely rewritten.
	(tex-print): Reset or restart the subshell before using it.

	* desktop.el (desktop-buffer-info, desktop-buffer-rmail)
	(desktop-buffer-mh, desktop-buffer-dired, desktop-buffer-file):
	Return the buffer produced.
	(desktop-create-buffer): Use the buffer that was returned.

	* ange-ftp.el (ange-ftp-kill-ftp-process): Convert buffer name
	to the buffer.

1998-03-28  Richard Stallman  <rms@psilocin.gnu.org>

	* desktop.el (desktop-load-default): Add autoload cookie.
	(desktop-read): Likewise.

1998-03-27  Dave Love  <d.love@dl.ac.uk>

	* menu-bar.el (menu-bar-options-menu): Remove "Toggle" from item
	names, using buttons instead.
	(menu-bar-make-toggle): Define a menu-item toggle button.
	(menu-bar-options-menu [save-place]): (require 'saveplace).
	(menu-bar-options-menu [toggle-auto-compression], [auto-fill-mode])
	(menu-bar-options-menu [toggle-global-lazy-font-lock-mode]):
	Define a menu-item button.

1998-03-27  Richard Stallman  <rms@psilocin.gnu.org>

	* bindings.el (completion-ignored-extensions): Add a few.

1998-03-25  Richard Stallman  <rms@psilocin.gnu.org>

	* bindings.el (debug-ignored-errors): Add file-supersession.

	* startup.el (normal-top-level-add-subdirs-to-load-path):
	Reverse order of subdirs to add.  Don't duplicate the parent dir.

	* mail/rmail.el (rmail-clear-headers):
	Handle failure to find "\n[^ \t]".

1998-03-25  Dave Love  <fx@gnu.org>

	* autorevert.el: Various doc fixes, mainly grammar.

	* autoinsert.el (auto-insert, auto-insert-query): :tag choices.
	(define-auto-insert): Rename arg key to match doc.

1998-03-25  Simon Marshall  <simon@gnu.org>

	* font-lock.el (c-font-lock-keywords-2): Added "sizeof".
	(c++-font-lock-keywords-2): Added "export" and "typename".

	* lazy-lock.el (lazy-lock-fontify-after-scroll)
	(lazy-lock-fontify-after-trigger): Use new window-end UPDATE arg
	rather than calculating a value using vertical-motion.

	* mail/sendmail.el (mail-font-lock-keywords): Don't use the value
	of mail-header-separator if its length is zero.

1998-03-24  Dave Love  <fx@gnu.org>

	* ange-ftp.el (shell-command): Define handler.
	(ange-ftp-shell-command): Add optional arg.
	(comint-last-output-start, comint-last-input-start)
	(comint-last-input-end): Defvar to silence compiler.

	* dired-aux.el (dired-run-shell-command): Maybe run handler.

	* simple.el (shell-command-on-region): Amend message to report
	success or failure when no process output.

1998-03-23  Andreas Schwab  <schwab@gnu.org>

	* xt-mouse.el (xterm-mouse-translate, xterm-mouse-event): Replace
	obsolete `concat with integer' by format.

	* rsz-mini.el (resize-minibuffer-mode): Make it a proper minor
	mode: toggle resize-minibuffer mode when called without argument.

1998-03-22  Richard Stallman  <rms@gnu.org>

	* startup.el (normal-top-level-add-subdirs-to-load-path): New function.

	* files.el (find-file-noselect): Use set-buffer-multibyte
	instead of setting enable-multibyte-characters.

	* disp-table.el (standard-display-underline): Shift face id by 19 bits.

1998-03-22  Johan Vromans  <jvromans@squirrel.nl>

	* complete.el (PC-expand-many-files): Apply
	completion-ignored-extensions.

1998-03-21  Richard Stallman  <rms@psilocin.gnu.org>

	* comint.el (comint-preoutput-filter-functions): Doc fix.

	* replace.el (perform-replace): Before recursive edit,
	get the match data as markers, and set real-match-data.

1998-03-20  Andre Spiegel  <spiegel@inf.fu-berlin.de>

	* vc-hooks.el (vc-sccs-project-dir, vc-search-sccs-project-dir):
	New functions.
	(vc-master-templates): Add call to vc-search-sccs-project-dir.

	* vc.el (vc-next-action-on-file): Properly handle the case
	when user tries to check-in, but file on disk has changed.
	(vc-do-command): Rewrote doc string.  Consider LAST argument
	only if FILE is non-nil.
	(vc-add-triple, vc-record-rename, vc-lookup-file): Find
	vc-name-assoc-file based on vc-name of FILE.
	(vc-backend-admin, vc-rename-file): Handle the SCCS PROJECTDIR
	feature.

1998-03-20  Richard Stallman  <rms@psilocin.gnu.org>

	* international/mule-cmds.el (set-language-environment): Doc fix.
	(current-language-environment): Use defcustom.
	(default-input-method): Specify :type.

1998-03-19  Barry A. Warsaw  <bwarsaw@cnri.reston.va.us>

	* reporter.el (reporter-mail): New function.
	(reporter-compose-outgoing): Use fboundp, not functionp.
	(reporter-bug-hook): Fix error message.

	* reporter.el (reporter-beautify-list): Break infloop when
	reaching the end of the buffer without crossing an unbalanced
	paren.  Use scan-sexps instead of forward-sexp for the loop break
	test.

	* reporter.el (reporter-submit-bug-report): Only call
	display-buffer if pop-up-windows is non-nil.

1998-03-19  Richard Stallman  <rms@psilocin.gnu.org>

	* progmodes/compile.el: Moved from parent directory.

	* compile.el (compilation-error-regexp-alist):
	Handle f90 in  DEC AXP OSF/1 cc  pattern.

1998-03-19  Dave Love  <fx@gnu.org>

	* simple.el (shell-command-on-region): Amend message to report
	success or failure when no process output.

1998-03-18  Richard Stallman  <rms@psilocin.gnu.org>

	* frame.el (focus-follows-mouse): New variable.
	(other-frame): Obey that variable.
	(focus-follows-mouse): Make it defcustom.

1998-03-18  Dave Love  <fx@gnu.org>

	* emacs-lisp/lisp-mode.el (lisp-fill-paragraph): Adjust
	paragraph-start in default filling case so that filling doc
	strings works.

1998-03-18  Andre Spiegel  <spiegel@inf.fu-berlin.de>

	* vc.el (vc-restore-buffer-context): Only try to restore mark
	if it is active.

1998-03-18  Richard Stallman  <rms@psilocin.gnu.org>

	* calendar/calendar.el (calendar-mode-map): Add bindings for
	appt-add and appt-delete.

1998-03-17  Richard Stallman  <rms@psilocin.gnu.org>

	* help.el (view-emacs-news): Handle prefix arg.

	* loadup.el: Load language/czech and language/slovak.

	* language/czech.el (setup-czech-environment): 3rd arg to
	setup-8-bit-environment is the default input method, not coding system.
	* language/slovak.el (setup-slovak-environment): 3rd arg to
	setup-8-bit-environment is the default input method, not coding system.

	* env.el (setenv): Simplify reading of args by passing old value
	as the default.

	* language/czech.el, language/slovak.el: New files.

	* info.el (Info-menu-update): Set Info-menu-last-node
	to (FILE NODENAME), and test it that way too.

1998-03-17  Emilio Lopes  <Emilio.Lopes@Physik.TU-Muenchen.DE>

	* help.el (view-emacs-news): Use prefix argument to display old news.

1998-03-16  Peter Breton  <pbreton@ne.mediaone.net>

	* generic-x.el: Customize.
	(fvwm-generic-mode): Added new keywords, and .fvwm2rc config file.
	(ini-generic-mode): Changed regexps so that value can contain equal signs.
	(java-manifest-generic-mode): Added new keywords.

1998-03-16  Alfred Correira  <ACorreir@pervasive-sw.com>

	* generic-x.el (mailrc-generic-mode, java-properties-generic-mode):
	New generic modes.
	(alias-generic-mode, rc-generic-mode, rul-generic-mode): Likewise.

1998-03-16  Erik Naggum  <erik@naggum.no>

	* mail/rmail.el (rmail-clear-headers): Make sure an empty line
	still separates the headers from the body.

1998-03-16  Kenichi Handa  <handa@etl.go.jp>

	* mail/rmail.el (rmail-quit): Call quit-window before calling
	replace-buffer-in-windows to assure that we can switch the rmail
	buffer of the selected window.

1998-03-16  Richard Stallman  <rms@psilocin.gnu.org>

	* mouse.el (mouse-drag-region): Bind deactivate-mark
	around call to copy-region-as-kill.
	(mouse-set-region): Likewise.
	(mouse-secondary-save-then-kill): Likewise.

	* simple.el (copy-region-as-kill): Set deactivate-mark
	instead of clearing mark-active directly.

1998-03-15  Richard Stallman  <rms@psilocin.gnu.org>

	* help.el (help-mode-maybe): Set view-return-to-alist.
	(help-return-method): New variable.
	(print-help-return-message): Set help-return-method.

	* view.el (view-return-to-alist): Doc fix.
	(view-mode-enter): Doc fix.
	(view-mode-exit): Handle new alternative `quit-window'
	for OLD-BUF-INFO in RETURN-TO-ALIST.

	* dired-aux.el (dired-shell-stuff-it): Use shell-quote-argument.
	(dired-shell-quote): Function deleted.

1998-03-14  Richard Stallman  <rms@psilocin.gnu.org>

	* locate.el (locate-current-line-number): No longer interactive.

	* dirtrack.el: Customized.
	(dirtrack-forward-slash): Renamed from `forward-slash'.
	(dirtrack-backward-slash): Renamed from `backward-slash'.
	(dirtrack-replace-slash): Renamed from `replace-slash'.

	* emacs-lisp/elp.el (elp-version): Now 3.2.

1998-03-14  Karl Heuer  <kwzh@gnu.org>

	* textmodes/texnfo-upd.el (texinfo-incorporate-menu-entry-names)
	(texinfo-start-menu-description): Call regexp-quote.

1998-03-13  Richard Stallman  <rms@psilocin.gnu.org>

	* subr.el (store-match-data): This is now the alias,
	set-match-data is now the primitive.

	* textmodes/reftex.el (reftex-nearest-match):
	store-match-data => set-match-data.

	* textmodes/bibtex.el (bibtex-search-reference):
	store-match-data => set-match-data.

	* progmodes/simula.el (simula-match-string-or-comment):
	store-match-data => set-match-data.

	* progmodes/fortran.el (fortran-match-!-comment):
	store-match-data => set-match-data.

	* play/life.el (life-grim-reaper): store-match-data => set-match-data.

	* mail/rfc822.el (rfc822-looking-at):
	store-match-data => set-match-data.

	* mail/mh-utils.el (mh-make-folder-list-filter):
	store-match-data => set-match-data.

	* emulation/viper-ex.el (ex-expand-filsyms):
	store-match-data => set-match-data.

	* emacs-lisp/edebug.el (edebug-recursive-edit)
	(edebug-outside-excursion): store-match-data => set-match-data.

	* emacs-lisp/debug.el (debug, debugger-env-macro):
	store-match-data => set-match-data.

	* emacs-lisp/cl-macs.el (defsetf match-data):
	store-match-data => set-match-data.

	* type-break.el (type-break-emacs-variant):
	store-match-data => set-match-data.

	* subr.el (save-match-data): store-match-data => set-match-data.

	* rlogin.el (rlogin-parse-words): store-match-data => set-match-data.

	* replace.el (perform-replace): store-match-data => set-match-data.

	* iswitchb.el (iswitchb-ignore-buffername-p):
	store-match-data => set-match-data.

	* ffap.el (ffap-file-at-point): store-match-data => set-match-data.

	* ediff-diff.el (ediff-exec-process):
	store-match-data => set-match-data.

	* comint.el (comint-word): store-match-data => set-match-data.

	* allout.el (outline-end-of-prefix):
	store-match-data => set-match-data.

	* textmodes/fill.el (fill-region-as-paragraph, fill-region):
	Allow t as legit value of JUSTIFY.

	* wid-edit.el (widget-echo-help-mouse): Don't use window-end.

	* subr.el (momentary-string-display): Pass t as UPDATE to window-end.

	* mouse.el (mouse-scroll-subr): Handle if window-end returns nil.

1998-03-12  Richard Stallman  <rms@psilocin.gnu.org>

	* mail/rnewspost.el (news-inews): Signal error if inews fails.

	* simple.el: Implement selective undo (by Paul Flinders).
	(undo-copy-list, undo-copy-list-1): New functions.
	(undo-make-selective-list, undo-delta): New functions.
	(undo-elt-in-region, undo-elt-crosses-region): New functions.
	(undo-adjusted-markers): New defvar.
	(undo-start): New args BEG and END.
	(undo): If arg or active region, pass args to undo-start.

	* mouse.el (mouse-buffer-menu-maxlen): Renamed from
	mouse-menu-buffer-maxlen.

1998-03-10  Eric M. Ludlam  <zappo@ultranet.com>

	* checkdoc.el (checkdoc-continue): Removed check for doc string.
	(checkdoc-this-string-valid-engine): Smarter keycode check regexp.

1998-03-10  Carsten Dominik  <cd@delysid.gnu.org>

	* textmodes/reftex.el (reftex-mode-map): Added keybinding for
	`reftex-mouse-view-crossref' to `S-mouse-2'.

1998-03-09  Carsten Dominik  <cd@delysid.gnu.org>

	* textmodes/reftex.el (reftex-nicify-text): Make a new " " string
	each time.
	(reftex-what-macro): Make sure `reftex-section-regexp' is defined.

1998-03-09  Richard Stallman  <rms@psilocin.gnu.org>

	* textmodes/tex-mode.el (latex-mode): Set fill-nobreak-predicate.
	(slitex-mode): Set fill-nobreak-predicate, tex-face-alist,
	and imenu-create-index-function.
	(latex-fill-nobreak-predicate): New function.

	* simple.el (do-auto-fill): Obey fill-nobreak-predicate.

	* textmodes/fill.el (fill-nobreak-predicate): New variable.
	(fill-region-as-paragraph): Obey fill-nobreak-predicate.

	* help-macro.el (make-help-screen): Mention DEL in the prompt.

1998-03-08  Richard Stallman  <rms@psilocin.gnu.org>

	* emacs-lisp/autoload.el (update-file-autoloads):
	Undo 1997-08-23 change.

	* window.el (shrink-window-if-larger-than-buffer):
	Bind text-height in the let*.
	(view-return-to-alist): Add defvar.

	* files.el: Delete junk accidentally left in buffer on 4 March.

1998-03-08  Carsten Dominik  <cd@gnu.org>

	* textmodes/reftex.el (reftex-offer-label-menu)
	(reftex-select-item): Removed match-everywhere interpretation.

1998-03-08  Carsten Dominik  <cd@gnu.org>

	* textmodes/reftex.el (reftex-cursor-selected-face)
	(reftex-mouse-selected-face, reftex-file-boundary-face)
	(reftex-label-face, reftex-section-heading-face)
	(reftex-toc-header-face, reftex-bib-author-face)
	(reftex-bib-year-face, reftex-bib-title-face)
	(reftex-bib-extra-face): New options.
	(reftex-toc, reftex-make-and-insert-label-list)
	(reftex-format-bib-entry, reftex-section-info): Use fonts defined
	in the new options.
	(reftex-do-citation): Kill buffer *RefTeX Select* to avoid
	problems with lazy-lock.

1998-03-08  Andre Spiegel  <spiegel@inf.fu-berlin.de>

	* vc.el (vc-context-matches-p): New function.
	(vc-restore-buffer-context): Restore point and mark only if they
	don't match the context.
	(vc-revert-buffer1, vc-clear-headers): Use save-excursion to relocate
	point and mark, and vc-restore-buffer-context as a backup.
	(vc-resynch-buffer): When operating on the current buffer, don't use
	save-excursion, because that would undo the effects of the above
	functions.
	(vc-clear-headers): Fixed regexp.
	(vc-resynch-window): Deleted code that removed vc-find-file-hook
	temporarily.  This was unnecessary, because find-file-hooks are not
	called when the buffer is reverted.

1998-03-08  Richard Stallman  <rms@psilocin.gnu.org>

	* progmodes/cc-vars.el (c-emacs-features): Doc fix.

1998-03-07  Richard Stallman  <rms@psilocin.gnu.org>

	* subr.el (read-passwd): Renamed from read-password.
	New second arg CONFIRM.

	* wid-edit.el (widget-choice-value-create): If there is an
	:explicit-choice, respect it.
	(widget-choice-action): Record an explicit choice in :explicit-choice.

1998-03-07  Stephen Eglen  <stephen@gnu.org>

	* allout.el, battery.el, cmuscheme.el, compare-w.el, docref.el:
	* dos-fns.el, find-file.el, follow.el, ispell4.el, shadowfile.el:
	* tempo.el, tmm.el, vcursor.el, xscheme.el: Customize.

1998-03-06  Barry A. Warsaw  <cc-mode-help@python.org>

	* Release 5.21

	* progmodes/cc-defs.el (c-emacs-features): Var moved to cc-vars.el.

	* progmodes/cc-vars.el (c-emacs-features): Var moved from cc-defs.el.

	* progmodes/cc-align.el: Don't require cc-defs.

	* progmodes/cc-engine.el (c-inside-bracelist-p): Fix for enum test.

	* progmodes/cc-mode.el (c-initialize-cc-mode):
	Moved require's to top level.

	* progmodes/cc-cmds.el (c-fill-paragraph):
	Bind fill-paragraph-function to nil when calling fill-paragraph,
	to avoid bogus recursion which will signal an error.

1998-03-06  Martin Stjernholm  <cc-mode-help@python.org>

	* progmodes/cc-mode.el (c-initialize-on-load): Variable removed.

	* progmodes/cc-cmds.el (c-fill-paragraph): Always keep point in
	the same relative position.  Fill comment before point if there's
	nothing else on the same line.  Fill block comments after code a
	little better.  Try harder to find a good fill-prefix when point
	is on a block comment ender line.  Use
	c-Java-javadoc-paragraph-start in block comments in Java mode.
	Leave block comment ender alone when c-hanging-comment-ender-p is
	nil and point is on that line.  Detect paragraph-separate in
	multiparagraph comments.  Fix for bug that may strip the `*' off
	`*/' if fill-prefix ends with `*' and c-hanging-comment-ender-p is
	t.  Added filling of multiline string literals.  Always return t
	to disable filling in any unhandled area, i.e. actual code where
	fill-paragraph only mess things up.

	* progmodes/cc-engine.el (c-collect-line-comments): Require same
	comment start column.

	* progmodes/cc-langs.el (c-Java-javadoc-paragraph-start): New variable.

	* progmodes/cc-engine.el (c-guess-basic-syntax): Fixes for nesting
	of and repeated defun-open's inside extern and namespace clauses.
	This is done by passing a relpos to `inextern-lang' and
	`innamespace'.  Also, the relpos in `defun-open' is no longer
	always bol.  It's always bol when on the top level, however.
	Changed cases: 5A.5, 5I, 14A.

	* progmodes/cc-engine.el (c-forward-token-1, c-backward-token-1): New
	functions to move by tokens.
	(c-guess-basic-syntax): Fixes for Java 1.1 array initialization
	brace lists.

1998-03-06  Vinicius Jose Latorre  <vinicius@cpqd.com.br>

	* ps-print.el: Some comment, doc and bug fixes.
	(ps-print-version): New version number (3.06) and doc fix.
	(ps-print-only-one-header, ps-font-type): New var.
	(ps-font-info-database): Better font database management.
	(ps-error-scale-font, ps-select-header-font): Funs eliminated.
	(ps-font, ps-font-bold, ps-font-italic, ps-font-bold-italic)
	(ps-avg-char-width, ps-space-width, ps-line-height)
	(ps-header-font, ps-header-title-font, ps-header-line-height)
	(ps-header-title-line-height): Vars eliminated.
	(ps-font-list, ps-font, ps-fonts, ps-font-number, ps-line-height)
	(ps-title-line-height, ps-space-width, ps-avg-char-width): New funs.
	(ps-print-prologue-1): Adjust PostScript programming.
	(ps-color-format): Doc indentation.
	(ps-print-hook, ps-print-begin-page-hook, ps-print-begin-column-hook):
	New hook vars.
	(ps-spool-without-faces, ps-spool-with-faces): Run hook var.
	(ps-line-lengths-internal, ps-nb-pages, ps-select-font)
	(ps-get-page-dimensions, ps-begin-file, ps-end-file, ps-header-page)
	(ps-begin-page, ps-dummy-page, ps-next-line, ps-continue-line)
	(ps-basic-plot-string, ps-basic-plot-whitespace, ps-plot-region)
	(ps-control-character, ps-color-values, ps-generate): Adjust programming.
	(ps-page-number): New macro.
	(ps-plot-with-face, ps-generate-postscript-with-faces): Fix invisible
	text printing.

1998-03-06  Dave Love  <fx@gnu.org>

	* progmodes/fortran.el (fortran-column-ruler-fixed)
	(fortran-column-ruler-tab): Doc fix.
	(fortran-mode-map): Bind fortran-narrow-to-subprogram.
	(bug-fortran-mode): Variable deleted.

1998-03-06  Dave Love  <d.love@dl.ac.uk>

	* browse-url.el: Various doc fixes, mainly to remove innappropriate
	leading "*"s.
	(browse-url-new-window-p, browse-url-netscape-display)
	(browse-url-save-file, browse-url-generic-program):
	Add autoload cookies.
	(browse-url-mosaic-program, browse-url-lynx-input-field)
	(browse-url-lynx-input-attempts, browse-url-lynx-input-delay):
	Add :version.
	(browse-url-of-file-hook): Add :options.
	(browse-url-lynx-emacs-args): New option.
	(browse-url-lynx-emacs): Use it.
	(browse-url-lynx-xterm): Use backquote.
	(browse-url-emacs-display): Use Emacs version, not XEmacs.
	((require 'term)): When compiling.

1998-03-06  Kenichi Handa  <handa@etl.go.jp>

	* international/titdic-cnv.el (titdic-convert): Use
	set-buffer-multibyte.

	* international/quail.el (quail-defrule-internal): New arg REPLACE.
	(quail-defrule): Call quail-defrule-internal with REPLACE t.

1998-03-05  Peter Breton  <pbreton@ne.mediaone.net>

	* generic.el (generic-mode-ini-file-find-file-hook): Use
	and-s instead of if-s.
	(generic-use-find-file-hook): Changed from defvar to defcustom.
	(generic-lines-to-scan): Changed from defvar to defcustom.
	(generic-find-file-regexp): Changed from defvar to defcustom.

1998-03-05  Ivar Rummelhoff  <ivarr@ifi.uio.no>

	* winner.el (winner-mode, winner-save-unconditionally)
	(winner-hook-installed-p): Save window configuration after
	every command if window-configuration-change-hook is not present.

	* winner.el (winner-save-new-configurations, winner-insert-if-new):
	Compare a new window configuration
	with the previous configuration before saving it.

	* winner.el (winner-insert-if-new, winner-ring)
	(winner-configuration, winner-set): Save buffer list together
	with the window configurations, so that windows that can no
	longer be correctly restored can instead be deleted.

	* winner.el (winner-undo): Compare restored configuration
	with other configurations that have been reviewed and skip
	this one if it looks similar.

	* winner.el (winner-insert-if-new, winner-save-new-configurations)
	(winner-save-unconditionally): Just save the final
	configuration if the same command (changing the window
	configuration) is applied several times in a row.

	* winner.el (winner-switch): Removed the command
	`winner-switch' (and the variables connected to it), since
	because of the change above, any "switching package" may now
	be used without disturbing winner-mode too much.

	* winner.el: Use list syntax for key definitions.

	* winner.el (winner-change-fun): Removed the pushnew
	command, so that `cl' will not have to be loaded.

	* winner.el (winner-set-conf): Introduced "wrapper" around
	`set-window-configuration', so that `winner-undo' may be
	called from the minibuffer.

1998-03-06  Carsten Dominik  <cd@delysid.gnu.org>

	* textmodes/reftex.el (reftex-select-item): A set-buffer in the
	unwind-protect form makes sure we deinstall in the correct hooks.

1998-03-05  Richard Stallman  <rms@psilocin.gnu.org>

	* mail/rmail.el (rmail-next-same-subject): Ignore leading and
	trailing whitespace in this message's subject.

1998-03-05  Ralph Schleicher  <rs@purple.UL.BaWue.DE>

	* battery.el: Fixed spelling of `autoload' magic cookies.

1998-03-05  Sam Steingold  <sds@usa.net>

	* simple.el (backward-delete-char-untabify-method): New user option.
	(backward-delete-char-untabify): Obey it.
	This implements "hungry" delete.

1998-03-04  Stephen Gildea  <gildea@stop.mail-abuse.org>

	* time-stamp.el (time-stamp-pattern): New variable.
	(time-stamp): Use that new variable.
	(time-stamp-string): Take optional format arg.

1998-03-04  Richard Stallman  <rms@psilocin.gnu.org>

	* files.el (auto-mode-alist): Recognize zone-mode.
	(basic-save-buffer): Use save-current-buffer not save-excursion.

1998-02-27  Dave Love  <d.love@dl.ac.uk>

	* wid-edit.el (widget-url-link-action): Call browse-url to sort
	out browser function.  Don't require browse-url.

1998-03-04  Kenichi Handa  <handa@etl.go.jp>

	* subr.el (sref): Increase CHAR in the while loop.

1998-03-03  Sam Steingold  <sds@usa.net>

	* dired.el (dired-quit): Function deleted.
	(dired-mode-map): Use quit-window for q.

	* buff-menu.el (Buffer-menu-quit): Function deleted.
	(Buffer-menu-mode-map): Use quit-window for q.

	* bookmark.el (bookmark-bmenu-mode-map): Use quit-window for q.
	(bookmark-bmenu-quit): Function deleted.

	* progmodes/make-mode.el (makefile-browser-quit): Use quit-window.

	* progmodes/etags.el (select-tags-table-quit): Use quit-window.

	* play/solitaire.el (solitaire-quit): Function deleted.
	(solitaire-mode-map): Use quit-window for q.

	* mail/rnews.el (news-exit): Use quit-window.

	* mail/rmail.el (rmail-bury, rmail-quit): Use quit-window.

	* mail/mh-e.el (mh-quit): Use quit-window.

1998-03-03  Richard Stallman  <rms@psilocin.gnu.org>

	* textmodes/fill.el (fill-region): If JUSTIFY is non-nil
	and not a known value, treat it as `full'.
	(fill-region-as-paragraph): Likewise.

1998-03-03  Peter Stephenson  <pws@ifh.de>

	* vcursor.el: Some support for character terminals provided.
	Various functions are smarter about using the correct windows
	and the appropriate keymaps.
	(vcursor-string): New variable, shows vcursor on dumb terminals.
	(vcursor-map): New variable, holds keymap for vcursor commands.
	(vcursor-use-vcursor-map): New variable, non-nil if vcursor
	keys are overlaid onto main keymap.
	(vcursor-toggle-vcursor-map): New function to implement this.
	(vcursor-interpret-input): New variable, copy input as if typed.
	(vcursor-window-funcall): With list instead of symbol, now calls
	interactively.
	(vcursor-isearch-backward): New function to match forward isearch.

1998-03-03  Stephen Eglen  <stephen@gnu.org>

	* iswitchb.el (iswitchb-default-method): Redundant :tag entries
	removed.
	Doc fixes.

1998-03-03  Kenichi Handa  <handa@etl.go.jp>

	* dired.el (dired-get-filename): Don't call encode-coding-string
	if default-file-name-coding-system is non-nil.

	* files.el (insert-directory): Bind coding-system-for-write.
	Don't encode filename here because call-process encodes the
	arguments by coding-system-for-write.

1998-03-03  Richard Stallman  <rms@psilocin.gnu.org>

	* emacs-lisp/lisp-mode.el (lisp-interaction-mode-map)
	(emacs-lisp-mode-map, lisp-mode-map): Use set-keymap-parent.

1998-03-02  Sam Steingold  <sds@usa.net>

	* window.el (quit-window): New command.

1998-03-02  Richard Stallman  <rms@psilocin.gnu.org>

	* emacs-lisp/gulp.el (gulp-send-requests): Call sort properly.
	When showing the message, put point at beginning of buffer.

1998-03-02  Kenichi Handa  <handa@etl.go.jp>

	* files.el (insert-directory): Bind coding-system-for-read to
	file-name-coding-system or default-file-name-coding-system if
	enable-multibyte-characters is non-nil.

	* simple.el (quoted-insert): Allow direct insertion of codes in
	the range 0200..0237.  Use unibyte-char-to-multibyte for codes in
	the range 0240..0377.

	* subr.el (sref): Typo in doc-string fixed.

	* international/mule-cmds.el (set-default-coding-systems): Set
	default-file-name-coding-system.  Doc-string modified.
	(prefer-coding-system): Doc-string modified.

	* language/japan-util.el (setup-japanese-environment): Set
	default-file-name-coding-system to japanese-iso-8bit.

1998-03-02  Richard Stallman  <rms@psilocin.gnu.org>

	* emacs-lisp/easymenu.el (easy-menu-change):
	Handle case of no keywords.

	* ange-ftp.el (ange-ftp-call-chmod): Don't try to chmod file `--'.

1998-03-02  Dave Love  <fx@gnu.org>

	* winner.el ((require 'cl)): Revert to compile-time require.
	Eliminating pushnew previously had actually fixed the lossage.

1998-03-02  Richard Stallman  <rms@psilocin.gnu.org>

	* isearch.el (isearch-*-char): Do nothing special if quoted with \.

1998-03-01  Richard Stallman  <rms@psilocin.gnu.org>

	* generic.el: Provide generic, not generic-mode.
	Several doc fixes.

	* generic-x.el: New file.

	* add-log.el (change-log-font-lock-keywords): Recognize + in date.

1998-03-01  Peter Breton  <pbreton@ne.mediaone.net>

	* locate.el (locate-update): New function.
	(locate-current-line-number): Renamed from `current-line'.
	(locate-default-make-command-line): Use list, not cons.
	(locate): Added a `save-window-excursion' form.
	(locate): Used an `apply' form for the start-process call.
	(locate-mode): Now has a `revert-buffer-function'.
	(locate-do-setup): Now longer deletes window.
	(locate-header-face): Use underline, not region.
	(locate-update-command): New option.
	(locate-command): Changed from defvar to defcustom.
	(locate-make-command-line): Changed from defvar to defcustom.
	(locate-fcodes-file): Changed from defvar to defcustom.
	(locate-mouse-face): Changed from defvar to defcustom.

1998-02-28  Richard Stallman  <rms@psilocin.gnu.org>

	* subr.el (read-quoted-char): Doc fix.

1998-02-27  Richard Stallman  <rms@psilocin.gnu.org>

	* info.el (info): Always switch to buffer *info* even if
	current buffer is in Info mode.

	* comint.el (comint-arguments): Treat \" and such as part of one arg.

	* files.el (set-visited-file-name): Don't call backup-enable-predicate
	when buffer-file-name is nil.

	* progmodes/make-mode.el (make-mode): Provide make-mode, not makefile.

	* international/mule.el (load-with-code-conversion):
	Don't bind enable-multibyte-characters; instead,
	bind default-enable-multibyte-characters before creating buffer.
	(after-insert-file-set-buffer-file-coding-system):
	Use set-buffer-multibyte.
	Use add-hook to add this to after-insert-file-functions.

	* avoid.el (mouse-avoidance-kbd-command): Function deleted.
	(mouse-avoidance-fancy-hook, mouse-avoidance-exile-hook)
	(mouse-avoidance-banish-hook): Test whether last command
	was a mouse command of any kind.

1998-02-27  Karl Heuer  <kwzh@gnu.org>

	* dired-x.el (dired-do-toggle): Function moved to dired.el.
	* dired.el (dired-do-toggle): Moved here from dired-x.el.
	(dired-mode-map): Changed dired-do-toggle from "T" to "t".

1998-02-27  Carsten Dominik  <dominik@strw.LeidenUniv.nl>

	* textmodes/reftex.el: Remove debugging statements.

1998-02-27  Andre Spiegel  <spiegel@inf.fu-berlin.de>

	* vc-hooks.el, vc.el: Added version ids.

	* vc.el (vc-default-init-version): New variable.
	(vc-register): Use it.  Also use COMMENT argument.

1998-02-27  Dave Love  <fx@gnu.org>

	* international/iso-cvt.el (iso-spanish, iso-german, iso-iso2tex)
	(iso-tex2iso, iso-gtex2iso, iso-iso2gtex, iso-iso2duden): Fix doc,
	interactive spec.

1998-02-27  Simon Marshall  <simon@gnu.org>

	* comint.el (comint-dynamic-complete-filename): Don't wrap up the value
	of directory-sep-char when calling comint-dynamic-complete-as-filename.
	(comint-dynamic-complete-as-filename, comint-exec-1):
	Use directory-sep-char rather than "/".

1998-02-25  Dave Love  <fx@gnu.org>

	* thingatpt.el (thing-at-point-url-at-point):
	Intuit ftp:// on `short' URLs.

1998-02-25  Richard Stallman  <rms@gnu.org>

	* mail/rmail.el (rmail-retry-failure): Don't insist on finding
	MIME delimiter again at end of bounce text.
	(mail-unsent-separator): Accept "Your message follows".

	* cus-edit.el (custom-file): New function.
	(custom-save-delete): Use it.
	(custom-save-all): Use it.

	* shell.el (shell-dirtrack-mode): Renamed from shell-dirtrack-toggle.
	(dirtrack-mode, shell-dirtrack-toggle): Defined as aliases.

1998-02-25  Carsten Dominik  <dominik@strw.LeidenUniv.nl>

	* textmodes/reftex.el (reftex-toc-mode, reftex-select-label-mode)
	(reftex-select-bib-mode): New major modes for RefTeX's special buffers.
	(reftex-offer-label-menu): Put selection buffer into
	`reftex-select-label-mode'.  Make selection buffer read-only.  Use
	`reftex-erase-buffer'.
	(reftex-do-citation): Put selection buffer into
	`reftex-select-bib-mode'.  Make selection buffer read-only.  Use
	`reftex-erase-buffer'.  Set `reftex-select-return-marker'.
	(reftex-toc): Put *toc* buffer into reftex-toc-mode.  Add
	mouse-face property.
	(reftex-select-item): Use recursive edit instead of selfmade
	command loop.  Removed unnecessary local bindings.  Changed the
	tag for catch, to avoid problems with `exit' tag in
	recursive-edit.  Moved the code around old command loop to pre-
	and post-command-hook.
	(reftex-select-pre-command-hook, reftex-select-post-command-hook)
	(reftex-select-show-insertion-point): New functions.
	(reftex-reference): Set `reftex-select-return-marker'.
	(reftex-check-recursive-edit): Error message changed.
	(reftex-select-search-minibuffer-map): Obsolete constant removed.
	(reftex-select-next, reftex-select-previous, reftex-select-scroll-up)
	(reftex-select-scroll-down, reftex-select-next-heading)
	(reftex-select-previous-heading): Handle prefix arguments.
	(reftex-toc, reftex-make-and-insert-label-list)
	(reftex-insert-bib-matches): Add mouse-face property.
	(reftex-highlight-selection): New option.
	(reftex-select-mouse-accept): New command.
	(reftex-select-recursive-edit, reftex-select-search-forward)
	(reftex-select-search-backward, reftex-select-search)
	(reftex-select-scroll-up, reftex-select-scroll-down)
	(reftex-scroll-other-window, reftex-scroll-other-window-down)
	(reftex-empty-toc-buffer): Removed obsolete functions.
	(reftex-highlight-overlays): Removed obsolete 3rd overlay.
	(reftex-select-label-map, reftex-select-bib-map): Removed obsolete
	bindings, added mouse bindings, `digit-argument',
	`negative-argument', `reftex-select-show-insertion-point'.
	(reftex-erase-buffer): BUFFER now defaults to current buffer.
	(reftex-label-alist-builtin): Added sidecap packages support.
	(reftex-last-follow-point, reftex-select-return-marker): New variables.
	(reftex-toc, reftex-select-item): Set `reftex-last-follow-point'.
	(reftex-toc-post-command-hook): Use `reftex-last-follow-point'.
	(reftex-get-file-buffer-force): Turn off `enable-local-variables'
	when reading a file literally.

1998-02-25  Per Starbäck  <starback@strindberg.ling.uu.se>

	* play/doctor.el (mathlst): Fix typo.
	(shortlst): Avoid saying "Can you be", which confuses the doctor.

	* vc.el (vc-register): Update vc-buffer-backend.

1998-02-25  Ralph Schleicher  <rs@purple.UL.BaWue.DE>

	* info-look.el: Added support for the Emacs Lisp manual.
	(info-complete-file): Use default value if MODE is nil.
	(info-lookup-file-alist): Variable removed.

	* battery.el (battery-linux-proc-apm-regexp): Load percentage
	and remaining time have to match negative values.
	(battery-linux-proc-apm): Initialize void %-sequences.

1998-02-25  Aki Vehtari  <Aki.Vehtari@hut.fi>

	* tar-mode.el: Add "q" for quit, and use "C" for copy and "R" for
	rename as in dired.

1998-02-25  Dan Nicolaescu  <done@ece.arizona.edu>

	* winner.el (winner-mode-hook): Fix typo.
	(winner-mode-leave-hook): Use defcustom.  Fix typo.

1998-02-24  Dave Love  <fx@gnu.org>

	* winner.el: (require 'cl) unconditionally.
	(winner): defgroup.
	(winner-dont-bind-my-keys, winner-skip-buffers)
	(winner-skip-regexps, winner-mode, winner-mode-hook)
	(winner-mode-leave-hook): Customized.
	(winner-mode): Add autoload cookie.
	(winner-undo): Doc fix.

	* vc.el (vc-checkin-hook): Add :options.
	(vc-checkin, vc-comment-to-change-log): Doc fix.

	* compile.el (compilation-error-regexp-alist): Allow initial
	program name in first pattern.

1998-02-23  Stephen Eglen  <stephen@gnu.org>

	* textmodes/spell.el: Doc fix.

1998-02-22  Stephen Eglen  <stephen@gnu.org>

	* emacs-lisp/find-func.el: Customize.
	* emulation/crisp.el: Customize.
	* mail/mail-extr.el, mail/uce.el, mail/sendmail.el: Customize.
	* mail/uce.el: Customize.
	* progmodes/cperl-mode.el, progmodes/modula2.el: Customize.
	* progmodes/perl-mode.el, progmodes/simula.el: Customize.
	* progmodes/tcl-mode.el: Customize.
	* textmodes/bib-mode.el, textmodes/picture.el: Customize.
	* textmodes/refbib.el, textmodes/refer.el: Customize.
	* textmodes/scribe.el, textmodes/spell.el: Customize.

1998-02-21  Sam Steingold  <sds@usa.net>

	* emacs-lisp/cl-indent.el: Fix indentation rules for
	multiple-value-setf and multiple-value-list.

1998-02-21  Simon Marshall  <simon@gnu.org>

	* font-lock.el (font-lock-constant-face): Variable and face renamed
	from font-lock-reference-face.
	(font-lock-reference-face): Changed value to font-lock-constant-face.

	* add-log.el:
	* dired.el:
	* emacs-lisp/checkdoc.el:
	* help.el:
	* ielm.el:
	* mail/rmail.el:
	* mail/sendmail.el:
	* outline.el:
	* pascal.el:
	* play/decipher.el:
	* progmodes/ada-mode.el:
	* progmodes/awk-mode.el:
	* progmodes/cperl-mode.el:
	* progmodes/f90.el:
	* progmodes/fortran.el:
	* progmodes/icon.el:
	* progmodes/make-mode.el:
	* progmodes/meta-mode.el:
	* progmodes/modula2.el:
	* progmodes/octave-mod.el:
	* progmodes/perl-mode.el:
	* progmodes/scheme.el:
	* progmodes/simula.el:
	* ps-print.el:
	* textmodes/bibtex.el:
	* textmodes/reftex.el:
	* textmodes/texinfo.el: Updated accordingly.

1998-02-20  Kenichi Handa  <handa@etl.go.jp>

	* mail/rmail.el (rmail-decode-babyl-format): Message modified.
	(rmail): Comment for the binding of rmail-enable-multibyte added.

1998-02-19  Kenichi Handa  <handa@etl.go.jp>

	* international/mule.el
	(after-insert-file-set-buffer-file-coding-system): Call
	set-buffer-multibyte instead of directly setting
	enable-multibyte-characters to nil.

	* language/china-util.el (setup-chinese-cns-environment): Correct
	the setting of default-input-method.

	* international/mule-cmds.el (select-safe-coding-system): Kill the
	warning buffer before returning.

	* mail/rmail.el (rmail-enable-multibyte): New variable.
	(rmail): Bind coding-system-for-read to raw-text.  Set the buffer
	multibyte if necessary.
	(rmail-convert-file): Call rmail-decode-babyl-format only when we
	don't have to call rmail-convert-to-babyl-format.
	(rmail-decode-babyl-format): If rmail-file-coding-system is nil,
	detect it.
	(rmail-get-new-mail): Bind rmail-enable-multibyte locally.
	(rmail-convert-to-babyl-format): Check the value of
	rmail-enable-multibyte instead of enable-multibyte-characters.

	* subr.el (sref): Doc-string added.

1998-02-18  Simon Marshall  <simon@gnu.org>

	* font-lock.el (font-lock-keywords)
	(font-lock-syntactic-keywords): Doc fixes.

1998-02-17  Dave Love  <fx@gnu.org>

	* textmodes/sgml-mode.el (sgml-mode-common): Downcase key for
	assoc so upper-case markup works.
	(sgml-attributes, sgml-tag-help): Likewise.

1998-02-17  Richard Stallman  <rms@psilocin.gnu.org>

	* progmodes/cc-styles.el (c-copy-tree): New function.
	(c-initialize-builtin-style): Use c-copy-tree.

1998-02-16  Richard Stallman  <rms@psilocin.gnu.org>

	* info.el (Info-summary): Clear buffer-read-only.

1998-02-16  Ralph Schleicher  <rs@purple.UL.BaWue.DE>

	* info-look.el (info-complete): Rewrite minibuffer completion code.

	* info-look.el (info-lookup-minor-mode, turn-on-info-lookup):
	Added minor mode interface.
	(info-lookup-minor-mode-string): New variable.
	(info-lookup-minor-mode-map): New variable.

	* info-look.el: Provide a work-around if the custom library is
	not available.

	* info-look.el (info-lookup-other-window-flag)
	(info-lookup-highlight-face): Variables customized.

	* info-look.el (info-lookup-alist): No longer customizable.
	(info-lookup-add-help, info-lookup-maybe-add-help): Interface
	functions for adding new modes.
	(info-lookup-add-help*): New function.
	(info-lookup-symbol-alist, info-lookup-file-alist): Variables deleted.
	This info is specified now by calling info-lookup-maybe-add-help
	and info-lookup-add-help.

1998-02-16  Martin Stjernholm  <cc-mode-help@python.org>

	* progmodes/cc-align.el (c-lineup-close-paren)
	(c-indent-one-line-block): New indentation functions.

	* progmodes/cc-cmds.el (c-beginning-of-statement)
	(c-end-of-statement): Do not move by sentence in strings.

	* progmodes/cc-cmds.el (c-beginning-of-statement):
	Major rewrite.

	* progmodes/cc-engine.el (c-forward-syntactic-ws, c-backward-syntactic-ws):
	Don't narrow, just make a simple check against the given limit.

	(c-collect-line-comments): New function.

	(c-literal-limits): New function that finds the start and end pos
	of a comment or string surrounding point.

	(c-literal-limits-fast): A faster variant of `c-literal-limits'
	for newer Emacsen where the state returned from
	`parse-partial-sexp' contains the starting pos of the last
	literal.

1998-02-16  Barry A. Warsaw  <cc-mode-help@python.org>

	* progmodes/cc-mode.el (c-mode, c++-mode, objc-mode, java-mode): Set
	imenu-case-fold-search to nil.

	* progmodes/cc-langs.el (c-postprocess-file-styles): If a file
	style or file offsets are set, make the variables local to the
	buffer (via make-local-variable).

	* progmodes/cc-styles.el (c-make-styles-buffer-local): Take an optional
	argument which switches between make-variable-buffer-local and
	make-local-variable.  Generalize.

	* progmodes/cc-defs.el (c-point): In XEmacs, use scan-lists +
	buffer-syntactic-context-depth.

	* progmodes/cc-vars.el (c-enable-xemacs-performance-kludge-p): New
	variable.

	* progmodes/cc-cmds.el, progmodes/cc-engine.el (c-beginning-of-defun)
	(c-indent-defun, c-parse-state): Use (c-point 'bod) instead of
	beginning-of-defun directly.

	* progmodes/cc-align.el (c-semi&comma-no-newlines-before-nonblanks)
	(c-semi&comma-no-newlines-for-oneline-inliners): New functions.

	* progmodes/cc-engine.el (c-guess-basic-syntax): Fixed a few byte
	compiler warnings.

	* progmodes/cc-cmds.el (c-beginning-of-defun, c-end-of-defun):
	New commands.

	* progmodes/cc-engine.el (c-backward-to-start-of-do): Break infloop for
	invalid code, e.g. when someone types while (TRUE) { at the top of
	a buffer, we shouldn't hang when the { is typed!

	* progmodes/cc-cmds.el (c-beginning-of-statement): When moving
	forward by sentences, because we're either inside or at the start
	of a comment, be sure to limit movement to only within the extent
	of the comment.

	* progmodes/cc-langs.el (c-java-method-key): Variable deleted.

	* progmodes/cc-mode.el (java-mode): Set c-method-key to nil.  I
	don't think this is necessary for Java, and besides, the old value
	was inherited from Objective-C which was clearly not right.

	* progmodes/cc-cmds.el (c-electric-colon): Don't insert newlines
	before or after scope operators, regardless of the value of
	c-hanging-colons.

	* progmodes/cc-engine.el (c-backward-to-start-of-if): Ensure never
	move forward, not even if point < lim.

	* progmodes/cc-align.el (c-lineup-dont-change): New lineup
	function that leaves the current line's indentation unchanged.
	Used for the new cpp-macro-cont syntactic symbol.

	* progmodes/cc-cmds.el (c-electric-brace): namespace-open and
	namespace-close braces can hang.

	* progmodes/cc-defs.el (c-emacs-features): Added autoload cookie.

	* progmodes/cc-engine.el (c-search-uplist-for-classkey): When
	searching up for a class key, instead of hardcoding the extended
	search for "extern", use the new variable c-extra-toplevel-key,
	which is language dependent.  For C++, this variable includes the
	keyword "namespace" which will match C++ namespace introducing
	blocks.

	(c-guess-basic-syntax): Support for recognizing C++ namespace
	blocks, by elaborating on the mechanism used to find external
	language blocks.  Searches which hardcoded "extern" now use
	c-extra-toplevel-key, a language dependent variable.  Case clauses
	that were modified: CASE 5A.1, CASE 5A.4, CASE 5F, CASE 5I, CASE
	14A.

	CASE 3: we can now determine whether we're at the beginning of a
	cpp macro definition, or inside the middle of one.  Set syntax to
	'cpp-macro in the former case, 'cpp-macro-cont in the latter.  In
	both cases, the relpos is the beginning of the macro.

	(c-forward-syntactic-ws): Added code that skips forward over
	multi-line cpp macros.

	(c-beginning-of-macro): Moved, and made into a defsubst.  This
	function can now actually find the beginning of a multi-line C
	preprocessor macro.

	(c-backward-syntactic-ws): Use c-beginning-of-macro to skip
	backwards over multi-line macro definitions.

	(c-in-literal, c-fast-in-literal): Use c-beginning-of-macro to
	find out whether we're in a multi-line macro definition.

	* progmodes/cc-langs.el (c-C-extra-toplevel-key)
	(c-C++-extra-toplevel-key, c-extra-toplevel-key): New variables
	which parameterize the search for additional top-level enclosing
	constructs.

	* progmodes/cc-menus.el: Imenu support changed.

	* progmodes/cc-mode.el (c++-mode): Set c-extra-toplevel-key to
	c-C++-extra-toplevel-key.
	(c-initialize-on-load): New variable, *not* customized.

	* progmodes/cc-styles.el (c-offsets-alist): Three new syntactic
	symbols: innamespace, namespace-open, namespace-close.  These
	support C++ namespace blocks.
	Also, new syntactic symbol cpp-macro-cont, by default bound to
	c-lineup-dont-change.  This symbol is assigned to subsequent lines
	of a multi-line C preprocess macro definition.

	* progmodes/cc-vars.el (c-default-style): Start doc string with *.

	* progmodes/cc-engine.el (c-fast-in-literal): Function which
	should be faster than c-in-literal.  In XEmacs, this uses
	buffer-syntactic-context.

	* progmodes/cc-cmds.el (c-comment-line-break-function): When breaking a
	line-oriented comment, copy the comment leader from the previous
	line instead of hardcoding it to "// ".  This ensures that
	whitespace between the slashes and the text is preserved.

	* progmodes/cc-cmds.el (c-electric-pound, c-electric-brace)
	(c-electric-slash, c-electric-star, c-electric-semi&comma)
	(c-electric-colon, c-electric-lt-gt, c-scope-operator)
	(c-electric-backspace, c-electric-delete)
	(c-indent-command, c-indent-exp, c-indent-defun)
	(c-backslash-region, c-fill-paragraph): Add "*" to interactive spec.

	* progmodes/cc-cmds.el (c-fill-paragraph): regexp-quote the
	fill-prefix when search forward for the end of line oriented comments.
	(c-backslash-region): Do not preserve the zmacs region (XEmacs).

	* progmodes/cc-langs.el (c-mode-base-map):
	c-mark-function moved back to M-C-h.

	* progmodes/cc-styles.el (c-style-alist): "jdk" style given by Martin
	Buchholz <mrb@Eng.Sun.COM> for conformance with Sun's JDK style.

	* progmodes/cc-styles.el (c-set-style-2, c-initialize-builtin-style):
	Don't special case "cc-mode", it's a derived style.
	Fix setup of derived style "cc-mode".
	Introduce the new default style "user" which contains all user
	customizations.

	* progmodes/cc-vars.el (c-default-style): Renamed from
	c-site-default-style.

1998-02-15  Aki Vehtari  <Aki.Vehtari@hut.fi>

	* bibtex.el (bibtex-autokey-names): Change number tag to integer.

	* bibtex.el (bibtex-include-OPTkey): Add non-nil default :value
	for function, so that it can be selected.
	(bibtex-entry-format): Replace repeat with set.
	(bibtex-mode-hook): Change :type to 'hook.
	(bibtex-clean-entry-hook): Ditto.
	(bibtex-add-entry-hook): Ditto.
	(bibtex-autokey-before-presentation-hook): Change name to ->
	`bibtex-autokey-before-presentation-function' as it is not hook.
	(bibtex-autokey-get-namefield): Remove newlines unconditionally.

	* bibtex.el (bibtex-autokey): Fixed prefix.
	(bibtex-user-optional-fields): Better `:type'.
	(bibtex-autokey-names): Better `:type' and doc-fix.
	(bibtex-mark-active): New function, taking care of Emacs variants.
	(bibtex-run-with-idle-timer): Ditto.
	(bibtex-mode-map): Change `[(control tab)]' to `[(meta tab)]'.
	(bibtex-autokey-get-yearfield): Changed to accept year when year
	field has field-delimiters.  This is quick fix, there might
	be better solution.
	(bibtex-mode): Don't call idle timer with 0 seconds.
	(bibtex-mode): Call easy-menu-add.

1998-02-15  Dirk Herrmann  <D.Herrmann@tu-bs.de>

	* bibtex.el (bibtex-autokey-get-yearfield): Fixed problem with
	parsing the year field.

	* bibtex.el (bibtex-comment-start): Font locking for comments added.

	* bibtex.el (autokey-name-case-convert)
	(autokey-titleword-case-convert): Replace autokey-preserve-case, adding
	flexibility to case conversion of author names and titlewords.

	* bibtex.el (bibtex-autokey-get-titles): Non capitalized title words
	are used for key generation as well.
	(bibtex-member-of-regexp): Case is honored for matches now.
	(bibtex-autokey-titleword-ignore): Added entries provide compatibility
	to former behavior.

	* bibtex.el (bibtex-autokey-titleword-ignore): Title words found in
	this list are always ignored (previously only at the beginning of the
	title).  Replaces bibtex-autokey-titleword-first-ignore.

1998-02-15  Stephen Eglen  <stephen@gnu.org>

	* msb.el (msb--choose-file-menu): Prevent looping when examining
	ange-ftp directory paths.
	(msb-modes-key): New variable.
	(msb--mode-menu-cond, msb--aggregate-alist): New functions.
	(msb--split-menus): Check if msb-max-file-menu-items is nil.
	(msb--format-title): Remove extra / after ~.
	File customized.
	Redundant (function ...) forms around lambda functions removed.
	Update copyright year.

	* hexl.el (hexl-mode-exit): Remove hexl-follow-ascii-find
	from post-command-hook when leaving hexl-mode.

1998-02-14  Simon Marshall  <simon@gnu.org>

	* progmodes/sh-script.el (sh-font-lock-keywords):
	Fontify sh-style function names in declarations.

1998-02-13  Peter S Galbraith  <galbraith@mixing.qc.dfo.ca>

	* info-look.el (info-complete):
	Display completions on second invocation at same point
	or if initial guess is already ambiguous.
	(info-look-completion): New variable.

	* info-look.el (info-lookup-symbol-alist):
	Added support for latex-mode, perl-mode, awk-mode, emacs-lisp-mode.

1998-02-13  Richard Stallman  <rms@psilocin.gnu.org>

	* jka-compr.el (jka-compr-compression-info-list): Fix previous change:
	clear "append" flag for bzip.

1998-02-13  Richard Stallman  <rms@psilocin.ai.mit.edu>

	* disp-table.el (standard-display-european): If AUTO is nil,
	clear multibyte in *scratch*, and load latin-1.

1998-02-12  Dave Love  <fx@gnu.org>

	* progmodes/scheme.el (scheme-imenu-generic-expression): Simplify
	regexps.
	(dsssl-imenu-generic-expression): Likewise.
	(scheme-mode-variables): Set imenu-syntax-alist.
	(dsssl-mode): Remove `!' from font-lock-defaults.  Set
	imenu-syntax-alist.

1998-02-11  Richard Stallman  <rms@psilocin.gnu.org>

	* play/cookie1.el (cookie-snarf): Use match-beginning on the delimiter.
	(cookie-delimiter): Handle single-% delimiter.

	* progmodes/sh-script.el (sh-set-shell): Use standard-syntax-table
	if none other is specified.

	* emacs-lisp/debug.el (debugger-mode):
	Don't set enable-multibyte-characters here.
	(debug): Use set-buffer-multibyte to clear enable-multibyte-characters.

1998-02-10  Richard Stallman  <rms@psilocin.gnu.org>

	* msb.el (msb--choose-file-menu): Save some debugging info.

	* comint.el (comint-interrupt-subjob): Call comint-kill-input.
	(comint-kill-subjob, comint-quit-subjob, comint-stop-subjob): Likewise.

	* help.el (describe-bindings): Fix interactive spec.

1998-02-09  Dave Love  <d.love@dl.ac.uk>

	* compile.el (compilation-scroll-output): New variable.
	(compile-internal): Use it.  Set lazy-lock-defer-on-scrolling.

1998-02-09  Emilio Lopes  <Emilio.Lopes@Physik.TU-Muenchen.DE>

	* apropos.el (apropos-variable): New function.
	(apropos-command): Show functions instead of variables if given an
	argument.  The old functionality is now provided by
	`apropos-variable'.

1998-02-08  Richard Stallman  <rms@psilocin.gnu.org>

	* msb.el (msb--toggle-menu-type): Pass arg to menu-bar-update-buffers.
	(msb--init-file-alist): Delete spurious =.

	* emacs-lisp/byte-opt.el (byte-optimize-form-code-walker):
	Only call compiler-macroexpand if the function has
	a cl-compiler-macro property.

	* jka-compr.el (jka-compr-compression-info-list): Handle bzip.

1998-02-06  Per Starbäck  <starback@update.uu.se>

	* international/iso-transl.el (iso-transl-define-keys): Don't add
	nonascii-insert-offset to ASCII characters.

1998-02-06  Richard Stallman  <rms@psilocin.gnu.org>

	* textmodes/bibtex.el (bibtex-autokey-year-length): Doc fix.

	* mail/rmail.el (rmail-clear-headers): Handle the last header
	in a message correctly.

	* font-lock.el (font-lock-keywords): Doc fix.

1998-02-05  Richard Stallman  <rms@psilocin.gnu.org>

	* replace.el (occur): Apply default by hand after read-from-minibuffer.
	No need to clear text props from the result.
	(query-replace-read-args, map-query-replace-regexp):
	Offer the FROM arg as the default for the TO arg.

1998-02-04  Richard Stallman  <rms@psilocin.gnu.org>

	* emacs-lisp/bytecomp.el (byte-compile-output-as-comment):
	Use the size in bytes for the #@ size integer.

1998-02-04  Stephen Eglen  <stephen@mescaline.gnu.org>

	* locate.el: Customized.

1998-02-04  Dave Love  <fx@gnu.org>

	* vc-hooks.el (vc-ignore-vc-files): New variable.
	(vc-file-hook, vc-file-not-found-hook): Use it.

1998-02-04  Kenichi HANDA  <handa@etl.go.jp>

	* international/characters.el: Use aref instead of sref.

	* international/kinsoku.el: Use aref instead of sref.

	* international/mule-cmds.el (find-safe-coding-system): Return
	undecided if FROM == TO.
	(select-safe-coding-system): Doc-string modified.

	* international/mule-util.el (compose-chars-component): Return
	result as unibyte string.
	(decompose-composite-char): Doc-string modified.

	* international/titdic-cnv.el: Many codes re-written to adjust for
	character-base positioning and for speed up by using
	with-temp-file, with-temp-buffer, and princ.

	* language/china-util.el (encode-hz-region): Do not bind
	enable-multibyte-characters to nil locally.

	* language/devan-util.el: Do not require `cl'.
	(rule-intersection): New function.
	(string-conversion-by-rule): Use rule-intersection instead of
	intersection.
	(indian-to-devanagari-string): Use aref instead of sref.
	(devanagari-decompose-string): Likewise.

	* language/indian.el: Move codes which set syntax and category of
	Indian characters to international/characters.el.

	* progmodes/etags.el (etags): Fix defgroup syntax.

1998-02-03  Richard Stallman  <rms@psilocin.gnu.org>

	* imenu.el (imenu-generic-expression): Doc fix.
	(imenu--index-alist): Doc fix.
	(imenu-create-index-function): Doc fix.
	(imenu-prev-index-position-function): Doc fix.
	(imenu-extract-index-name-function): Doc fix.

	* emacs-lisp/edebug.el (edebug-stop-before-symbols): Variable deleted.
	(edebug-form): Don't handle edebug-stop-before-symbols.
	(edebug-submit-bug-report): Don't include edebug-stop-before-symbols.

	* avoid.el (mouse-avoidance-fancy-hook): Do nothing if button is down.
	(mouse-avoidance-exile-hook, mouse-avoidance-banish-hook): Likewise.

	* mail/mail-extr.el (mail-extr-all-letters-but-separators)
	(mail-extr-first-letters, mail-extr-last-letters):
	Make range start from \240, not from \200.

1998-02-02  Richard Stallman  <rms@psilocin.gnu.org>

	* textmodes/fill.el (fill-region-as-paragraph): Fix the test for any
	non-ASCII characters, for deciding whether to do kinsoku.

1998-02-02  Ed Reingold  <reingold@melange.gnu.org>

	* calendar/calendar.el (general-holidays): Fix misspelling.

1998-02-02  Dan Nicolaescu  <done@ece.arizona.edu>

	* progmodes/hideshow.el (hs-special-modes-alist): Enhanced java
	regexp.

1998-02-02  Richard Stallman  <rms@psilocin.gnu.org>

	* help.el (describe-bindings): New command (formerly in keymap.c).

	* mldrag.el (mldrag-drag-vertical-line): Fix criterion
	for the error for trying to move a scroll bar at the frame edge.

1998-02-01  Richard Stallman  <rms@psilocin.gnu.org>

	* emacs-lisp/easy-mmode.el (easy-mmode-define-minor-mode): Fix
	the doc strings used for the mode flag variable and the keymap.
	Delete duplicate &optional's.

	* emacs-lisp/edebug.el: Doc fixes.

	* emacs-lisp/bytecomp.el (byte-compile-from-buffer):
	Bind edebug-all-defs and edebug-all-forms to nil.

	* subr.el (suspend-hook, suspend-resume-hook): New defvars.

	* emacs-lisp/autoload.el (update-file-autoloads): Give clean errors
	if autoloads file is empty or can't be written.

1998-02-01  Dan Nicolaescu  <done@ece.arizona.edu>

	* hideshow.el (hs-special-modes-alist): Improved the regexp for java.

	* isearch.el (isearch-range-invisible): Avoid infinite loop when
	search-invisible is nil.

1998-02-01  Stephen Eglen  <stephen@melange.gnu.org>

	* autoinsert.el (auto-insert-mode): New function.
	(auto-insert-mode): New customize variable to automatically load
	the package.  Other variables customized.

	* tar-mode.el: Customized.

	* mail/mspools.el: Customized.  Doc fixes.

1998-01-31  Richard Stallman  <rms@sucrose.ai.mit.edu>

	* mail/mailalias.el (define-mail-alias):
	If FROM-MAILRC-FILE, don't call sendmail-sync-aliases.
	(build-mail-aliases): Clear mail-aliases to nil at the beginning.

1998-01-30  Richard Stallman  <rms@psilocin.gnu.org>

	* replace.el (query-replace-from-history-variable): New variable.
	(query-replace-to-history-variable): New variable.
	(query-replace-read-args): Use them.

1998-01-30  Dave Love  <d.love@dl.ac.uk>

	* fortran.el: Various docstring and commentary fixes, including
	note of current maintainer.
	(fortran-mode): Use imenu-syntax-alist.
	(fortran-imenu-generic-expression): Use
	fortran-continuation-string, not always `+'.
	(fortran-font-lock-keywords-1): Include symbol syntax as well as
	word, following syntax table changes.
	(fortran-imenu-generic-expression): Likewise.
	(fortran-mode-map): Add a menu.
	(fortran-mode-version, fortran-startup-message): Delete misleading
	variables.
	(fortran-mode): Don't use them.
	(fortran-column-ruler-fixed, fortran-column-ruler-tab): Fix
	leading \ which made `0' into null.
	(fortran-join-line): New function and key binding.
	(fortran-narrow-to-subprogram): New function and key binding.
	(fortran-mode-syntax-table): Make ?., ?_, ?$ symbol, not word.

1998-01-29  Carsten Dominik  <dominik@strw.LeidenUniv.nl>

	* textmodes/reftex.el (reftex-toc): Fixed bug with split-window.  Using
	split-window instead of split-window-vertically.
	(reftex-reset-mode): Removed obsolete buffer from kill list.
	(reftex-make-and-insert-label-list, reftex-do-citation): Delete
	other windows before displaying selection.
	(reftex-cite-format-builtin): Fixed bug in Chicago format.
	(reftex-enlarge-to-fit): New function.
	(reftex-nicify-text): Cut context-string at \item,\\.  Changed
	match sequence for efficiency reasons.
	(reftex-parse-from-file): Include files can be ignored with
	`reftex-no-include-regexps'.
	(reftex-no-include-regexps): New option.
	(reftex-do-parse): Initialize appendix flag.
	(reftex-parse-from-file): Interpret appendix.
	(reftex-section-info): Use changed version of reftex-section-number.
	(reftex-where-am-I): Interpret appendix match.
	(reftex-init-section-numbers): New arg: appendix.
	(reftex-section-number): Treat appendix enumeration.
	(reftex-toc-external): Improved message.
	(reftex-compute-ref-cite-tables): Regular expression extended for
	appendix.
	(reftex-toc-rescan): Renamed from reftex-toc-redo.
	(reftex-toc-Rescan): Renamed from reftex-toc-Redo.
	(reftex-toc-revert): New function.
	(reftex-select-external-document): Completion on label prefixes.
	(reftex-find-file-on-path): Added an extra call to
	expand-file-name for the directory.
	(reftex-locate-bibliography-files): Added expand-file-name call.
	(reftex-guess-label-type): New function.
	(reftex-word-before-point): Function removed.
	(reftex-reference): Uses reftex-guess-label-type.  Changed meaning
	of `~' in reference format.  Magic words are regular expressions.
	(reftex-compute-ref-cite-tables): Convert magic words to regexps.
	(reftex-select-label-maps): Default bindings for TAB, up, down, RET.
	(reftex-select-read-string): Now uses completion.
	(reftex-make-and-insert-label-list): Prepare for completion.
	(reftex-where-am-I): Fixed bug with input files.
	(reftex-save-all-document-buffers): New command.
	(reftex-select-next-heading): New function.
	(reftex-select-previous-heading): New function.
	(reftex-select-read-string): New function.
	(reftex-offer-label-menu): Handle string value from reftex-select-item.
	(reftex-reference): Fixed bug (missing save-excursion).
	(reftex-toc-map): Added binding for ?n and ?p.
	(reftex-do-citation): Changed to use reftex-default-bibliography.
	(reftex-default-bibliography): New option.
	(reftex-find-tex-file): Check for file-name-absolute-p first.
	(reftex-format-label-function, reftex-format-ref-function)
	(reftex-format-cite-function): New hooks.
	(reftex-info): New function.
	(reftex-compute-ref-cite-tables): Removed interactive form.
	(reftex-where-am-I): Removed interactive form.
	(reftex-format-names): Removed interactive form.
	(reftex-vref-is-default): New customization variable.
	(reftex-mode-menu): Capitalize citation options.
	(reftex-last-cnt): Variable removed.
	(reftex-last-data, reftex-last-line): New variables.
	(reftex-select-toggle-varioref): New function.
	(reftex-offer-label-menu): Changed mode-line-format for varioref.
	(reftex-select-label-help): Help string updated.
	(reftex-do-parse): Fixed bug with empty xr list.
	(reftex-view-crossref): Prefix argument interpretation changed.
	(reftex-get-offset): New function.
	(reftex-label): Remove selection buffer to force update.
	(reftex-access-scan-info): Remove selection buffers.
	(reftex-select-external-document): Fixed bug with highest index.
	(reftex-label-index-list, reftex-found-list): Variables removed.
	(reftex-offer-label-menu, reftex-make-and-insert-label-list)
	(reftex-select-item, reftex-citation, reftex-select-label-callback)
	(reftex-bibtex-selection-callback, reftex-select-callback): Changed
	to put the scan data directly into the text property :data,
	instead of doing this indirectly with an index-list.
	(reftex-make-selection-buffer-name): New function.
	(reftex-tie-multifile-symbols): Store master-index-as-property.
	(reftex-kill-buffer): New function.
	(reftex-erase-buffer): New function.
	(reftex-erase-all-selection-buffers): New function.
	(reftex-mode-menu): Button "Restore from file" no longer sensitive
	to existence of the file.  This had caused problems for LateX
	style files.  Quoted `:style' and `:selected' for compatibility.
	(reftex-access-parse-file): `Restore' action now throws an
	exception when the file is not found.
	(reftex-create-customize-menu): New function.
	(reftex-label): Fixed bug which made naked labels in \footnotes.
	(reftex-select-label-map, reftex-select-bib-map): New keymaps for
	the RefTeX Select buffer.
	(reftex-select-next, reftex-select-previous, reftex-select-scroll-down)
	(reftex-select-scroll-up, reftex-select-quit)
	(reftex-select-toggle-follow, reftex-select-callback)
	(reftex-select-accept, reftex-select-help)
	(reftex-select-recursive-edit, reftex-select-search-forward)
	(reftex-select-search-backward, reftex-select-search)
	(reftex-select-scroll-other-window)
	(reftex-select-scroll-other-window-down):
	New commands for use in the two new keymaps.
	(reftex-select-item): Now uses the appropriate keymaps.
	(reftex-toc-map): New keymap (a keymap for the toc buffer.
	(reftex-toc): Now uses reftex-toc-map.
	(reftex-fontify-select-label-buffer): New function.
	(reftex-select-font-lock-fontify-region): New function.
	(reftex-make-and-insert-label-list): Refontification now uses
	`reftex-select-font-lock-fontify-region'.
	(reftex-show-entry): Refontification generalized.
	(reftex-select-search-minibuffer-map): New constant.
	(reftex-parse-from-file): Look for \begin{thebibliography}.
	(reftex-do-citation): Check also for thebibliography.
	(reftex-bibtex-selection-callback): Handle bibitem.
	(reftex-view-crossref): Handle bibitem.
	(reftex-extract-bib-entries-from-thebibliography): New function.
	(reftex-format-bibitem): New function.
	(reftex-parse-bibitem): New function.
	(reftex-make-desparate-section-regexp): Changed name to
	reftex-make-desperate-section-regexp.
	(reftex-do-parse, reftex-locate-bibliography-files)
	(reftex-string-to-label, reftex-select-external-document)
	(reftex-find-duplicate-labels, reftex-format-bib-entry)
	(reftex-do-citation, reftex-insert-bib-matches)
	(reftex-select-search-minibuffer-map, reftex-access-search-path)
	(reftex-compute-ref-cite-tables, reftex-recursive-directory-list):
	All lambda expressions now quoted with `function'.
	(reftex-view-crossref, reftex-mouse-view-crossref): Fixed bug with
	multiple calls.
	(reftex-get-buffer-visiting): Error message changed.
	(reftex-select-external-document, reftex-query-label-type)
	(reftex-do-citation, reftex-select-help):
	Use `reftex-enlarge-to-fit' now.
	(reftex-pop-to-bibtex-entry): No longer beep on failure, to make
	it work better with follow mode.

1998-01-29  Inge Frick  <inge@nada.kth.se>

	* emacs-lisp/easymenu.el (easy-menu-add-item): Fix the BEFORE argument.
	Done by letting `easy-menu-do-add-item' handle it.
	(easy-menu-do-add-item): Take argument BEFORE instead of PREV.
	Inserts directly in keymap, instead of calling `define-key-after'.
	(easy-menu-create-menu): Don't reverse items as
	`easy-menu-do-add-item' now puts things at the end of keymaps.

1998-01-29  Stephen Eglen  <stephen@mescaline.gnu.org>

	* type-break.el (type-break-mode): New customize variable to
	automatically load the package.  Other variables customized.

1998-01-28  Dave Love  <d.love@dl.ac.uk>

	* progmodes/etags.el (find-tag-marker-ring-length): New variable.
	(find-tag-marker-ring): New variable.
	(tags-location-ring): New variable replacing tags-location-ring.
	(tags-location-stack): Deleted.
	(tags-table-format-hooks): Doc fix.
	(initialize-new-tags-table): Init find-tag-marker-ring,
	tags-location-ring.
	(tags-reset-tags-tables): Doc fix.  Set tags-location-ring,
	find-tag-marker-ring.
	(find-tag-noselect): Doc fix.  Use tags-location-ring,
	find-tag-marker-ring.
	(find-tag, find-tag-other-window, find-tag-other-frame)
	(find-tag-regexp): Doc fix.
	(pop-tag-mark): New function.
	(esc-map): Bind pop-tag-mark.

1998-01-28  Richard Stallman  <rms@psilocin.gnu.org>

	* mail/emacsbug.el (report-emacs-bug-address):
	Variable renamed from bug-gnu-emacs.  Use defcustom.
	(report-emacs-bug-pretest-address): Use defcustom.

	* international/mule-cmds.el (toggle-enable-multibyte-characters):
	Use set-buffer-multibyte.
	(find-safe-coding-system-list-subset-p): Renamed from list-subset-p.
	The call changed also.

1998-01-28  Kenichi Handa  <handa@etl.go.jp>

	* international/titdic-cnv.el (titdic-convert): Set
	enable-multibyte-characters to t after inserting TIT file by
	no-conversion.
	(tit-process-body): Do not bind enable-multibyte-characters to
	nil.

1998-01-27  Inge Frick  <inge@nada.kth.se>

	* emacs-lisp/easymenu.el (easy-menu-define): Use ` and , read-macros
	instead of (` and (,.  Implement :filter.  Doc fix.
	(easy-menu-do-define): Call `easy-menu-create-menu' instead of
	`easy-menu-create-keymaps'.
	(easy-menu-create-keymaps): Replaced by `easy-menu-create-menu'.
	(easy-menu-create-menu): New public function.  Replaces
	`easy-menu-create-keymaps', but with large changes.
	(easy-menu-button-prefix): New constant.
	(easy-menu-do-add-item, easy-menu-make-symbol): New functions.
	(easy-menu-update-button): Doc fix.
	(easy-menu-change): New optional argument BEFORE.
	Now just a call to `easy-menu-add-item'.
	(easy-menu-add-item, easy-menu-item-present-p)
	(easy-menu-remove-item): New public functions.
	(easy-menu-get-map, easy-menu-is-button-p, easy-menu-have-button-p)
	(easy-menu-real-binding, easy-menu-change-prefix, easy-menu-filter):
	New functions.

1998-01-26  Richard Stallman  <rms@psilocin.gnu.org>

	* mail/rmail.el (rmail): Reinsert the let-binding
	of enable-local-variables.

	* play/gametree.el: New file.

1998-01-26  Andreas Schwab  <schwab@gnu.org>

	* progmodes/ada-stmt.el: Customized.  Change `(load "skeleton")'
	to `(require 'skeleton)'.

	* progmodes/octave-mod.el, progmodes/octave-inf.el: Customized.
	* progmodes/meta-mode.el, progmodes/hideif.el: Likewise.
	* progmodes/dcl-mode.el, progmodes/asm-mode.el: Likewise.

1998-01-26  Richard Stallman  <rms@psilocin.gnu.org>

	* emacs-lisp/bytecomp.el: Customized.

	* emacs-lisp/bytecomp.el (displaying-byte-compile-warnings):
	To avoid error, use (forward-line -1), not previous-line.

	* emacs-lisp/byte-opt.el (byte-optimize-form-code-walker):
	Fix previous change.

	* emacs-lisp/byte-opt.el (byte-compile-inline-expand):
	Use string-as-unibyte, if it is defined.

1998-01-25  Richard Stallman  <rms@psilocin.gnu.org>

	* desktop.el (desktop-clear): Don't kill dead buffers.

	* progmodes/sh-script.el (sh-case): Fix paren error.

1998-01-25  Dave Love  <fx@gnu.org>

	* imenu.el (imenu-syntax-alist): New buffer-local variable.
	(imenu--generic-function): Use it.
	(imenu--split-menu): Don't (setcdr nil) with, say, empty functions
	list.

1998-01-24  Stephen Eglen  <stephen@delysid.gnu.org>

	* hscroll.el (hscroll-global-mode): New customize variable to
	automatically load the package.

	* icomplete.el: Customized.

1998-01-23  Richard Stallman  <rms@psilocin.gnu.org>

	* calendar/cal-french.el (calendar-french-single-byteify):
	Function deleted.
	(calendar-goto-french-date): Don't call calendar-french-single-byteify.
	Delete local var oldval.
	(calendar-print-french-date): Don't bind enable-multibyte-characters.

	* msb.el (msb--strip-dir): Use Emacs filename primitives, not regexps.

1998-01-22  Richard Stallman  <rms@psilocin.gnu.org>

	* mail/emacsbug.el (emacsbug): Customized.
	(report-emacs-bug-no-confirmation):
	Renamed from report-emacs-bug-run-tersely.
	(report-emacs-bug-no-explanations): New option.
	(report-emacs-bug): Handle that option.

1998-01-22  Eric Ludlam  <zappo@mescaline.gnu.org>

	* mail/rmail.el (rmail-speedbar-buttons): Added speedbar support
	for Rmail, including rmail-speedbar-button,
	rmail-speedbar-find-file, rmail-move-message-to-folder-on-line,
	rmail-speedbar-move-message, and support variables.

	* info.el (Info-speedbar-buttons): Added speedbar support for Info
	mode, including Info-speedbar-button, Info-speedbar-menu, and
	support variables.

	* gud.el (gud-speedbar-buttons): Added speedbar support for GUD in
	general, and for GDB specifically, including
	gud-gdb-goto-stackframe, gud-gdb-get-stackframe,
	gud-gdb-run-command-fetch-lines, gud-gdb-speedbar-stack-filter,
	and support variables.

	* emacs-lisp/checkdoc.el: New File.

	* speedbar.el, speedbspec.el: New files.

1998-01-22  Richard Stallman  <rms@psilocin.gnu.org>

	* vc.el (vc-annotate-compcar): Iterate instead of recursing.
	(vc-annotate-car-last-cons, vc-annotate-time-span):
	Rename arg assoc-list to a-list.

	* vc.el (vc-annotate-display): All support for XEmacs extents removed.
	Functions `set-face-*' are called only when a face is created.

	* arc-mode.el (archive-find-type): Accept d or s after digit, for lzh.
	(archive-rename-entry): Likewise.  Parse mode, uid and gid right.
	Allow newline in header.
	(archive-lzh-summarize): Fix paren error.  Use prname to set `files'.

1998-01-22  Andre Spiegel  <spiegel@inf.fu-berlin.de>

	* vc.el (vc-resynch-window): Behave properly when view-read-only
	is non-nil.

1998-01-21  Richard Stallman  <rms@psilocin.gnu.org>

	* emacs-lisp/cl-macs.el (define-compiler-macro): Handle empty arglist.

	* emacs-lisp/byte-opt.el (byte-optimize-form-code-walker):
	If compiler-macroexpand is defined, use it.

1998-01-21  Kenichi Handa  <handa@etl.go.jp>

	* international/mule-cmds.el (prefer-coding-system): Call
	update-iso-coding-systems.

	* international/mule-util.el (string-to-sequence): Adjusted for
	the change of multibyte-form handling (byte-base to char-base).
	(store-substring): Likewise.
	(truncate-string-to-width): Likewise.
	(decompose-region): Likewise.
	(decompose-string): Likewise.
	(decompose-composite-char): Call string instead of concat-chars.

	* international/quail.el (quail-show-kbd-layout): Bug fix for the
	case that TRANSLATION is a cons.

	* international/skkdic-cnv.el (skkdic-jbytes): Variable deleted.
	All codes using this variable adjusted.
	* international/skkdic-utl.el: Likewise.

	* loadup.el: Call update-iso-coding-systems after loading files
	under language subdir.

1998-01-21  Kenichi Handa  <handa@etl.go.jp>

	* international/characters.el: Put `prefered-coding-system'
	property to each character set.

	* international/mule.el (coding-system-base): Doc-string modified.
	(make-coding-system): The 6th optional arg is changed to
	PROPERTIES.
	(set-buffer-file-coding-system): Show "(default, nil)" in prompt.
	(set-coding-priority): Code tuned.

	* international/mule-cmds.el (set-language-info): Doc-string
	describes `coding-priority' KEY.
	(set-language-environment-coding-systems): New function.
	(list-subset-p): New function.
	(select-safe-coding-system): New function.
	(set-language-info): New optional args DESCRIBE-MAP and SETUP-MAP.
	(set-language-info-alist): New optional arg PARENTS.  Call
	set-language-info with appropriate DESCRIBE-MAP and SETUP-MAP args.
	(set-language-environment-coding-systems): New function.

	* international/mule-conf.el: Adjusted for the change of the
	format of make-coding-system's 6th argument.  Initialize
	coding-category-iso-7-tight to iso-2022-jp.

	* international/mule-diag.el (describe-coding-system): Change the
	format of showing safe charsets.

	* international/mule-util.el (find-safe-coding-system): Moved to
	mule-cmds.el.
	(detect-coding-with-priority): New macro.
	(detect-coding-with-language-environment): New function.

	* language/chinese.el: Remove setting up of
	describe-chinese-environment-map and
	setup-chinese-environment-map.  Exclude them in args of calls to
	set-language-info-alist.  Adjusted for the change of
	make-coding-system.  Register coding-priority key in
	language-info-alist.
	(iso-2022-cn-ext): New coding system.

	* language/cyrillic.el: Remove setting up of
	describe-cyrillic-environment-map and
	setup-cyrillic-environment-map.  Exclude them in args of calls to
	set-language-info-alist.  Adjusted for the change of
	make-coding-system.  Register coding-priority key in
	language-info-alist.

	* language/devanagari.el: Exclude describe-indian-environment-map
	and setup-indian-environment-map for args of call to
	set-language-info-alist.  Adjusted for the change of
	make-coding-system.  Register coding-priority key in
	language-info-alist.

	* language/english.el: Register coding-priority key in
	language-info-alist.

	* language/ethiopic.el: Register coding-priority key in
	language-info-alist.

	* language/european.el: Remove setting up of
	describe-european-environment-map and
	setup-european-environment-map.  Exclude them in args of calls to
	set-language-info-alist.  Adjusted for the change of
	make-coding-system.  Register coding-priority key in
	language-info-alist.  Add "German" language env.
	(setup-8-bit-environment): Delete CODING-SYSTEM arg.
	(iso-latin-1): Make it compatible with MIME-charset "iso-8859-1".
	(compound-text): New coding system.  `ctext' is now alias of it.
	(setup-german-environment): New function.

	* language/greek.el: Adjusted for the change of
	make-coding-system and setup-8-bit-environment.
	(setup-greek-environment): For Greek lang. env., change default
	input method to "greek-postfix".

	* language/hebrew.el: Adjusted for the change of
	make-coding-system and setup-8-bit-environment.

	* language/indian.el: Remove setting up of
	describe-indian-environment-map and setup-indian-environment-map.

	* language/japanese.el, language/korean.el, language/lao.el,
	* language/thai.el, language/tibetan.el, language/vietnamese.el:
	Adjusted for the change of make-coding-system.  Register
	coding-priority key in

	* language/china-util.el, language/japan-util.el,
	* language/korea-util.el, language/tibet-util.el,
	* language/viet-util.el: In setup-LANGUAGE-environment functions,
	call set-language-environment-coding-systems.

	* language/cyril-util.el, language/devan-util.el,
	* language/lao-util.el, language/thai-util.el: In
	setup-LANGUAGE-environment functions, adjust for the change of
	setup-8-bit-environment.

	* mail/sendmail.el (sendmail-coding-system): Doc-string modified.
	(sendmail-send-it): Select a safe coding system to encode an
	outgoing mail.

1998-01-21  Kenichi Handa  <handa@etl.go.jp>

	* international/ccl.el: Comment about CCL syntax modified.
	(ccl-command-table): Add read-multibyte-character,
	write-multibyte-character, and unify-character.
	(ccl-code-table): Add ex-cmd.
	(ccl-extended-code-table): New variable.
	(ccl-embed-extended-command): New function.
	(ccl-compile-read-multibyte-character)
	(ccl-compile-write-multibyte-character)
	(ccl-compile-unify-character, ccl-compile-iterate-multiple-map)
	(ccl-compile-translate-multiple-map)
	(ccl-compile-translate-single-map)
	(ccl-compile-multiple-map-function): New functions.
	(ccl-dump-ex-cmd, ccl-dump-read-multibyte-character)
	(ccl-dump-write-multibyte-character, ccl-dump-unify-character)
	(ccl-dump-unify-character-const-tbl, ccl-dump-iterate-multiple-map)
	(ccl-dump-translate-multiple-map, ccl-dump-translate-single-map):
	New functions.

	* international/mule.el (define-character-unification-table): New
	function.

	* international/mule-conf.el (oldjis-newjis-jisroman-ascii): New
	character unification table.
	(standard-character-unification-table-for-decode): Initialize to
	`unification-table' property of `oldjis-newjis-jisroman-ascii'.

1998-01-21  Erik Naggum  <erik@naggum.no>

	* complete.el (PC-try-load-many-files): Load files in reverse
	order so they come in the right order in the buffer list.

1998-01-20  Richard Stallman  <rms@psilocin.gnu.org>

	* mldrag.el (mldrag-drag-vertical-line): Delete debugging `message'.

	* emacs-lisp/tq.el (tq-filter): Use with-current-buffer.

	* ange-ftp.el (ange-ftp-date-regexp):
	Make l pattern match any non-ASCII char.

1998-01-19  Richard Stallman  <rms@psilocin.gnu.org>

	* menu-bar.el (menu-bar-file-menu): Add Recover Session menu item.
	(menu-bar-help-menu): Add Getting New Versions, Copying Conditions
	and (Non)Warranty menu items.

	* subr.el (momentary-string-display): Fix backward test
	for whether end of message is off the screen.

	* mouse.el (mouse-drag-vertical-line): Properly determine which
	side the scroll bar or vertical line is on.

	* mldrag.el (mldrag-drag-vertical-line): Delete debugging code.

1998-01-17  Richard Stallman  <rms@gnu.org>

	* progmodes/vhdl-mode.el: New file.

	* progmodes/etags.el (etags): Fix defgroup syntax.

	* simple.el (switch-to-completions): If no completions window,
	don't try to switch to it.

	* files.el (auto-mode-alist): Add vhdl-mode.

	* replace.el (occur): If the matching line has no final newline,
	insert one anyway.  Compensate for that when inserting line nums.

	* buff-menu.el (Buffer-menu-mode-map): Bind e like f.

	* startup.el (command-line-1): Add alternate startup message
	for use when there is a mouse.

1998-01-17  Karl Heuer  <kwzh@gnu.org>

	* register.el (number-to-register, increment-register): Args
	renamed to match doc.

1998-01-17  Dave Love  <d.love@dl.ac.uk>

	* vc.el (vc-finish-logentry): Move killing the log buffer after
	the operation in case that fails.

1998-01-17  Stephen Eglen  <stephen@cns.ed.ac.uk>

	* hexl.el (hexl-follow-ascii): New function and variable to
	highlight the ASCII character corresponding to point.

1998-01-16  Richard Stallman  <rms@sucrose.gnu.org>

	* mail/rmail.el (rmail): Don't bind enable-multibyte-characters;
	read the file normally.
	(rmail-revert): Likewise.

1998-01-16  Richard Stallman  <rms@psilocin.gnu.org>

	* mldrag.el (mldrag-drag-vertical-line): Handle left-side scroll bars.

	* info-look.el (info-lookup): Report if Info-goto-node fails.
	(info-lookup-make-completions): Likewise.

	* autorevert.el (global-auto-revert-ignore-buffer): Fix typo.
	(global-auto-revert-mode): Fix typo.

	* ange-ftp.el (ange-ftp-inodes-hashtable): New variable.
	(ange-ftp-next-inode-number): New variable.
	(ange-ftp-file-attributes): Assign each file a unique "inode number".

1998-01-15  Richard Stallman  <rms@sucrose.gnu.org>

	* progmodes/etags.el (etags): Fix defgroup syntax.

1998-01-15  Simon Marshall  <simon@gnu.org>

	* menu-bar.el: Add a Print submenu to the Tools menu.

	* font-lock.el (c++-font-lock-extra-types): Add some container classes.
	(c-font-lock-keywords-1): Use builtin face for preprocessor directives.

1998-01-12  Richard Stallman  <rms@sucrose.gnu.org>

	* mail/rmail.el (rmail): Don't kill local enable-multibyte-characters.
	Don't bind coding-system-for-read.  Fix error message.

	* mail/rmail.el (rmail-make-in-reply-to-field):
	Make foo and bar patterns match all non-ASCII chars.

	* mail/rmail.el (rmail): Unwind-protect call to rmail-get-new-mail.

	* mail/rfc822.el (rfc822-snarf-word): Don't reject non-ASCII chars.
	(rfc822-snarf-subdomain): Likewise.
	(rfc822-addresses-1, rfc822-addresses): Likewise.

	* dired.el (dired-move-to-filename-regexp):
	Make l pattern match any non-ASCII char.

1998-01-12  Dave Love  <fx@gnu.org>

	* font-lock.el (lisp-font-lock-keywords-1): Add defmethod.

1998-01-12  Kenichi Handa  <handa@etl.go.jp>

	* bindings.el: Change "?\C-\ " to "?\C- " because "\ " is changed
	to standing for nothing in lread.c (read_escape).
	* calendar/calendar.el (calendar-mode-map): Likewise.
	* international/kkc.el (kkc-mode-map): Likewise.
	* international/quail.el (quail-translation-keymap): Likewise.

1998-01-11  Dave Love  <fx@gnu.org>

	* emacs-lisp/lisp-mnt.el (lm-get-package-name, lm-header)
	(lm-header-multiline, lm-summary, lm-version, lm-commentary):
	Return string without properties.
	(lm-get-header, lm-get-package-name, lm-crack-address)
	(lm-insert-at-column, lm-report-bug): Minor doc fixes.

1998-01-08  Eric Ludlam  <zappo@gnu.org>

	* emacs-lisp/checkdoc.el: New file.

1998-01-07  Andre Spiegel  <spiegel@inf.fu-berlin.de>

	* vc.el (vc-resynch-window): Behave properly when view-read-only
	is non-nil.

1998-01-07  Andreas Schwab  <schwab@gnu.org>

	* custom.el (defgroup): Doc fix.

	* cus-edit.el (custom-browse-visibility): Doc fix.

	* emacs-lisp/pp.el (pp-to-string): Greatly simplify by letting the
	Emacs printer do the (quote x) to 'x conversion.  Better handle
	the # print syntax in all its forms.

	* find-dired.el, filecache.el, expand.el, emerge.el: Customized.

1998-01-07  Eli Zaretskii  <eliz@delysid.gnu.org>

	* files.el (delete-auto-save-files): Say in the doc string that
	auto-save file will not be deleted if the buffer has unsaved
	changes.

1998-01-06  Eric Ludlam  <zappo@gnu.org>

	* speedbar.el, speedbspec.el: New files.

1998-01-04  Richard Stallman  <rms@psilocin.gnu.org>

	* subr.el (sref): Defined.

1998-01-03  Stephen Eglen  <stephen@cns.ed.ac.uk>

	* time.el (display-time-mode): New customize variable to
	automatically load the package.

1998-01-02  Richard Stallman  <rms@psilocin.gnu.org>

	* filecache.el (file-cache-minibuffer-complete): Accept a prefix arg.

	* bindings.el (minor-mode-overriding-map-alist):
	Call make-variable-buffer-local.

	* which-func.el (which-func-update): Fix paren error.

